#ifndef _JRMPCOMPOSER_H_
#define _JRMPCOMPOSER_H_

#include <ser/classdescription.h>

#define RMI_LOOKUP_HASH 4905912898345647071ULL 
#define RMIHOLDER_BOOLEAN_SETVALUE_SERIAL -3665804199014368530L
#define RMIHOLDER_INTEGER_SETVALUE_SERIAL 1360826667806852920L
#define RMIHOLDER_STRING_SETVALUE_SERIAL -6849794470754667710L

typedef struct rmiholder_stub_obj {
	OBJECTDESCPTR obj;
	int arg_index;
	struct rmiholder_stub_obj* next;
} RMIHOLDER_STUB_OBJ;
typedef RMIHOLDER_STUB_OBJ* RMIHOLDER_STUB_OBJ_PTR;

typedef struct service_comm {
	int stream_id;
	char* service_name;
	METHODDEFPTR method;
	char* source_addr;
	int source_port;
	char* url_path;
	char* url_nopath;
	int src_socket_id;
	RMIHOLDER_STUB_OBJ_PTR rmiholder_objs;
} SERVICE_COMM;
typedef SERVICE_COMM* SERVICE_COMM_PTR;

typedef struct service_comm_table {
	SERVICE_COMM services[100];
	int n_services;
} SERVICE_COMM_TABLE;

void service_comm_table_init(SERVICE_COMM_TABLE* table);
void service_comm_table_add_entry(SERVICE_COMM_TABLE* table, int stream_id);
int service_comm_table_contains_stream_id(SERVICE_COMM_TABLE table, int stream_id);

void service_comm_table_set_url_nopath(SERVICE_COMM_TABLE* table, int stream_id, char* url_nopath);
void service_comm_table_set_url_path(SERVICE_COMM_TABLE* table, int stream_id, char* url_path);
void service_comm_table_set_service_name(SERVICE_COMM_TABLE* table, int stream_id, char* service_name);
void service_comm_table_set_method(SERVICE_COMM_TABLE* table, int stream_id, METHODDEFPTR method);
void service_comm_table_set_source_addr(SERVICE_COMM_TABLE* table, int stream_id, char* source_addr);
void service_comm_table_set_source_port(SERVICE_COMM_TABLE* table, int stream_id, int source_port);
char* service_comm_table_get_service_name_by_stream_id(SERVICE_COMM_TABLE table, int stream_id);
METHODDEFPTR service_comm_table_get_methoddef_by_stream_id(SERVICE_COMM_TABLE table, int stream_id);
char* service_comm_table_get_url_path_by_stream_id(SERVICE_COMM_TABLE table, int stream_id);
char* service_comm_table_get_url_nopath_by_stream_id(SERVICE_COMM_TABLE table, int stream_id);
char* service_comm_table_get_source_addr_by_stream_id(SERVICE_COMM_TABLE table, int stream_id);
int service_comm_table_get_source_port_by_stream_id(SERVICE_COMM_TABLE table, int stream_id);
int service_comm_table_get_src_socket_id_by_stream_id(SERVICE_COMM_TABLE table, int stream_id);
void service_comm_table_set_src_socket_id(SERVICE_COMM_TABLE* table, int stream_id, int src_socket_id);
void service_comm_table_add_rmiholder_stub(SERVICE_COMM_TABLE* table, int stream_id, RMIHOLDER_STUB_OBJ_PTR obj);
RMIHOLDER_STUB_OBJ_PTR service_comm_table_get_rmiholder_objs_by_stream_id(SERVICE_COMM_TABLE table, int stream_id);

#endif //_JRMPCOMPOSER_H_

