#ifndef _SOAPCOMPOSER_H_
#define _SOAPCOMPOSER_H_

#include <stdio.h>

char *SOAP_ELEMENT_PREPRECESSOR ="<?xml version=\"1.0\" encoding=\"utf-8\"?>";
char *SOAP_ELEMENT_ENVELOPE_START ="<soapenv:Envelope xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">"; 
char *SOAP_ELEMENT_ENVELOPE_END = "</soapenv:Envelope>";
char *SOAP_ELEMENT_BODY_START = "<soapenv:Body>";
char *SOAP_ELEMENT_BODY_END = "</soapenv:Body>";

char *STR_TYPE_QUALIFIER = "xsi:type";

char *SOAP_ELEMENT_START = "<";
char *SOAP_ELEMENT_END = ">";
char *SOAP_ELEMENT_END_MARKER = "/";

char *SPACE = " ";
char *QUOTE = "\"";
char *EQUALITY = "=";

char* SOAP_HTTP_POST = "POST ";
char* SOAP_HTTP_HOST = "HOST: ";

#define STR_RESPONSE "Response"



#define SOAP_REQ 1
#define SOAP_RES 2


void SOAP_ComposeBodyElement(int bSoapType, char *data,METHODDEFPTR method_to_call);
void ComposerMethodStartTag(int bSoapType, char *data,char *methodName);
void ComposerMethodEndTag(int bSoapType, char *,char *);
void ComposeArgumentStartTag(char *data,char *argName,char *type);
void ComposeArgumentValue(char *data,char *Value);
void ComposeArgumentEndTag(char *data,char *argName);
void SOAP_ComposeHttpPOSTHeader(char* data, char* dest_url);
void SOAP_ComposeHttpHOSTHeader(char* data, char* dest_addr, int dest_port);
//void SOAP_ComposeHttpEndHeader(char* data);

void SOAP_AdjustMethodStartTagLength(int *,char *);
void SOAP_AdjustMethodEndTagLength(int *,char *);
void SOAP_AdjustArgumentStartTagLength(int *iSize,char *argName,char *type);
void SOAP_AdjustArgumentValueLength(int *iSize,char *Value);
void SOAP_AdjustArgumentEndTagLength(int *iSize,char *argName);
void SOAP_AdjustHttpPOSTHeaderLength(int *iSize, char* dest_url);
void SOAP_AdjustHttpHOSTHeaderLength(int *iSize, char* dest_addr, int dest_port);
//void SOAP_AdjustHttpEndHeaderLength(int *iSize);


void SOAP_ComposeHttpResultHeader(char* data, char* resultStr);
void SOAP_AdjustHttpResultHeaderLength(int *iHeaderSize, char* resultStr);
	
void SOAP_AdjustHttpEndHeaderLength(int bSoapType, int *iHeaderSize,int iContentLength,/*char *url,*/METHODDEFPTR method_to_call, SERVICEDEFPTR service_ptr);
void SOAP_ComposeHttpEndHeader(int bSoapType, char* data,int iContentLength,/*char *url,*/METHODDEFPTR method_to_call, SERVICEDEFPTR service_ptr);

#endif //_SOAPCOMPOSER_H_

