#ifndef _UPNPDEVICECOMPOSER_H_
#define _UPNPDEVICECOMPOSER_H_

#include "composer/composer.h"



typedef struct upnp_service_discover {
	int stream_id;
	char location_url_nopath[255];
	char location_url_path[255];
} UPNP_SERVICE_DISCOVER;
typedef UPNP_SERVICE_DISCOVER* UPNP_SERVICE_DISCOVER_PTR;


typedef struct upnp_service_discover_table {
	UPNP_SERVICE_DISCOVER services[100];
	int n_services;
} UPNP_SERVICE_DISCOVER_TABLE;

void upnp_service_discover_table_init(UPNP_SERVICE_DISCOVER_TABLE* table);
void upnp_service_discover_table_add_entry(UPNP_SERVICE_DISCOVER_TABLE* table, int stream_id, char* location_url_nopath, char* location_url_path);
int upnp_service_discover_table_contains_stream_id(UPNP_SERVICE_DISCOVER_TABLE table, int stream_id);

char* upnp_service_discover_table_get_location_url_path(UPNP_SERVICE_DISCOVER_TABLE table, int stream_id);
char* upnp_service_discover_table_get_location_url_nopath(UPNP_SERVICE_DISCOVER_TABLE table, int stream_id);

void upnp_service_discover_table_set_location_url_nopath(UPNP_SERVICE_DISCOVER_TABLE* table, int stream_id, char* location_url_nopath);
void upnp_service_discover_table_set_location_url_path(UPNP_SERVICE_DISCOVER_TABLE* table, int stream_id, char* location_url_path);

#endif //_UPNPCOMPOSER_H_
