#ifndef _WSDCOMPOSER_H_
#define _WSDCOMPOSER_H_

#include "composer/composer.h"
#include "protocol/wsdmsg.h"



typedef struct wsd_service_discover {
	int stream_id;
	int type; 
	WSDMSG_PTR wsdmsg;
	char* proxy_url;
} WSD_SERVICE_DISCOVER;
typedef WSD_SERVICE_DISCOVER* WSD_SERVICE_DISCOVER_PTR;


typedef struct wsd_service_discover_table {
	WSD_SERVICE_DISCOVER services[100];
	int n_services;
} WSD_SERVICE_DISCOVER_TABLE;

void wsd_service_discover_table_init(WSD_SERVICE_DISCOVER_TABLE* table);

void wsd_service_discover_table_add_entry(WSD_SERVICE_DISCOVER_TABLE* table, int stream_id, WSDMSG_PTR wsdmsg);
int wsd_service_discover_table_contains_stream_id(WSD_SERVICE_DISCOVER_TABLE table, int stream_id);

WSDMSG_PTR wsd_service_discover_table_get_wsdmsg_by_stream_id(WSD_SERVICE_DISCOVER_TABLE table, int stream_id);

char* wsd_service_discover_table_get_proxy_url(WSD_SERVICE_DISCOVER_TABLE table, int stream_id);
void wsd_service_discover_table_set_proxy_url(WSD_SERVICE_DISCOVER_TABLE* table, int stream_id, char* proxy_url);

#endif //_WSDCOMPOSER_H_
