/*
 * 
 *             Author  @Youssef Laarouchi : laarouchi_yous@yahoo.fr
 * 
 * 
 */

#ifndef PARSER_H_
#define PARSER_H_

#include "engine/graph.h"


typedef struct transition TRANSITION; 


typedef struct eventdef {
	EVENT * sdpevent;
	char * name;
} EVENTDEF;


typedef struct parseresult {
	GRAPH * graph;
	EVENTDEF * events;
	int nb_defined_events;
} PARSERESULT;




struct transition {
	char * filter;
	//char * action; 
	char * next_state;
	ACTION * Action;
	TRANSITION * next_transition;
};



typedef struct  {
	char * name;
	ACTION * entry;
	TRANSITION * transition;
} STATE;

void print(char * s);

char ** getBetweenTokens(char * unparsed_state, char token1, char token2);

//PARSERESULT * parse (FILE *fp, ACTION* actions);
PARSERESULT * parse (int fp, ACTION* actions);

ACTION * action_get_byname(ACTION* actions, char* function_name);

char* noBlanck(char* s);
//void parse (FILE *fp);


#endif /*PARSER_H_*/
