#ifndef _IO_H_
#define _IO_H_

#ifndef _JTYPE_H_
#include <io/jtype.h>
#endif
#ifndef _UTF8_H_
#include <io/utf8.h>
#endif


extern int parseBytes(int fd, j_byte *buf, int *len);
extern int parsejByte(int fd, j_byte *v);
extern int parsejShort(int fd, j_short *v);
extern int parsejInt(int fd, j_int *v);
extern int parsejLong(int fd, j_long *v);
extern j_byte parseCode(int fd);
extern char *toHexString(j_byte b);
extern j_byte peekCode(int fd);
extern char* parsejUTF8String(int fd);
extern j_short byte_array_to_short(uint8* b,int pos);
extern UTF8_PTR stringToUTF8(const char* str);
extern char* utf8ToString(UTF8_PTR utf8);
int writejByte(int fd,j_byte b);


int writeBytes(int fd, j_byte* buff, size_t length);
int writejShort(int fd,j_short sh);
int writejByte(int fd,j_byte b);
int writejInt(int fd,j_int ji);
int writejUtf8(int fd, UTF8_PTR utf8);
int writejLong(int fd, j_long jl);



char* parsejUTF8String(int fd);
UTF8_PTR stringToUTF8(const char* str);
char* parsejUTF8String_charPtr(char** stream);
char* utf8ToString(UTF8_PTR utf8);

#endif //_IO_H_
