#ifndef TOOLS_H_
#define TOOLS_H_ 

#include <stdio.h>
#include <unistd.h>
#include <netdb.h>
#include <arpa/inet.h> 
#include "io/io.h"
#include "sha/sha.h"

#define MAX_LEN  65536 

static char* machine_ip_address;
static int machine_ip_address_set = 0;

static char* httpserver_path;


char *get_host_ip();
void set_host_ip();

void parseURL_host_port(char *url_input, char **ip, int *port, char** url);
void parseURL_nopath_path(char *location, char **location_url_nopath, char** location_url_path);
int replace_dot_with_slash(char* input, char* output);
int replace_slash_with_dot(char* input, char* output);
int replace_slash_with_$(char* input, char* output);

char* ExtractHeaderField(char *Header, char *field_name);
char* ExtractHTTPDirective(char *Header, char *directive_name);

int get_httpserver_port();
char* get_httpserver_path();
char* set_httpserver_path(char*);
int get_soapproxy_port();
int get_rmiregistry_port();
char* get_httpserver_urlpath();

j_long calc_method_hash(char* hash_method_name);

#endif /*TOOLS_H_*/
