#ifndef _SLP_H_
#define _SLP_H_

enum slp_msg_type {
	

	
	//Msg Type
	SrvRqst        = 1,
    SrvRply        = 2,
    SrvReg         = 3,
    SrvDeReg       = 4,
    SrvAck         = 5,
    AttrRqst       = 6,
    AttrRply       = 7,
    DAAdvert       = 8,
    SrvTypeRqst    = 9,
    SrvTypeRply    = 10,
    SAAdvert       = 11
};
      
enum slp_error_code {
    //Error Code
    OK                           = 0,
    LANGUAGE_NOT_SUPPORTED       = 1,
    PARSE_ERROR                  = 2,
    INVALID_REGISTRATION         = 3,
    SCOPE_NOT_SUPPORTED          = 4,
    AUTHENTICATION_UNKNOWN       = 5,
    AUTHENTICATION_ABSENT        = 6,
    AUTHENTICATION_FAILED        = 7,
    VER_NOT_SUPPORTED            = 9,
    INTERNAL_ERROR               = 10,
    DA_BUSY_NOW                  = 11,
    OPTION_NOT_UNDERSTOOD        = 12,
    INVALID_UPDATE               = 13,
    MSG_NOT_SUPPORTED            = 14,
    REFRESH_REJECTED             = 15
 };
 
 
    //The four defined flags in SLP message common header
#define   oflow_flag     = 0x8000
#define    fresh_flag     = 0x4000
#define    mcast_flag     = 0x2000
#define    normal_flag    = 0x0000
    
    
#define    	slp_version		 2
#define	SLP_HEADER_LENGTH     12   // not include language tag
    
#define	PORT 			427
#define	MULTICAST_ADDRESS 	"239.255.255.253"


#endif // _SLP_H_
