#ifndef _SLPMSG_H_

#define _SLPMSG_H_

typedef struct slp_msg {		
	int msg_version;
	int function_id;
	int length;
	char* xid;
	int error_code;
	int remote_port;
	char* lang_tag;
	char* scope_list;
	char* pr_list;
	char* service_type;
	char* predicate;
	char* url_list;
	int n_url_entries;
	char** url_entries;
	
	char* src_addr;
	int src_port;
	char* dest_addr;
	int dest_port;
} SLPMSG;
typedef SLPMSG* SLPMSG_PTR;

SLPMSG_PTR slpmsg_create();
int slpmsg_set_version(SLPMSG_PTR msg, int msg_version);
int slpmsg_set_function_id(SLPMSG_PTR msg, int function_id);
int slpmsg_set_length(SLPMSG_PTR msg, int length);
int slpmsg_set_xid(SLPMSG_PTR msg, char* xid);
int slpmsg_set_error_code(SLPMSG_PTR msg, int error_code);
int slpmsg_set_lang_tag(SLPMSG_PTR msg, char* lang_tag);
int slpmsg_set_scope_list(SLPMSG_PTR msg, char* scope_list);
int slpmsg_set_pr_list(SLPMSG_PTR msg, char* pr_list);
int slpmsg_set_service_type(SLPMSG_PTR msg, char* service_type);
int slpmsg_set_predicate(SLPMSG_PTR msg, char* predicate);
int slpmsg_set_url_list(SLPMSG_PTR msg, char* url_list);
int slpmsg_set_src_addr(SLPMSG_PTR msg, char* src_addr);
int slpmsg_set_src_port(SLPMSG_PTR msg, int src_port);
int slpmsg_set_dest_addr(SLPMSG_PTR msg, char* dest_addr);
int slpmsg_set_dest_port(SLPMSG_PTR msg, int dest_port);

int slpmsg_get_version(SLPMSG_PTR msg);
int slpmsg_get_function_id(SLPMSG_PTR msg);
int slpmsg_get_length(SLPMSG_PTR msg);
char* slpmsg_get_xid(SLPMSG_PTR msg);
int slpmsg_get_error_code(SLPMSG_PTR msg);
char* slpmsg_get_lang_tag(SLPMSG_PTR msg);
char* slpmsg_get_scope_list(SLPMSG_PTR msg);
char* slpmsg_get_pr_list(SLPMSG_PTR msg);
char* slpmsg_get_service_type(SLPMSG_PTR msg);
char* slpmsg_get_predicate(SLPMSG_PTR msg);
char* slpmsg_get_url_list(SLPMSG_PTR msg);
char* slpmsg_get_src_addr(SLPMSG_PTR msg);
int slpmsg_get_src_port(SLPMSG_PTR msg);
char* slpmsg_get_dest_addr(SLPMSG_PTR msg);
int slpmsg_get_dest_port(SLPMSG_PTR msg);

int slpmsg_set_n_url_entries(SLPMSG_PTR msg, int n_url_entries);
int slpmsg_get_n_url_entries(SLPMSG_PTR msg);
int slpmsg_set_url_entry(SLPMSG_PTR msg, int index_url_entry, char* url_entry);
char* slpmsg_get_url_entry(SLPMSG_PTR msg, int index_url_entry);

#endif //_SLPMSG_H_
