#ifndef _WSD_H_
#define _WSD_H_

#include "protocol/wsdmsg.h" 

#define TAG_START '<'
#define TAG_END '>'
#define SPACE ' '
#define QUESTIONMARK '?'
#define MARKUP_END_TAG "</"

#define FILE_PATH "/mnt/win/xml/probe.xml"

#define STR_HEADER "Header"
#define STR_BODY "Body"
#define STR_TO "To"
#define STR_MESSAGEID "MessageID"
#define STR_ACTION "Action"
#define STR_RELATESTO "RelatesTo"
#define STR_RELATIONSHIPTYPE "RelationshipType"
#define STR_APPSEQUENCE "AppSequence"
#define STR_REPLYTO "ReplyTo"
#define STR_INSTANCEID "InstanceId"
#define STR_MESSAGENUMBER "MessageNumber"
#define STR_ENDPOINTREFERENCE "EndpointReference"
#define STR_ADDRESS "Address"
#define STR_METADATAVERSION "MetadataVersion"
#define STR_XADDRS "XAddrs"
#define STR_PROBEMATCH "ProbeMatch"
#define STR_RESOLVEMATCH "ResolveMatch"

#define ACTION_HELLO "Hello"
#define ACTION_BYE "Bye"
#define ACTION_PROBE "Probe"
#define ACTION_PROBEMATCH "ProbeMatches"
#define ACTION_RESOLVE "Resolve"
#define ACTION_RESOLVEMATCH "ResolveMatches"

#define STR_TYPES "Types"
#define STR_SCOPES "Scopes"
#define STR_MATCHBY "MatchBy"

#define WSD_HELLO_MSG 		101
#define WSD_BYE_MSG 		102
#define WSD_PROBE_MSG 		103
#define WSD_PROBE_MATCH_MSG 	104
#define WSD_RESOLVE_MSG 	105
#define WSD_RESOLVE_MATCH_MSG 	106

#define TRUE 1
#define FALSE 0

void ComposeWSDiscovery();
void ComposeHeaderElement(WSDMSG_PTR ,int ,int ,int ,char *);
void ComposeActionElement(int ,char *);
void ComposeMessageIDElement(char *);
void ComposeTOElement(char *);
void ComposeAPPSEQElement(int ,char *);
void ComposeRelatesToElement(WSDMSG_PTR,int ,int ,char *);
void ComposeReplyToElement(int ,int ,char *);
void ComposeBodyElement(WSDMSG_PTR wsdmsg,int ,int ,int ,int ,char *);
void ComposeBodyMainStartElement(int, char *);
void ComposeBodyMainEndElement(int, char *);
void ComposeEndPointReferenceElement(int , char *);
void ComposeTypesElement(WSDMSG_PTR wsdmsg,int ,int , char *);
void ComposeScopesElement(WSDMSG_PTR wsdmsg,int ,int ,char *);
void ComposeXAddrsElement(WSDMSG_PTR wsdmsg,int ,int ,char *);
void ComposeMetaDataVersionElement(int ,char *);
void ComposeProbeMatchElement(WSDMSG_PTR ,int ,int ,int ,char *);
void ComposeResolveMatchElement(int ,int ,int ,char *);

void AdjustACTLength(int , int *);
void AdjustMSGIDLength(int *);
void AdjustTOLength(int *);
void AdjustAPPSEQLength(int , int *);
void AdjustRELATESTOLength(WSDMSG_PTR,int, int, int *);
void AdjustREPLYTOLength(int, int, int *);
void AdjustBodyMainStartElement(int, int *);
void AdjustBodyMainEndElement(int, int *);
void AdjustEndPointReferenceLength(int , int *);
void AdjustTypesLength(WSDMSG_PTR ,int ,int ,int *);
void AdjustScopesLength(WSDMSG_PTR ,int ,int ,int *);
void AdjustXAddrsLength(WSDMSG_PTR ,int ,int ,int *);
void AdjustMetaDataVersionLength(int ,int *);
void AdjustProbeMatchLength(WSDMSG_PTR wsdmsg,int ,int ,int ,int *);
void AdjustResolveMatchLength(int ,int ,int ,int *);

#endif
