#include "composer/composer.h"
#include "unit/unit.h"
#include "io/io.h"
#include <stdio.h>
#include "event/eventqueue_table.h"
#include <pthread.h>

#include "event/servicedef.h"

#include "composer/rmi_proxy.h"
#include "composer/proxy_composer.h"
#include "monitor/tools.h"





void method(char* str)
{
	char* ptr1;
	char* ptr2;
	char* ptr3;
	char* tmp1;
	char* tmp2;
	
	int nb;
	
	ptr1=strchr(str,'(');
	ptr2=strchr(str,')');
	nb=ptr2-ptr1;
	tmp1=malloc(sizeof(char)*nb-1);
	strncpy(tmp1,ptr1+1,nb-1);
	tmp1[nb]='\0';
	do
	{
		ptr1=strchr(tmp1,';');
		nb=ptr1-tmp1;
		tmp2=malloc(sizeof(char)*nb);
		strncpy(tmp2,tmp1,nb);
		tmp2[nb]='\0';
		tmp1+=nb+1;
	}while(ptr1!=NULL);
}

int proxy_finalize(JCLASS_PTR cls)
{
	FIELD_PTR clinit = class_get_method(cls,ACC_STATIC,"<clinit>","()V");
	if (clinit == NULL)
		clinit = class_add_method(cls,ACC_STATIC,"<clinit>","()V");
	ATTR_PTR  attr1 = field_get_attribute(clinit,CODE);
	if (attr1 == NULL)
		attr1 = field_add_attribute(clinit,CODE);
	
	code_add_single_instr(attr1,OP_RETURN);
}




/*
 * signature: is the argement class type (e.g., Ljava/lang/String)
 * return: the name for the variable of type class that contains the class of type "signature"
 * 			(e.g., class$java$lang$String )
 */
char* get_classname_from_argsignature(char* signature)
{
	char class_name_tmp[255];
	// final class name is 4 chars longer than signature
	char* class_name = malloc(strlen(signature)+4+1);
	strcpy(class_name, "class$");
	// replace "/" with  "." 
	// remove "L" from begin of the class name
	replace_slash_with_$(signature+1, class_name_tmp);
	// remove  ";" from the end of the class name
	class_name_tmp[strlen(class_name_tmp)-1] = '\0';
	strcat(class_name, class_name_tmp);
	return class_name;
}

char* proxy_add_method1(JCLASS_PTR cls, char* complete_class_name, char* name, j_long hash_index, char* returntype, int nargs, char* args[])
{
	static ALREADY_INIT_REMOTEREF = 0;
	static ALREADY_CLASS_INIT = 0;
	static CLASS_INIT_STATIC_index = 0;
	
	int nbarg = nargs;
	int i=0;
	
/*	
	size_t len;
	char *retbuf;
	va_list argp;
	char *p;
	int nbarg=0;
	int i=0;
	
	if(name == NULL)
		return NULL;
	len = strlen(returntype);
	va_start(argp, returntype);
	while((p = va_arg(argp, char *)) != NULL)
	{	
		len += strlen(p);
		nbarg++;	
	}
	va_end(argp);
	char** args=malloc(sizeof(char*)*nbarg);
	va_start(argp, returntype);
	while((p = va_arg(argp, char *)) != NULL)
	{	
		args[i++]=p;
	}
	va_end(argp);
*/

			

	char class0[255];
	//char class1[255];
	char label0[255];
	char label1[255];
	char method_name[255];
	sprintf(class0,"class$%d",CLASS_INIT_STATIC_index);
	//sprintf(class1,"class$%d",CLASS_INIT_STATIC_index+1);
	sprintf(label0,"l%d_0",CLASS_INIT_STATIC_index);
	sprintf(label1,"l%d_1",CLASS_INIT_STATIC_index);
	sprintf(method_name, "$method_%s_%d", name, CLASS_INIT_STATIC_index);
	CLASS_INIT_STATIC_index += 2; 
	
	//FIELD_PTR  f=class_add_field(cls,ACC_STATIC,"class$0","Ljava/lang/Class;");
	FIELD_PTR  f=class_add_field(cls, /*ACC_PRIVATE*/  ACC_STATIC, class0, "Ljava/lang/Class;");
	field_add_attribute(f,SYNTHETIC);
	//f=class_add_field(cls,ACC_STATIC,"class$1","Ljava/lang/Class;");
	//f=class_add_field(cls, /* ACC_PRIVATE| */ ACC_STATIC, class1, "Ljava/lang/Class;");
	//field_add_attribute(f,SYNTHETIC);	


	//WARNING FREE OLD LABELS
	//FIELD_PTR clinit = class_add_method(cls,ACC_STATIC,"<clinit>","()V");
	//ATTR_PTR  attr1 = field_add_attribute(clinit,CODE);
	//code_add_label(attr1,"l0");
	FIELD_PTR clinit = class_get_method(cls,ACC_STATIC,"<clinit>","()V");
	if (clinit == NULL)
		clinit = class_add_method(cls,ACC_STATIC,"<clinit>","()V");
	ATTR_PTR  attr1 = field_get_attribute(clinit,CODE);
	if (attr1 == NULL)
		attr1 = field_add_attribute(clinit,CODE);
	fprintf(stdout, "label0 is = %s\n",label0);
	code_add_label(attr1, label0);



	//proxy_code_get_class(attr1,"test.Echo","test/server/EchoServer_Stub","class$0","Ljava/lang/Class;");
	//proxy_code_get_class(attr1,"defaultPkg.tv","defaultPkg/tvImpl0_Stub","class$0","Ljava/lang/Class;");
	//proxy_code_get_class(attr1,"defaultPkg.helloservice" /*"defaultPkg.tv"*/,"defaultPkg/helloserviceImpl0_Stub" /*"defaultPkg/tvImpl0_Stub"*/,class0,"Ljava/lang/Class;");
	char* complete_class_name_with_dot = malloc(sizeof(char)*(strlen(complete_class_name)+1));
	replace_slash_with_dot(complete_class_name, complete_class_name_with_dot);
	proxy_code_get_class(attr1, complete_class_name_with_dot /*"defaultPkg.tv"*/, complete_class_name, class0, "Ljava/lang/Class;");
	
	
	//code_add_ldc(attr1,CONSTANT_String,"echo");
	code_add_ldc(attr1,CONSTANT_String, name);
	//code_add_single_instr(attr1,OP_ICONST_1); //Number of arguments
	code_add_single_instr(attr1, iconst[nbarg]); //Number of arguments
	code_add_type_instr(attr1,OP_ANEWARRAY,"java/lang/Class");
	
	fprintf(stdout, "\nproxy_add_method1.hash_index=%d ",hash_index);
	// define the Method and all its arguments
	int index_arg;
	for (index_arg=0; index_arg < nbarg; index_arg++)
	{
		
		fprintf(stdout, "\nproxy_add_method1.arg%d=%s", index_arg,args[index_arg]);
		
//		 repeat nbarg times 	: L objects;  //  instead of proxy_code_get_class for primitive types

		// index in the list of arguments: to be increased for each arguments 
		code_add_single_instr(attr1,OP_DUP);
		
		// index of the argument in the method call
		code_add_single_instr(attr1, /*OP_ICONST_0*/ iconst[index_arg] ); //java.lang.Class[0] iconst[i]
		
		//proxy_code_get_class(attr1,"java.lang.String","test/server/EchoServer_Stub","class$1","Ljava/lang/Class;");
		//proxy_code_get_class(attr1,"java.lang.String","defaultPkg/tvImpl0_Stub","class$1","Ljava/lang/Class;");
		
		if (args[index_arg][0] == 'L')
		{
			char class_name[255];
			// replace "/" with  "." 
			// remove "L" from begin of the class name
			replace_slash_with_dot(args[index_arg]+1, class_name);
			// remove  ";" from the end of the class name
			class_name[strlen(class_name)-1] = '\0';
			
			
			char* class_variable = get_classname_from_argsignature(args[index_arg]);
			
			if (class_get_field(cls, ACC_STATIC, class_variable, "Ljava/lang/Class;") == NULL)
			{
				FIELD_PTR class_variable_field = class_add_field(cls, ACC_STATIC, class_variable, "Ljava/lang/Class;");
				field_add_attribute(class_variable_field, SYNTHETIC);	
			}
			
			//proxy_code_get_class(attr1,"java.lang.String","defaultPkg/tvImpl0_Stub",class1,"Ljava/lang/Class;");
			//proxy_code_get_class(attr1, class_name, "defaultPkg/tvImpl0_Stub", class1, "Ljava/lang/Class;");
			proxy_code_get_class(attr1, class_name, complete_class_name /*"defaultPkg/helloserviceImpl0_Stub"*/ /*"defaultPkg/tvImpl0_Stub"*/, class_variable, "Ljava/lang/Class;");
			code_add_single_instr(attr1,OP_AASTORE);	
			
			
			fprintf(stdout, "\nproxy_add_method1. class_name=%s",class_name);
		}

		
		/*
		class_add_field(cls,  ACC_STATIC, "java/lang/Long.TYPE", "Ljava/lang/Class;");
		code_add_field_instr(attr1,OP_GETSTATIC,"defaultPkg/tvImpl0_Stub", "java/lang/Long.TYPE","Ljava/lang/Class;");
		code_add_single_instr(attr1,OP_AASTORE);
		code_add_single_instr(attr1,OP_DUP);
	*/	
	}

	


	
	
	
	code_add_method_instr(attr1,OP_INVOKEVIRTUAL,\
									"java/lang/Class",
									"getMethod",\
									"(Ljava/lang/String;[Ljava/lang/Class;)Ljava/lang/reflect/Method;");
	
	
	//code_add_field_instr(attr1,OP_PUTSTATIC,"test/server/EchoServer_Stub","$method_echo_0","Ljava/lang/reflect/Method;"); 	
	//code_add_field_instr(attr1,OP_PUTSTATIC,"defaultPkg/tvImpl0_Stub","$method_echo_0","Ljava/lang/reflect/Method;");
	code_add_field_instr(attr1,OP_PUTSTATIC,complete_class_name /*"defaultPkg/helloserviceImpl0_Stub"*/ /*"defaultPkg/tvImpl0_Stub"*/, method_name,"Ljava/lang/reflect/Method;");
	
	code_add_jump_instr_index(attr1,OP_GOTO,14); //Check 14
	//code_add_label(attr1,"l1");
	fprintf(stdout, "label1 is = %s\n",label1);
	code_add_label(attr1, label1);
	code_add_single_instr(attr1,OP_ASTORE_0);	
	code_add_type_instr(attr1,OP_NEW,"java/lang/NoSuchMethodError");
	code_add_single_instr(attr1,OP_DUP);
	code_add_ldc(attr1,CONSTANT_String,"stub class initialization failed"); 
	code_add_method_instr(attr1,OP_INVOKESPECIAL,\
						"java/lang/NoSuchMethodError",\
						"<init>",\
						"(Ljava/lang/String;)V"
						);
	code_add_single_instr(attr1,OP_ATHROW);
	
/* MUST BE THE LAST INSTRUCTUION OF <clinit>, so it must be >ADDED ONLY AFTER THE LAST METHOD ADDED TO <clinit>
	code_add_single_instr(attr1,OP_RETURN);
/**/	
	
	
	
	//code_add_try_catch(attr1,"l0","l1","l1","java/lang/NoSuchMethodException");
//	code_add_try_catch(attr1, label0, label1, label1,"java/lang/NoSuchMethodException");
	
	//code_set_max(attr1,7,1);
	// 
	code_set_max(attr1,7,10);
	
	//WARNING FREE OLD LABELS
if (!ALREADY_INIT_REMOTEREF) {
	
	ALREADY_INIT_REMOTEREF = 1;
	
	FIELD_PTR init=class_add_method(cls,ACC_PUBLIC,"<init>","(Ljava/rmi/server/RemoteRef;)V");
	ATTR_PTR  attr2=field_add_attribute(init,CODE);
	code_add_single_instr(attr2,OP_ALOAD_0);
	code_add_single_instr(attr2,OP_ALOAD_1);
	code_add_method_instr(attr2,OP_INVOKESPECIAL,\
						"java/rmi/server/RemoteStub",\
						"<init>",\
						"(Ljava/rmi/server/RemoteRef;)V"
						);
	code_add_single_instr(attr2,OP_RETURN);	
	
	//code_set_max(attr2,2,2);
	// maxlocals = 1 (arg of constructor)
	code_set_max(attr2,2,10);
}


	//class_add_field(cls,ACC_PRIVATE|ACC_STATIC,"$method_echo_0","Ljava/lang/reflect/Method;");
	class_add_field(cls, ACC_PRIVATE|ACC_STATIC, method_name,"Ljava/lang/reflect/Method;");

	
	//=>WARNING YOU MUST COMPUTE "Ljava/lang/String;etc...
	//FIELD_PTR meth0=class_add_method(cls,ACC_PUBLIC,name,"(Ljava/lang/String;)Ljava/lang/String;");
	
	
	// compute signature
	//if (strcmp(name, "SetPower") == 0 )
	//	meth0=class_add_method(cls,ACC_PUBLIC,name,"(Ljava/lang/String;)V"/*"(Ljava/lang/Boolean;Lrmiholders/IBooleanHolder;)I"*/);
	//else if (strcmp(name, "GetPower") == 0 )
	//	meth0=class_add_method(cls,ACC_PUBLIC,name,"(Ljava/lang/String;)V"/*"(Lrmiholders/IBooleanHolder;)I"*/);
	//else 
	//	meth0=class_add_method(cls,ACC_PUBLIC,name,"(Ljava/lang/String;)V");
	char signature[255] = "(";
	for (index_arg=0; index_arg < nbarg; index_arg++)
	{
		fprintf(stdout,"\n\nSIGNATURE %s: arg %d = %s\n\n",name, index_arg, args[index_arg]);
		strcat(signature, args[index_arg]);
	}
	strcat(signature,")");
	strcat(signature,returntype);
	FIELD_PTR meth0 = class_add_method(cls, ACC_PUBLIC, name, signature);
	
fprintf(stdout,"\n\nSIGNATURE %s = %s\n\n",name, signature);	
	
	
	ATTR_PTR  ex=field_add_attribute(meth0,EXCEPTIONS);	
	method_add_exceptions(ex,"java/rmi/RemoteException");
	ATTR_PTR  attr0=field_add_attribute(meth0,CODE);

	code_add_label(attr0,"l0");
	code_add_single_instr(attr0,OP_ALOAD_0);

	
	//code_add_field_instr(attr0,OP_GETFIELD,\
	//					"test/server/EchoServer_Stub",\
	//					"ref",\
	//					"Ljava/rmi/server/RemoteRef;"); 	
	code_add_field_instr(attr0,OP_GETFIELD,\
			complete_class_name,\
			/*"defaultPkg/helloserviceImpl0_Stub",\*/
			/*"defaultPkg/tvImpl0_Stub",\*/
			"ref",\
			"Ljava/rmi/server/RemoteRef;"); 	
	
	//Ref sur le proxy	
	code_add_single_instr(attr0,OP_ALOAD_0);
	//code_add_field_instr(attr0,OP_GETSTATIC,\
	//					"test/server/EchoServer_Stub",\
	//					"$method_echo_0",\
	//					"Ljava/lang/reflect/Method;");	 
	//code_add_field_instr(attr0,OP_GETSTATIC,\
	//		"defaultPkg/tvImpl0_Stub",\
	//		"$method_echo_0",\
	//		"Ljava/lang/reflect/Method;");
	code_add_field_instr(attr0,OP_GETSTATIC,\
			complete_class_name,\
			/*"defaultPkg/helloserviceImpl0_Stub",\
			/*"defaultPkg/tvImpl0_Stub",\*/
			method_name,\
			"Ljava/lang/reflect/Method;");
	
	
	
	code_add_single_instr(attr0,iconst[nbarg]);
	code_add_type_instr(attr0,OP_ANEWARRAY,"java/lang/Object");	
	for(i=0;i<nbarg;i++)
	{
		code_add_single_instr(attr0,OP_DUP);
		code_add_single_instr(attr0,iconst[i]);
		switch(args[i][0])
		{
			case 'L':
				code_add_single_instr(attr0,aload[i]+1); //index 0 reserved
				break;
			case 'I':
			{
				code_add_type_instr(attr0,OP_NEW,"java/lang/Integer");
				code_add_single_instr(attr0,OP_DUP);
				code_add_single_instr(attr0,iload[i]+1); //index0 reserved
				code_add_method_instr(attr0,OP_INVOKESPECIAL,\
						"java/lang/Integer",\
						"<init>",\
						"(I)V");
				break;
			}
			default:
				{
					
				}
		}
		code_add_single_instr(attr0,OP_AASTORE);
	}	

	//TODO calculate dynamically the hashcode !!!!
	//j_long hash=5525131960618330777ULL;
	j_long hash = hash_index;
	//WARNING hash do not exist anymore at the end of the method
	code_add_ldc(attr0,CONSTANT_Long,&hash);
	code_add_method_instr(attr0,OP_INVOKEINTERFACE,\
					"java/rmi/server/RemoteRef",\
					"invoke",\
					"(Ljava/rmi/Remote;Ljava/lang/reflect/Method;[Ljava/lang/Object;J)Ljava/lang/Object;");
	switch(returntype[0])
	{
		case 'L':
		{
			fprintf(stdout,"Return type=L. nbarg: %i\n",nbarg);
			code_add_single_instr(attr0,astore[nbarg+1]);
			code_add_single_instr(attr0,aload[nbarg+1]);
			code_add_label(attr0,"l1");
			code_add_type_instr(attr0,OP_CHECKCAST,"java/lang/String"); // to be modified for different object type
			code_add_single_instr(attr0,OP_ARETURN);
			break;
		}
		case 'I':		
		{
			fprintf(stdout,"Return type=I. nbarg: %i\n",nbarg);
			code_add_single_instr(attr0,astore[nbarg+1]);
			code_add_single_instr(attr0,aload[nbarg+1]);
			code_add_label(attr0,"l1");
			code_add_type_instr(attr0,OP_CHECKCAST,"java/lang/Integer");
			code_add_method_instr(attr0,OP_INVOKEVIRTUAL,\
									"java/lang/Integer",
									"intValue",\
									"()I");
			code_add_single_instr(attr0,OP_IRETURN);
			break;
		}
		case 'V':
		{
			fprintf(stdout,"Return type=V. nbarg: %i\n",nbarg);
			code_add_single_instr(attr0,OP_POP);
			code_add_single_instr(attr0,OP_RETURN);
			break;
		}
	}
	code_add_label(attr0,"l2");	
	code_add_single_instr(attr0,astore[nbarg+1]);
	code_add_label(attr0,"l3");
	code_add_single_instr(attr0,aload[nbarg+1]);
	code_add_single_instr(attr0,OP_ATHROW);
	code_add_label(attr0,"l4");
	code_add_single_instr(attr0,astore[nbarg+1]);
	code_add_label(attr0,"l5");
	code_add_single_instr(attr0,aload[nbarg+1]);
	code_add_single_instr(attr0,OP_ATHROW);
	code_add_label(attr0,"l6");
	code_add_single_instr(attr0,astore[nbarg+1]);
	code_add_label(attr0,"l7");
	code_add_type_instr(attr0,OP_NEW,"java/rmi/UnexpectedException");
	code_add_single_instr(attr0,OP_DUP);
	code_add_ldc(attr0,CONSTANT_String,"undeclared check exception"); //Check
	code_add_single_instr(attr0,aload[nbarg+1]);
	code_add_method_instr(attr0,OP_INVOKESPECIAL,\
						"java/rmi/UnexpectedException",\
						"<init>",\
						"(Ljava/lang/String;Ljava/lang/Exception;)V"
						);
	code_add_single_instr(attr0,OP_ATHROW);
	code_add_label(attr0,"l8");
	code_add_try_catch(attr0,"l0","l2","l2","java/lang/RuntimeException");
	code_add_try_catch(attr0,"l0","l2","l4","java/rmi/RemoteException");
	code_add_try_catch(attr0,"l0","l2","l6","java/lang/Exception");
	//code_set_max(attr0,7,3);
	
	// maxlocals == nbarg+1 of the method
	code_set_max(attr0, 17 , 10 /*nbarg+2*/);
}

/*
char* proxy_add_method1(JCLASS_PTR cls, char* name, j_long hash_index, char* returntype, ...)
{
	
	static ALREADY_INIT_REMOTEREF = 0;
	static ALREADY_CLASS_INIT = 0;
	static CLASS_INIT_STATIC_index = 0;
	
	size_t len;
	char *retbuf;
	va_list argp;
	char *p;
	int nbarg=0;
	int i=0;
	
	if(name == NULL)
		return NULL;
	len = strlen(returntype);
	va_start(argp, returntype);
	while((p = va_arg(argp, char *)) != NULL)
	{	
		len += strlen(p);
		nbarg++;	
	}
	va_end(argp);
	char** args=malloc(sizeof(char*)*nbarg);
	va_start(argp, returntype);
	while((p = va_arg(argp, char *)) != NULL)
	{	
		args[i++]=p;
	}
	va_end(argp);
	

			

	char class0[255];
	//char class1[255];
	char label0[255];
	char label1[255];
	char method_name[255];
	sprintf(class0,"class$%d",CLASS_INIT_STATIC_index);
	//sprintf(class1,"class$%d",CLASS_INIT_STATIC_index+1);
	sprintf(label0,"l%d_0",CLASS_INIT_STATIC_index);
	sprintf(label1,"l%d_1",CLASS_INIT_STATIC_index);
	sprintf(method_name, "$method_%s_%d", name, CLASS_INIT_STATIC_index);
	CLASS_INIT_STATIC_index += 2; 
	
	//FIELD_PTR  f=class_add_field(cls,ACC_STATIC,"class$0","Ljava/lang/Class;");
	FIELD_PTR  f=class_add_field(cls, ACC_STATIC, class0, "Ljava/lang/Class;");
	field_add_attribute(f,SYNTHETIC);
	//f=class_add_field(cls,ACC_STATIC,"class$1","Ljava/lang/Class;");
	//f=class_add_field(cls,  ACC_STATIC, class1, "Ljava/lang/Class;");
	//field_add_attribute(f,SYNTHETIC);	


	//WARNING FREE OLD LABELS
	//FIELD_PTR clinit = class_add_method(cls,ACC_STATIC,"<clinit>","()V");
	//ATTR_PTR  attr1 = field_add_attribute(clinit,CODE);
	//code_add_label(attr1,"l0");
	FIELD_PTR clinit = class_get_method(cls,ACC_STATIC,"<clinit>","()V");
	if (clinit == NULL)
		clinit = class_add_method(cls,ACC_STATIC,"<clinit>","()V");
	ATTR_PTR  attr1 = field_get_attribute(clinit,CODE);
	if (attr1 == NULL)
		attr1 = field_add_attribute(clinit,CODE);
	fprintf(stdout, "label0 is = %s\n",label0);
	code_add_label(attr1, label0);



	//proxy_code_get_class(attr1,"test.Echo","test/server/EchoServer_Stub","class$0","Ljava/lang/Class;");
	//proxy_code_get_class(attr1,"defaultPkg.tv","defaultPkg/tvImpl0_Stub","class$0","Ljava/lang/Class;");
	proxy_code_get_class(attr1,"defaultPkg.tv","defaultPkg/tvImpl0_Stub",class0,"Ljava/lang/Class;");
	
	//code_add_ldc(attr1,CONSTANT_String,"echo");
	code_add_ldc(attr1,CONSTANT_String, name);
	//code_add_single_instr(attr1,OP_ICONST_1); //Number of arguments
	code_add_single_instr(attr1, iconst[nbarg]); //Number of arguments
	code_add_type_instr(attr1,OP_ANEWARRAY,"java/lang/Class");
	
	
	// define the Method and all its arguments
	int index_arg;
	for (index_arg=0; index_arg < nbarg; index_arg++)
	{
//		 repeat nbarg times 	: L objects;  //  instead of proxy_code_get_class for primitive types

		// index in the list of arguments: to be increased for each arguments 
		code_add_single_instr(attr1,OP_DUP);
		
		// index of the argument in the method call
		code_add_single_instr(attr1,  iconst[index_arg] ); //java.lang.Class[0] iconst[i]
		
		//proxy_code_get_class(attr1,"java.lang.String","test/server/EchoServer_Stub","class$1","Ljava/lang/Class;");
		//proxy_code_get_class(attr1,"java.lang.String","defaultPkg/tvImpl0_Stub","class$1","Ljava/lang/Class;");
		
		if (args[index_arg][0] == 'L')
		{
			char class_name[255];
			// replace "/" with  "." 
			// remove "L" from begin of the class name
			replace_slash_with_dot(args[index_arg]+1, class_name);
			// remove  ";" from the end of the class name
			class_name[strlen(class_name)-1] = '\0';
			
			
			char* class_variable = get_classname_from_argsignature(args[index_arg]);
			
			if (class_get_field(cls, ACC_STATIC, class_variable, "Ljava/lang/Class;") == NULL)
			{
				FIELD_PTR class_variable_field = class_add_field(cls, ACC_STATIC, class_variable, "Ljava/lang/Class;");
				field_add_attribute(class_variable_field, SYNTHETIC);	
			}
			
			//proxy_code_get_class(attr1,"java.lang.String","defaultPkg/tvImpl0_Stub",class1,"Ljava/lang/Class;");
			//proxy_code_get_class(attr1, class_name, "defaultPkg/tvImpl0_Stub", class1, "Ljava/lang/Class;");
			proxy_code_get_class(attr1, class_name, "defaultPkg/tvImpl0_Stub", class_variable, "Ljava/lang/Class;");
			code_add_single_instr(attr1,OP_AASTORE);			
		}

		
		
		//class_add_field(cls,  ACC_STATIC, "java/lang/Long.TYPE", "Ljava/lang/Class;");
		//code_add_field_instr(attr1,OP_GETSTATIC,"defaultPkg/tvImpl0_Stub", "java/lang/Long.TYPE","Ljava/lang/Class;");
		//code_add_single_instr(attr1,OP_AASTORE);
		//code_add_single_instr(attr1,OP_DUP);
	
	}

	


	
	
	
	code_add_method_instr(attr1,OP_INVOKEVIRTUAL,\
									"java/lang/Class",
									"getMethod",\
									"(Ljava/lang/String;[Ljava/lang/Class;)Ljava/lang/reflect/Method;");
	
	
	//code_add_field_instr(attr1,OP_PUTSTATIC,"test/server/EchoServer_Stub","$method_echo_0","Ljava/lang/reflect/Method;"); 	
	//code_add_field_instr(attr1,OP_PUTSTATIC,"defaultPkg/tvImpl0_Stub","$method_echo_0","Ljava/lang/reflect/Method;");
	code_add_field_instr(attr1,OP_PUTSTATIC,"defaultPkg/tvImpl0_Stub", method_name,"Ljava/lang/reflect/Method;");
	
	code_add_jump_instr_index(attr1,OP_GOTO,14); //Check 14
	//code_add_label(attr1,"l1");
	fprintf(stdout, "label1 is = %s\n",label1);
	code_add_label(attr1, label1);
	code_add_single_instr(attr1,OP_ASTORE_0);	
	code_add_type_instr(attr1,OP_NEW,"java/lang/NoSuchMethodError");
	code_add_single_instr(attr1,OP_DUP);
	code_add_ldc(attr1,CONSTANT_String,"stub class initialization failed"); 
	code_add_method_instr(attr1,OP_INVOKESPECIAL,\
						"java/lang/NoSuchMethodError",\
						"<init>",\
						"(Ljava/lang/String;)V"
						);
	code_add_single_instr(attr1,OP_ATHROW);
	
// MUST BE THE LAST INSTRUCTUION OF <clinit>, so it must be >ADDED ONLY AFTER THE LAST METHOD ADDED TO <clinit>
//	code_add_single_instr(attr1,OP_RETURN);
	
	
	
	
	//code_add_try_catch(attr1,"l0","l1","l1","java/lang/NoSuchMethodException");
//	code_add_try_catch(attr1, label0, label1, label1,"java/lang/NoSuchMethodException");
	
	//code_set_max(attr1,7,1);
	// 
	code_set_max(attr1,7,10);
	
	//WARNING FREE OLD LABELS
if (!ALREADY_INIT_REMOTEREF) {
	
	ALREADY_INIT_REMOTEREF = 1;
	
	FIELD_PTR init=class_add_method(cls,ACC_PUBLIC,"<init>","(Ljava/rmi/server/RemoteRef;)V");
	ATTR_PTR  attr2=field_add_attribute(init,CODE);
	code_add_single_instr(attr2,OP_ALOAD_0);
	code_add_single_instr(attr2,OP_ALOAD_1);
	code_add_method_instr(attr2,OP_INVOKESPECIAL,\
						"java/rmi/server/RemoteStub",\
						"<init>",\
						"(Ljava/rmi/server/RemoteRef;)V"
						);
	code_add_single_instr(attr2,OP_RETURN);	
	
	//code_set_max(attr2,2,2);
	// maxlocals = 1 (arg of constructor)
	code_set_max(attr2,2,10);
}


	//class_add_field(cls,ACC_PRIVATE|ACC_STATIC,"$method_echo_0","Ljava/lang/reflect/Method;");
	class_add_field(cls, ACC_PRIVATE|ACC_STATIC, method_name,"Ljava/lang/reflect/Method;");

	
	//=>WARNING YOU MUST COMPUTE "Ljava/lang/String;etc...
	//FIELD_PTR meth0=class_add_method(cls,ACC_PUBLIC,name,"(Ljava/lang/String;)Ljava/lang/String;");
	
	
	// compute signature
	//if (strcmp(name, "SetPower") == 0 )
	//	meth0=class_add_method(cls,ACC_PUBLIC,name,"(Ljava/lang/String;)V");
	//else if (strcmp(name, "GetPower") == 0 )
	//	meth0=class_add_method(cls,ACC_PUBLIC,name,"(Ljava/lang/String;)V");
	//else 
	//	meth0=class_add_method(cls,ACC_PUBLIC,name,"(Ljava/lang/String;)V");
	char signature[255] = "(";
	for (index_arg=0; index_arg < nbarg; index_arg++)
	{
		strcat(signature, args[index_arg]);
	}
	strcat(signature,")");
	strcat(signature,returntype);
	FIELD_PTR meth0 = class_add_method(cls, ACC_PUBLIC, name, signature);
	
	
	
	ATTR_PTR  ex=field_add_attribute(meth0,EXCEPTIONS);	
	method_add_exceptions(ex,"java/rmi/RemoteException");
	ATTR_PTR  attr0=field_add_attribute(meth0,CODE);

	code_add_label(attr0,"l0");
	code_add_single_instr(attr0,OP_ALOAD_0);

	
	//code_add_field_instr(attr0,OP_GETFIELD,\
	//					"test/server/EchoServer_Stub",\
	//					"ref",\
	//					"Ljava/rmi/server/RemoteRef;"); 	
	code_add_field_instr(attr0,OP_GETFIELD,\
			"defaultPkg/tvImpl0_Stub",\
			"ref",\
			"Ljava/rmi/server/RemoteRef;"); 	
	
	//Ref sur le proxy	
	code_add_single_instr(attr0,OP_ALOAD_0);
	//code_add_field_instr(attr0,OP_GETSTATIC,\
	//					"test/server/EchoServer_Stub",\
	//					"$method_echo_0",\
	//					"Ljava/lang/reflect/Method;");	 
	//code_add_field_instr(attr0,OP_GETSTATIC,\
	//		"defaultPkg/tvImpl0_Stub",\
	//		"$method_echo_0",\
	//		"Ljava/lang/reflect/Method;");
	code_add_field_instr(attr0,OP_GETSTATIC,\
			"defaultPkg/tvImpl0_Stub",\
			method_name,\
			"Ljava/lang/reflect/Method;");
	
	
	
	code_add_single_instr(attr0,iconst[nbarg]);
	code_add_type_instr(attr0,OP_ANEWARRAY,"java/lang/Object");	
	for(i=0;i<nbarg;i++)
	{
		code_add_single_instr(attr0,OP_DUP);
		code_add_single_instr(attr0,iconst[i]);
		switch(args[i][0])
		{
			case 'L':
				code_add_single_instr(attr0,aload[i]+1); //index 0 reserved
				break;
			case 'I':
			{
				code_add_type_instr(attr0,OP_NEW,"java/lang/Integer");
				code_add_single_instr(attr0,OP_DUP);
				code_add_single_instr(attr0,iload[i]+1); //index0 reserved
				code_add_method_instr(attr0,OP_INVOKESPECIAL,\
						"java/lang/Integer",\
						"<init>",\
						"(I)V");
				break;
			}
			default:
				{
					
				}
		}
		code_add_single_instr(attr0,OP_AASTORE);
	}	

	//TODO calculate dynamically the hashcode !!!!
	//j_long hash=5525131960618330777ULL;
	j_long hash = hash_index;
	//WARNING hash do not exist anymore at the end of the method
	code_add_ldc(attr0,CONSTANT_Long,&hash);
	code_add_method_instr(attr0,OP_INVOKEINTERFACE,\
					"java/rmi/server/RemoteRef",\
					"invoke",\
					"(Ljava/rmi/Remote;Ljava/lang/reflect/Method;[Ljava/lang/Object;J)Ljava/lang/Object;");
	switch(returntype[0])
	{
		case 'L':
		{
			fprintf(stdout,"Return type=L. nbarg: %i\n",nbarg);
			code_add_single_instr(attr0,astore[nbarg+1]);
			code_add_single_instr(attr0,aload[nbarg+1]);
			code_add_label(attr0,"l1");
			code_add_type_instr(attr0,OP_CHECKCAST,"java/lang/String"); // to be modified for different object type
			code_add_single_instr(attr0,OP_ARETURN);
			break;
		}
		case 'I':		
		{
			fprintf(stdout,"Return type=I. nbarg: %i\n",nbarg);
			code_add_single_instr(attr0,astore[nbarg+1]);
			code_add_single_instr(attr0,aload[nbarg+1]);
			code_add_label(attr0,"l1");
			code_add_type_instr(attr0,OP_CHECKCAST,"java/lang/Integer");
			code_add_method_instr(attr0,OP_INVOKEVIRTUAL,\
									"java/lang/Integer",
									"intValue",\
									"()I");
			code_add_single_instr(attr0,OP_IRETURN);
			break;
		}
		case 'V':
		{
			fprintf(stdout,"Return type=V. nbarg: %i\n",nbarg);
			code_add_single_instr(attr0,OP_POP);
			code_add_single_instr(attr0,OP_RETURN);
			break;
		}
	}
	code_add_label(attr0,"l2");	
	code_add_single_instr(attr0,astore[nbarg+1]);
	code_add_label(attr0,"l3");
	code_add_single_instr(attr0,aload[nbarg+1]);
	code_add_single_instr(attr0,OP_ATHROW);
	code_add_label(attr0,"l4");
	code_add_single_instr(attr0,astore[nbarg+1]);
	code_add_label(attr0,"l5");
	code_add_single_instr(attr0,aload[nbarg+1]);
	code_add_single_instr(attr0,OP_ATHROW);
	code_add_label(attr0,"l6");
	code_add_single_instr(attr0,astore[nbarg+1]);
	code_add_label(attr0,"l7");
	code_add_type_instr(attr0,OP_NEW,"java/rmi/UnexpectedException");
	code_add_single_instr(attr0,OP_DUP);
	code_add_ldc(attr0,CONSTANT_String,"undeclared check exception"); //Check
	code_add_single_instr(attr0,aload[nbarg+1]);
	code_add_method_instr(attr0,OP_INVOKESPECIAL,\
						"java/rmi/UnexpectedException",\
						"<init>",\
						"(Ljava/lang/String;Ljava/lang/Exception;)V"
						);
	code_add_single_instr(attr0,OP_ATHROW);
	code_add_label(attr0,"l8");
	code_add_try_catch(attr0,"l0","l2","l2","java/lang/RuntimeException");
	code_add_try_catch(attr0,"l0","l2","l4","java/rmi/RemoteException");
	code_add_try_catch(attr0,"l0","l2","l6","java/lang/Exception");
	//code_set_max(attr0,7,3);
	
	// maxlocals == nbarg+1 of the method
	code_set_max(attr0, 17 , 10 );

}
*/


void proxy_code_get_class(ATTR_PTR attr,char* classObject,char* className,char* varName,char* typeName)
{
	code_add_field_instr(attr,OP_GETSTATIC,className,varName,typeName);
	code_add_single_instr(attr,OP_DUP);
	code_add_jump_instr_index(attr,OP_IFNONNULL,28); //pc+28 => After OP_THROW
	code_add_single_instr(attr,OP_POP);
	code_add_label(attr,"p1");
	code_add_ldc(attr,CONSTANT_String,classObject); 
	code_add_method_instr(attr,OP_INVOKESTATIC,\
						"java/lang/Class",\
						"forName",\
						"(Ljava/lang/String;)Ljava/lang/Class;");
	code_add_label(attr,"p2");
	code_add_single_instr(attr,OP_DUP);
	code_add_field_instr(attr,OP_PUTSTATIC,className,varName,typeName); 
	code_add_jump_instr_index(attr,OP_GOTO,15); //pc+15 //After OP_THROW
	code_add_label(attr,"p3");
	code_add_type_instr(attr,OP_NEW,"java/lang/NoClassDefFoundError");
	code_add_single_instr(attr,OP_DUP_X1);
	code_add_single_instr(attr,OP_SWAP);
	code_add_method_instr(attr,OP_INVOKEVIRTUAL,\
						"java/lang/Throwable",\
						"getMessage",\
						"()Ljava/lang/String;");
	code_add_method_instr(attr,OP_INVOKESPECIAL,\
						"java/lang/NoClassDefFoundError",\
						"<init>",\
						"(Ljava/lang/String;)V");
	code_add_single_instr(attr,OP_ATHROW);
	code_add_try_catch(attr,"p1","p2","p3","java/lang/ClassNotFoundException");
	code_add_free_labels(attr,"p1");
	code_add_free_labels(attr,"p2");
	code_add_free_labels(attr,"p3");
}


char* rmiproxy_write_RMI_class(SERVICEDEFPTR service)
{


	/*
	package defaultPkg;
	*
	 * Source created on Wed Mar 01 18:37:52 CET 2006
	 *
	public class tvImpl0 extends java.rmi.server.UnicastRemoteObject implements java.rmi.Remote , tv  {
	    public static void main(String[] args) throws Exception {
	            }
	public tvImpl0() throws java.rmi.RemoteException {
	super();
	}
	        public void SetPower(Boolean Power,rmiholders.IBooleanHolder Result)  throws java.rmi.RemoteException, java.lang.NoSuchMethodException {
	        // Power:0
	        // Result:1
	        }
	        public void GetPower(rmiholders.IBooleanHolder Power)  throws java.rmi.RemoteException, java.lang.NoSuchMethodException {
	        // Power:1
	        }
	}
		char* XMLfile;
		INTERFACEDEFPTR interfacesDefinition;
		char* host;
		int port;
		int indexService;
		
		char* name;
		char* type;
		long long RMI_ObjNum;
		long RMI_ObjUnique;
		long long RMI_ObjTime;
		short RMI_ObjCount;
		long RMI_ObjPort;
	*/

		
//	if ( service->indexService == 0)
//		return;

	
	if (service->name == NULL) 
		return NULL;
	
		if (index(service->name , '.') == NULL)
		{
			char* serv_name = strdup(DEFAULT_JAVA_PACKAGE);
			strcat(serv_name, strdup(service->name));
			fprintf(stdout,"\nserv_name = %s\n", serv_name );
			service->name = strdup(serv_name);
			fprintf(stdout,"service->name = %s\n", service->name );
		}
	
		fprintf(stdout,"Class name = %s\n", service->name );
		//char[255] package_name;
		//char[255] class_name;
		char complete_name[255];
		replace_dot_with_slash(service->name, complete_name);
		//strcpy(complete_name, package_name);
		//strcat(complete_name, class_name);
		char stubname[255];
		sprintf(stubname, "%sImpl%d_Stub", complete_name, service->indexService);
		//strcat(complete_name, stubname);
		fprintf(stdout,"Class complete_name = %s : stubname =%s\n", complete_name ,stubname);
		JCLASS_PTR cls=new_class( stubname, "java/rmi/server/RemoteStub");


		

		FIELD_PTR c_field=class_add_field(cls,ACC_STATIC|ACC_PRIVATE|ACC_FINAL,"serialVersionUID","J");
		ATTR_PTR c_attr=field_add_attribute(c_field,CONSTANT_VALUE);
		j_long sl=2L;
		attribute_add_constant_value(c_attr, CONSTANT_Long, &sl);	
		
		class_add_interface(cls,"java/rmi/Remote");
		class_add_interface(cls,  complete_name /*iface_complete_name*/ /*"defaultPkg/helloservice"/*"defaultPkg/tv"*/ /*iface_complete_name*/);
		
		
		INTERFACEDEFPTR ifaces;
		for (ifaces = service->interfacesDefinition; ifaces != NULL; ifaces = ifaces->next)
		{
			
			if ((ifaces->name != NULL) && index(ifaces->name , '.') == NULL)
			{
				char* serv_name = strdup(DEFAULT_JAVA_PACKAGE);
				strcat(serv_name, strdup(ifaces->name));
				ifaces->name = strdup(serv_name);
			}
			
			fprintf(stdout,"Interface name = %s\n", ifaces->name );
			//char[255] iface_package_name;
			//char[255] iface_class_name;
			char iface_complete_name[255];
			replace_dot_with_slash(ifaces->name, iface_complete_name);
			//strcpy(iface_complete_name, package_name);
			//strcat(iface_complete_name, iface_class_name);

			
		
			int meth_hash_index = 0;
			METHODDEFPTR meths;
			for (meths = ifaces->methods; meths != NULL; meths = meths->next)
			{
				fprintf(stdout,"method name = %s\n", meths->name);
			
				char* args_types[meths->nArgs];
				ARGUMENTDEFPTR args;
				//int index = 0;
				for (args = meths->args; args != NULL; args = args->next)
				{
					//char* type;
					char type[40];
					if (args->dir == ARG_IN)
					{
						if (!strcmp(args->datatype,"int"))
							//type = strdup("Ljava/lang/Integer;");
							strcpy(type, "Ljava/lang/Integer;");
						else if (!strcmp(args->datatype,"boolean"))
							//type = strdup("Ljava/lang/Boolean;");
							strcpy(type, "Ljava/lang/Boolean;");
						else if (!strcmp(args->datatype,"string"))
							//type = strdup("Ljava/lang/String;");
							strcpy(type, "Ljava/lang/String;");
						else
							//type = NULL;
							strcpy(type , "void");
						fprintf(stdout, "\n arg IN:  type=%s\n",type);
					}
					else if (args->dir == ARG_OUT)
					{
						if (!strcmp(args->datatype,"int"))
							//type = strdup("Lrmiholders/IIntegerHolder;");
							strcpy(type, "Lrmiholders/IIntegerHolder;");
						else if (!strcmp(args->datatype,"boolean"))
							//type = strdup("Lrmiholders/IBooleanHolder;");
							strcpy(type, "Lrmiholders/IBooleanHolder;");
						else if (!strcmp(args->datatype,"string"))
							//type = strdup("Lrmiholders/IStringHolder;");
							strcpy(type, "Lrmiholders/IStringHolder;");
						else
							//type = NULL;
							strcpy(type , "void");
						fprintf(stdout, "\n arg OUT:  type=%s\n",type);
					}
					if (type == NULL)
						args_types[args->index] = NULL;
					else
					{
						args_types[args->index] = malloc(strlen(type)+1);
						strcpy(args_types[args->index], type);
					}
					
					fprintf(stdout, "\n arg%d:  %s\n",args->index, args_types[args->index]);
					
					//index++;
				}
				meths->hash_index = meth_hash_index;
				proxy_add_method1(cls, stubname, meths->name, meths->hash_index, "V", meths->nArgs, args_types);
				
				/*		
				if (strcmp(meths->name, "SetPower") == 0 )
					proxy_add_method1(cls, meths->name, meths->hash_index, "V","Ljava/lang/Boolean;", "Lrmiholders/IBooleanHolder;", NULL);
					//proxy_add_method1(cls, meths->name, meths->hash_index, "V","Lrmiholders/IBooleanHolder;", "Lrmiholders/IBooleanHolder;", NULL);
					//proxy_add_method1(cls,  meths->name, meths->hash_index, "V","Ljava/lang/String;","Lrmiholders/IBooleanHolder;", NULL);
				else if (strcmp(meths->name, "GetPower") == 0 )
					proxy_add_method1(cls, meths->name, meths->hash_index, "V", "Lrmiholders/IBooleanHolder;", NULL);
					//proxy_add_method1(cls, meths->name, meths->hash_index, "V", "Ljava/lang/String;", NULL);
				//else
				//	proxy_add_method1(cls, meths->name, "V", NULL);
				//proxy_add_method1(cls, meths->name, "V","I","I",NULL);
				 
				 */
				meth_hash_index++;
			}
			
		}
		proxy_finalize(cls);

		//class_add_interface(cls,"test/Echo");
		


		
//		proxy_add_method1(cls,"toto","I","I","I",NULL);
		//proxy_add_method1(cls,"Name","ReturnType","args",NULL);
		//proxy_add_method1(cls,"echo","Ljava/lang/String;","Ljava/lang/String;",NULL);

		char filename[255];	
		//sprintf(filename, "NAME%d.class", service->indexService); 
		//sprintf(filename, "/opt/jakarta-tomcat-WSAMI/webapps/ROOT/tmp/defaultPkg/tvImpl%d_Stub.class", service->indexService);
		//sprintf(filename, "/opt/jakarta-tomcat-WSAMI/webapps/ROOT/tmp/defaultPkg/helloserviceImpl%d_Stub.class", service->indexService);
		sprintf(filename, "%s%s/%s.class", get_httpserver_path(),get_httpserver_urlpath(), stubname);
				
		fprintf(stdout, "proxy_write_RMI_class: Creating file %s\n",filename);
		
		int fd=open(filename, O_WRONLY|O_CREAT |O_TRUNC);
		class_write(fd, cls);
		close(fd);

		Table_add_PathServiceDef_Elem( &ServiceDefinitionTable, stubname, service);
		
		return strdup(stubname);
}


void *rmiproxy_run_composer(void* ptr)
{

	COMPOSETHREADDATA_PTR data = (COMPOSETHREADDATA_PTR)ptr;
	
	EVENTQUEUE_TABLE_ENTRY_PTR entry = (EVENTQUEUE_TABLE_ENTRY_PTR)data->entry_event_queue;
	COMPOSER_PTR composer = (COMPOSER_PTR)data->composer;
	
pthread_mutex_lock(&(entry->mutex));	
	
	
	// Add the identifier of the thread composer to the eventqueue_table 
	pthread_t thread_composer = pthread_self();

/*	
	char* reply_dest_addr;
	int reply_dest_port;
	SLPMSG_PTR slpmsg = slpmsg_create();
*/	
	
	PROXY_SERVICE_DISCOVER_TABLE services_table;
	proxy_service_discover_table_init(&services_table);
	
	/*
	SERVICEDEFPTR service_ptr = servicedef_new();
	service_ptr->indexService = 0;
	INTERFACEDEFPTR interface_ptr = interfacedef_new(service_ptr);
	servicedef_add_interface(service_ptr, interface_ptr);
	*/
	fprintf(stdout,"proxy_run_composer: starts. number of events=%d\n",entry->event_queue->size);
	

	while (1)
	{
		
		EVENT_PTR evt = eventqueue_table_get_event(entry);

		if (evt != NULL)
		{
			
			fprintf(stdout,"proxy_run_composer: evt is type=%d, src=%p\n", evt->type,evt->stream_id);
			event_print(evt);  
					
			switch (evt->type) 
			{

			
				case SDP_SERVICE_DESCRIPTION_SERVICETYPE:
				{
					SERVICEDEFPTR service_ptr;
					INTERFACEDEFPTR interface_ptr;
					int service_is_new_entry = 1;
					
					if (proxy_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					{
						service_is_new_entry = 0;
						service_ptr = proxy_service_discover_table_get_service_by_stream_id(services_table, evt->stream_id);
						servicedef_set_name(service_ptr, evt->value.value_string);
					}
					else
					{
						service_is_new_entry = 1;
						
						service_ptr = servicedef_new();
						//service_ptr->indexService = 0;
						INTERFACEDEFPTR interface_ptr = interfacedef_new(service_ptr);
						servicedef_add_interface(service_ptr, interface_ptr);
						
						proxy_service_discover_table_add_entry(&services_table, evt->stream_id, service_ptr);
						servicedef_set_name(service_ptr, evt->value.value_string);
					}
				}
				break;
				
				case SDP_SERVICE_DESCRIPTION_INTERFACE_NAMESPACE:
				{
					SERVICEDEFPTR service_ptr;
					int service_is_new_entry = 1;
					
					if (proxy_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					{
						service_is_new_entry = 0;
						service_ptr = proxy_service_discover_table_get_service_by_stream_id(services_table, evt->stream_id);
						INTERFACEDEFPTR interface_ptr = service_ptr->interfacesDefinition;
						interfacedef_set_namespace(interface_ptr, evt->value.value_string);
					}
					else
					{
						service_is_new_entry = 1;
						
						service_ptr = servicedef_new();
						//service_ptr->indexService = 0;
						INTERFACEDEFPTR interface_ptr = service_ptr->interfacesDefinition;
						servicedef_add_interface(service_ptr, interface_ptr);
						
						proxy_service_discover_table_add_entry(&services_table, evt->stream_id, service_ptr);
						interfacedef_set_namespace(interface_ptr, evt->value.value_string);
					}
				}
				break;
				
				case SDP_SERVICE_DESCRIPTION_INTERFACETYPE:
				{
					SERVICEDEFPTR service_ptr;
					int service_is_new_entry = 1;
					
					if (proxy_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					{
						service_is_new_entry = 0;
						service_ptr = proxy_service_discover_table_get_service_by_stream_id(services_table, evt->stream_id);
						INTERFACEDEFPTR interface_ptr = service_ptr->interfacesDefinition;
						interfacedef_set_name(interface_ptr, evt->value.value_string);
					}
					else
					{
						service_is_new_entry = 1;
						
						service_ptr = servicedef_new();
						//service_ptr->indexService = 0;
						INTERFACEDEFPTR interface_ptr = service_ptr->interfacesDefinition;
						servicedef_add_interface(service_ptr, interface_ptr);
						
						proxy_service_discover_table_add_entry(&services_table, evt->stream_id, service_ptr);
						interfacedef_set_name(interface_ptr, evt->value.value_string);
					}
				}
				break;
				
				case SDP_INTERFACE_CTRL_URL_PATH:
				{
					SERVICEDEFPTR service_ptr;
					int service_is_new_entry = 1;
					
					if (proxy_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					{
						service_is_new_entry = 0;
						service_ptr = proxy_service_discover_table_get_service_by_stream_id(services_table, evt->stream_id);
						INTERFACEDEFPTR interface_ptr = service_ptr->interfacesDefinition;
						interfacedef_set_uripath(interface_ptr, evt->value.value_string);
					}
					else
					{
						service_is_new_entry = 1;
						
						service_ptr = servicedef_new();
						//service_ptr->indexService = 0;
						INTERFACEDEFPTR interface_ptr = service_ptr->interfacesDefinition;
						servicedef_add_interface(service_ptr, interface_ptr);
						
						proxy_service_discover_table_add_entry(&services_table, evt->stream_id, service_ptr);
						interfacedef_set_uripath(interface_ptr, evt->value.value_string);
					}
				}
				break;
				
				case SDP_SERVICE_CTRL_URL_NOPATH:
				case SDP_SERVICE_DESCR_URL_NOPATH:
				{
					char *ip, *url;
					int port;
					parseURL_host_port(evt->value.value_string, &ip, &port, &url);
					fprintf(stdout,"proxy_run_composer: ip=%s, port=%d, url=%s\n", ip, port, url);
					
					SERVICEDEFPTR service_ptr;
					
					if (proxy_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					{
						service_ptr = proxy_service_discover_table_get_service_by_stream_id(services_table, evt->stream_id);
						
						servicedef_set_host(service_ptr, ip);
						servicedef_set_port(service_ptr, port);
					}
					else
					{
						service_ptr = servicedef_new();
						//service_ptr->indexService = 0;
						INTERFACEDEFPTR interface_ptr = interfacedef_new(service_ptr);
						servicedef_add_interface(service_ptr, interface_ptr);
						
						proxy_service_discover_table_add_entry(&services_table, evt->stream_id, service_ptr);
						
						servicedef_set_host(service_ptr, ip);
						servicedef_set_port(service_ptr, port);
					}

				}
					break;
				
				case SDP_SERVICE_METHOD_DESCRIPTION:
				{
					SERVICEDEFPTR service_ptr;
					INTERFACEDEFPTR interface_ptr;
					int service_is_new_entry = 1;
					
					if (proxy_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					{
						service_is_new_entry = 0;
						service_ptr = proxy_service_discover_table_get_service_by_stream_id(services_table, evt->stream_id);
					}
					else
					{
						service_is_new_entry = 1;
						
						service_ptr = servicedef_new();
						//service_ptr->indexService = 0;
						INTERFACEDEFPTR interface_ptr = interfacedef_new(service_ptr);
						servicedef_add_interface(service_ptr, interface_ptr);
						
						proxy_service_discover_table_add_entry(&services_table, evt->stream_id, service_ptr);
					}
					
					
					EVENT_METHOD_DEF_PTR event_methoddef = evt->value.value_void_pointer;
					
				    METHODDEFPTR methoddef = event_methoddef->method;
				    methoddef_print(methoddef);
				    
				    if (!service_is_new_entry)
				    {
				    	if (!servicedef_contains_method(service_ptr, methoddef))
				    	{
				    		interface_ptr = service_ptr->interfacesDefinition;
				    		interfacedef_add_method(interface_ptr, methoddef);
				    	}
				    }
				    else
				    {
				    	interface_ptr = service_ptr->interfacesDefinition;
				    	interfacedef_add_method(interface_ptr, methoddef);
				    }
				    
				    //servicedef_set_name(service_ptr, event_methoddef->service_name);
				    //interfacedef_set_name(interface_ptr, event_methoddef->interface_name);
		    
				}
				break;
				
				case GENERATE_PROXY:
					if (proxy_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					{
						
						SERVICEDEFPTR service_ptr = proxy_service_discover_table_get_service_by_stream_id(services_table, evt->stream_id);
							
				//		if (service_ptr != NULL && service_ptr->name !=NULL)
				//		{
							fprintf(stdout, "\nGENERATE_PROXY_before RMI\n");
							servicedef_print(service_ptr);
							fprintf(stdout, "\nGENERATE_PROXY_after RMI\n");
							
							//servicedef_set_name(service_ptr, "RMIPROXYCLASS_TEST");
							//interfacedef_set_name(interface_ptr, "RMIPROXYINTERFACE_TEST");
		//					servicedef_set_name(service_ptr, "defaultPkg.helloservice"/*"defaultPkg.tv"*/);
							
							INTERFACEDEFPTR interface_ptr = service_ptr->interfacesDefinition;
							
		//					interfacedef_set_name(interface_ptr, "RMIPROXYINTERFACE_TEST");
							
							
							servicedef_set_RMI_ObjNum(service_ptr, RMI_OBJNUM);
							servicedef_set_RMI_ObjUnique(service_ptr, RMI_OBJUNIQUE++);
							servicedef_set_RMI_ObjTime(service_ptr, RMI_OBJTIME);
							servicedef_set_RMI_ObjCount(service_ptr, RMI_OBJCOUNT);
							
							fprintf(stdout,"proxy_run_composer:GENERATE_PROXY: before  proxy_write_RMI_class");
							char* stubname = rmiproxy_write_RMI_class(service_ptr);
							fprintf(stdout,"proxy_run_composer:GENERATE_PROXY: after proxy_write_RMI_class stubname=%s\n",stubname);
							
							char serviceproxy_url[255];
							sprintf(serviceproxy_url, "http://%s:%d/%s",get_host_ip(),get_rmiregistry_port(), stubname);
													 
							composer_publish_event(event_create_string(SDP_SERVICEPROXY_URL_CTRL, serviceproxy_url, evt->stream_id, (void*)evt->src), composer);
					    	
							
				//		    upnpproxy_create_devicedescription(service_ptr);
				//		    INTERFACEDEFPTR interface_ptr_tmp;
				//		    for (interface_ptr_tmp = service_ptr->interfacesDefinition; interface_ptr_tmp != NULL; interface_ptr_tmp=interface_ptr_tmp->next)
				//		    {
				//		    	upnpproxy_create_servicedescription(interface_ptr_tmp, service_ptr);
				//		    }
						    
						    
						    
						    // Adds the service definition to the table that associates servicedefinitions to 
							//the related path used in SOAP message calls  in POST of the HTTP HEADER.
		
						     //  Each RMI service has got only one interface, so the path for the service is:
						     //  "/"+unique_interface_name+"/control" 
						
							
							//Table_add_PathServiceDef_Elem( &ServiceDefinitionTable, "x", service_ptr);
					
							if (stubname != NULL && strcmp(stubname, ""))
							{
						    	char path1[255] ="/";
						    	strcat(path1, stubname);
						    	strcat(path1, "/control");
						    	Table_add_PathServiceDef_Elem( &ServiceDefinitionTable, path1, service_ptr);
						    	
						  /*  	
						    INTERFACEDEFPTR iface = service_ptr->interfacesDefinition;
						    if (iface != NULL) {
						    	char path1[255] ="/";
						    	strcat(path1, iface->name);
						    	strcat(path1, "/control");
						    	Table_add_PathServiceDef_Elem( &ServiceDefinitionTable, path1, service_ptr);
						    }
	
						    char* path2 = "path2";
						    Table_add_PathServiceDef_Elem( &ServiceDefinitionTable, path2, service_ptr);
						    char* path3 = "path3";
						    Table_add_PathServiceDef_Elem( &ServiceDefinitionTable, path3, service_ptr);
						    
						    char* path4 = "x"; //"/washer_rmislp.WasherImpl/control";
						    SERVICEDEFPTR srvTmp = Table_get_ServiceDef(ServiceDefinitionTable, path4);
						    if (srvTmp != NULL)
						    	fprintf(stdout,"\nService %s Found: %s\n",path4, srvTmp->name);
						    else
						    	fprintf(stdout,"\nService %s NOT Found\n", path4);
					    */
							}
				//		}
					    
					}			    
					break;
					


	
			}	

		}
		usleep(10);

	}
}



void rmiproxy_composer_event_received(EVENT_PTR evt, LISTENER_PTR node)
{
	fprintf(stdout,"RMIPROXY");
	composer_event_received(evt, node);
}

COMPOSER_PTR rmiproxy_composer_create(UNIT_PTR u)
{
	fprintf(stdout, "Creating RMIPROXY composer\n");
		
	
	COMPOSER_PTR c = composer_create(u);

	c->run_composer = rmiproxy_run_composer;
	c->factory = rmiproxy_composer_create;

	c->func_event_received = rmiproxy_composer_event_received;
	return c;	
}



void proxy_service_discover_table_init(PROXY_SERVICE_DISCOVER_TABLE* table)
{
	table->n_services = 0;
	int i =0;
	for (i=0 ; i<100; i++)
	{
		table->services[i].stream_id = -1;
		table->services[i].service_ptr = NULL;
	}
}

void proxy_service_discover_table_add_entry(PROXY_SERVICE_DISCOVER_TABLE* table, int stream_id, SERVICEDEFPTR service_ptr)
{
	fprintf(stdout, "proxy_service_discover_table_add_entry(table->n_services=%d). stream_id=%p \n",table->n_services, stream_id);
	
	table->services[table->n_services].stream_id = stream_id;
	table->services[table->n_services].service_ptr = service_ptr;
	table->n_services += 1;
	
	fprintf(stdout, "proxy_service_discover_table_add_entry END (table->n_services=%d). stream_id=%p \n",table->n_services, stream_id);
}

int proxy_service_discover_table_contains_stream_id(PROXY_SERVICE_DISCOVER_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		fprintf(stdout, "proxy_service_discover_table_contains_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return 1;
	}
	return 0;
}

SERVICEDEFPTR proxy_service_discover_table_get_service_by_stream_id(PROXY_SERVICE_DISCOVER_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		fprintf(stdout, "proxy_service_discover_table_get_slpmsg_by_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return table.services[i].service_ptr;
	}
	return NULL;
}


