#include "composer/composer.h"
#include "unit/unit.h"
#include "protocol/slpmsg.h"
#include "protocol/slp.h"
#include "io/io.h"
#include <stdio.h>
#include "event/eventqueue_table.h"
#include <pthread.h>

#include "composer/slpcomposer.h"
#include "monitor/tools.h"

/*
int writejByte(int fd,j_byte b);
int writeBytes(int fd, j_byte* buff, size_t length);
int writejShort(int fd,j_short sh);
int writejByte(int fd,j_byte b);
int writejInt(int fd,j_int ji);
int writejUtf8(int fd, UTF8_PTR utf8);
int writejLong(int fd, j_long jl);
*/

	/**
	 * Compose SLP common message header, flags may be set, there may exist
	 * extensions, language tag is NOT included here
	 * +--------------+-----------------+----------------------------------+
	 * |Version | Function-ID | Length |
	 * +--------------+-+-+-+-----------+---------------+------------------+
	 * |Length cont. |O|F|R| Reserved | Next Ext. Offset |
	 * +--------------+-+-+-+-----------+---------------+------------------+
	 * |Next Ext. Offset Cont. | XID |
	 * +--------------------------------+----------------------------------+
	 */

/*
void slpcomposer_msg_header(SLPMSG_PTR slpmsg, int fd)
{
	int version = slpmsg_get_version(slpmsg);
	int function_id = slpmsg_get_function_id(slpmsg);
	int len = slpmsg_get_length(slpmsg);
	int flag = 0000000; // to be added to slpmsg
	int xid = slpmsg_get_xid(slpmsg);
	
	writejByte(fd, (j_byte)version);
	writejByte(fd, (j_byte)function_id);
	// write length: 3 bytes
	writejByte(fd, (j_byte)0);
	writejShort(fd, (j_short)len);
	// write flag: 2 bytes
	writejShort(fd, (j_short)flag);
	// write ext. offset: 3 bytes
	writejByte(fd, (j_byte)0);
	writejShort(fd, (j_short)0);
	// write xid: 2 bytes
	writejShort(fd, (j_short)xid);
}
*/

/*
	private void Header(int type, int len, int flag, int xid) {
		try {
			b.reset();
			d.writeByte(ConstantSlp.version); // SLP version
			unit.getLogger().debug("header type="+type);			
			d.writeByte(type); // Function type
			d.writeByte(0); // len
			unit.getLogger().debug("header len="+len);
			d.writeShort(len); // length
			unit.getLogger().debug("header flag="+flag);
			d.writeShort(flag); // flag bits
			d.writeByte(0); // next ext. offset
			d.writeShort(0); // next ext. offset
			unit.getLogger().debug("header xid="+xid);
			d.writeShort(xid); // XID
		} catch (Exception e) {
			System.err.println(e);
		}
	}
*/	
	/**
	 * service request <#1>
	 * +----------------------------+---------------------------+
	 * | Length of <PRList>			| <PRList>string 			\
	 * +----------------------------+---------------------------+ 
	 * | Length of <service-type>	| <service-type>string 		\
	 * +----------------------------+---------------------------+ 
	 * | Length of <scope-list>		| <scope-list>string 		\
	 * +----------------------------+---------------------------+ 
	 * | Length of predicate string | service request predicate \
	 * +----------------------------+---------------------------+ 
	 * | Length of <SLP SPI> string | <SLP SPI> string 			\
	 * +----------------------------+---------------------------+
	 */
	
	 /*
int slpcomposer_slpmsg_writeString(int fd, char* string)
{
	// write length: 2 bytes
	writejShort(fd, (j_short)strlen(string));
	// write string: len bytes
	writeBytes(fd, string, strlen(string));
}
	  */

/*
int slpcomposer_slp_request(SLPMSG_PTR slpmsg, int fd)
{
	//int len = 
//			int len = ConstantSlp.header_len + strlen(ltag) + strlen(pr) + strlen(type)
//				+ strlen(scope) + strlen(pred) + strlen(spi);
	slpcomposer_msg_header(slpmsg, fd);
	
	char* ltag = slpmsg_get_lang_tag(slpmsg);
	char* pr_list = slpmsg_get_pr_list(slpmsg);
	char* service_type = slpmsg_get_service_type(slpmsg);
	char* scopes = slpmsg_get_scope_list(slpmsg);
	char* pred = slpmsg_get_predicate(slpmsg);
	char* spi = ""; //slpmsg_get_spi(slpmsg);

	slpcomposer_slpmsg_writeString(fd, ltag);
	slpcomposer_slpmsg_writeString(fd, pr_list);
	slpcomposer_slpmsg_writeString(fd, service_type);
	slpcomposer_slpmsg_writeString(fd, scopes);
	slpcomposer_slpmsg_writeString(fd, pred);
	slpcomposer_slpmsg_writeString(fd, spi);
}
*/





/*
	public byte[] SrvRqst(int xid, int flag, String ltag, String pr,
			String type, String scope, String pred, String spi) {
		
		
		int len = ConstantSlp.header_len + strlen(ltag) + strlen(pr) + strlen(type)
				+ strlen(scope) + strlen(pred) + strlen(spi);
		
		Header(ConstantSlp.SrvRqst, len, flag, xid);

		unit.getLogger().debug("req ltag="+ltag);
		putString(ltag); // language tag
		putString(pr); // PRList
		putString(type); // service type
		putString(scope); // scope list
		putString(pred); // predicate
		putString(spi); // SPI
		return b.toByteArray();
	}
*/	


void slpcomposer_slpmsg_writejBytes_charPtr(char** stream, j_byte *buf, size_t len)
{
  int i;
  for (i=0; i< len; i++)
     (*stream)[i] = buf[i];

  *stream += len; 
}

void slpcomposer_slpmsg_writejByte_charPtr(char** stream, j_byte b)
{
    size_t len = sizeof(j_byte);
    return slpcomposer_slpmsg_writejBytes_charPtr(stream, &b, len);
}   
    
void slpcomposer_slpmsg_writejInt_charPtr(char** stream, j_int ji)
{
    size_t len = sizeof(j_int);
	ji=(\
		((ji & 0xff000000)>>24)|
		((ji & 0x00ff0000)>>8) |
		((ji & 0x0000ff00)<<8) |
		((ji & 0x000000ff)<<24));
    return slpcomposer_slpmsg_writejBytes_charPtr(stream, (j_byte*)(&ji),len);	 
}

void slpcomposer_slpmsg_writejShort_charPtr(char** stream, j_short sh)
{
	 size_t len=sizeof(j_short);
	 sh=(\
	 		((sh& 0xff00)>>8)|
	 		((sh &0x00ff)<<8));
	return slpcomposer_slpmsg_writejBytes_charPtr(stream, (j_byte*)(&sh),len);
}


void slpcomposer_slpmsg_writeString_charPtr(char** stream, char* string)
{
	if (string == NULL)
	{
		// write length: 2 bytes
		slpcomposer_slpmsg_writejShort_charPtr(stream, (j_short)0);
		// do not write string: len bytes = 0
	}
	else 
	{
		// write length: 2 bytes
		slpcomposer_slpmsg_writejShort_charPtr(stream, (j_short)strlen(string));
		// write string: len bytes
		slpcomposer_slpmsg_writejBytes_charPtr(stream, string, strlen(string));
	}
}

void slpcomposer_msg_header_charPtr(SLPMSG_PTR slpmsg, char** stream)
{
	int version = slpmsg_get_version(slpmsg);
	int function_id = slpmsg_get_function_id(slpmsg);
	int len = slpmsg_get_length(slpmsg);
	int flag = 0x0000; // to be added to slpmsg
	char* xid = slpmsg_get_xid(slpmsg);
	
	slpcomposer_slpmsg_writejByte_charPtr(stream, (j_byte)version);
	slpcomposer_slpmsg_writejByte_charPtr(stream, (j_byte)function_id);
	// write length: 3 bytes
	slpcomposer_slpmsg_writejByte_charPtr(stream, (j_byte)0);
	slpcomposer_slpmsg_writejShort_charPtr(stream, (j_short)len);
	// write flag: 2 bytes
	slpcomposer_slpmsg_writejShort_charPtr(stream, (j_short)flag);
	// write ext. offset: 3 bytes
	slpcomposer_slpmsg_writejByte_charPtr(stream, (j_byte)0);
	slpcomposer_slpmsg_writejShort_charPtr(stream, (j_short)0);
	// write xid: 2 bytes
	slpcomposer_slpmsg_writejShort_charPtr(stream, (j_short)atoi(xid));
}

	/**
	 * service reply (reply for service request) <#2>
	 * +----------------------------+---------------------------+ 
	 * | Error Code 				|		URL entry count		|
	 * +----------------------------+---------------------------+ 
	 * | 		<URl entry1> ... <URL entry N> 					\
	 * +----------------------------+---------------------------+
	 */
	 
MSG_PTR slpcomposer_slp_reply(SLPMSG_PTR slpmsg)
{
	//int len = 
//			int len = ConstantSlp.header_len + strlen(ltag) + strlen(pr) + strlen(type)
//				+ strlen(scope) + strlen(pred) + strlen(spi);
	
	//fprintf(stdout, "slpcomposer_slp_reply = %p %s  \n",slpmsg , slpmsg_get_dest_addr(slpmsg) );
	fprintf(stdout, "slpcomposer_slp_reply to (%s:%d) - url_list=%s - msg->service_type=%s\n", slpmsg_get_dest_addr(slpmsg), slpmsg_get_dest_port(slpmsg), slpmsg_get_url_list(slpmsg) ,slpmsg->service_type);

	if (slpmsg->url_list/*_get_url_list(slpmsg)*/ == NULL)
		return NULL;
	
	MSG_PTR reply_msg = (MSG_PTR)msg_create("", 0, get_host_ip(), 1000, slpmsg_get_dest_addr(slpmsg), slpmsg_get_dest_port(slpmsg), NULL);	

	fprintf(stdout, "REPLY_MSG->DATA = %p\n",&reply_msg->data );
	
	int msg_len = SLP_HEADER_LENGTH;
	
	// language tag
	char* ltag = slpmsg_get_lang_tag(slpmsg);
	msg_len += (2 + strlen(ltag));
	
	// error code
	msg_len +=2;
	
	// url entry count
	msg_len += 2;
	
	// url entry
	//char* url_list = slpmsg_get_url_list(slpmsg);
	int url_list_len = 0;
	char url_list[255];
	
	if (slpmsg->url_list != NULL)
	{
		sprintf(url_list, "%s:%s",slpmsg->service_type, slpmsg->url_list);
		url_list_len = strlen(url_list/*"service:tv:http://192.168.2.2:1100/x" /slpmsg->url_list */);
		fprintf(stdout, "slpcomposer_slp_reply. url_list=%s url_list_len=%d\n ",url_list, url_list_len);
	}
	//else
	//	url_list_len = strlen("service:tv:http://");
	msg_len += 1 /*reserved*/ + 2/*lifetime*/ + 2 /*url length*/ + url_list_len /*strlen("service:tv:http://192.168.2.2:1100/x")*/ + 1 /*auth block*/;
	
	
	reply_msg->length = msg_len;
	reply_msg->data = malloc(msg_len);
	
	slpmsg_set_length(slpmsg, msg_len);
	slpmsg_set_function_id(slpmsg, SrvRply);
	
	char* reply_data_content = reply_msg->data;
	slpcomposer_msg_header_charPtr(slpmsg, /*&reply_msg->data*/ &reply_data_content);
	
	slpcomposer_slpmsg_writeString_charPtr(/*&reply_msg->data*/ &reply_data_content, ltag);
	
	
	// SLPREPLY: ERROR CODE
	slpcomposer_slpmsg_writejShort_charPtr(/*&reply_msg->data*/ &reply_data_content, (j_short)OK);
	
	
	// SLPREPLY: URLLIST
	slpcomposer_slpmsg_writejShort_charPtr(/*&reply_msg->data*/ &reply_data_content, (j_short)1);
	slpcomposer_slpmsg_writejByte_charPtr(/*&reply_msg->data*/ &reply_data_content, 0); /* reserved */
	slpcomposer_slpmsg_writejShort_charPtr(/*&reply_msg->data*/ &reply_data_content, 65535); /* lifetime */
	
	if (slpmsg->url_list != NULL)
		slpcomposer_slpmsg_writeString_charPtr(/*&reply_msg->data*/ &reply_data_content, url_list); /*urllength + urllist */
		//slpcomposer_slpmsg_writeString_charPtr(/*&reply_msg->data*/ &reply_data_content, "service:tv:http://192.168.2.2:1100/x");
//	else
//		slpcomposer_slpmsg_writeString_charPtr(/*&reply_msg->data*/ &reply_data_content, "service:tv:http://"); 


	slpcomposer_slpmsg_writejByte_charPtr(/*&reply_msg->data*/ &reply_data_content, 0); /* auth */

	
	fprintf(stdout, "REPLY_MSG->DATA = %p\n",&reply_msg->data );
	
	return reply_msg;		
}	 


MSG_PTR slpcomposer_slp_request(SLPMSG_PTR slpmsg)
{

	MSG_PTR request_msg = msg_create("", 0, get_host_ip()/*"192.168.2.2"*/, 1000, "239.255.255.253", 427, NULL);
	fprintf(stdout, "slpcomposer_slp_request.  service type = %s\n",slpmsg_get_service_type(slpmsg) );
	
	int msg_len = SLP_HEADER_LENGTH;
	char st[255] = "service:";
	
	// language tag
	char* ltag = slpmsg_get_lang_tag(slpmsg);
	msg_len += (2 + strlen(ltag));
	
	// url PRLIST, service-type, scope, predicate, spi (optional)
	if (slpmsg_get_pr_list(slpmsg) != NULL)
		msg_len += 2 /*prlist length*/ + strlen(slpmsg_get_pr_list(slpmsg)) ;
	else 
		msg_len += 2 /*prlist length*/;
	if (slpmsg_get_service_type(slpmsg) != NULL)
	{
		sprintf(st, "service:%s",slpmsg_get_service_type(slpmsg));
		msg_len += 2 /*prlist service_type*/ + strlen(st) ;
	}
	else 
		msg_len += 2 /*prlist service_type*/;
	if (slpmsg_get_scope_list(slpmsg) != NULL)
		msg_len += 2 /*scope_list length*/ + strlen(slpmsg_get_scope_list(slpmsg)) ;
	else 
		msg_len += 2 /*scope_list*/;
	if (slpmsg_get_predicate(slpmsg) != NULL)
		msg_len += 2 /*predicate length*/ + strlen(slpmsg_get_predicate(slpmsg)) ;
	else 
		msg_len += 2 /*predicate length*/;
	// SPI == NULL
	msg_len += 2 /* spi length*/;	
	
	request_msg->length = msg_len;
	request_msg->data = malloc(msg_len);
	
	slpmsg_set_length(slpmsg, msg_len);
	slpmsg_set_function_id(slpmsg, slpmsg_get_function_id(slpmsg));
	
	char* request_data_content = request_msg->data;
	slpcomposer_msg_header_charPtr(slpmsg, /*&reply_msg->data*/ &request_data_content);
	
	slpcomposer_slpmsg_writeString_charPtr(/*&reply_msg->data*/ &request_data_content, ltag);
	
	// SLPREQUEST: PRLIST, service-type, scope, predicate, spi (optional)
	slpcomposer_slpmsg_writeString_charPtr(&request_data_content, slpmsg_get_pr_list(slpmsg));
	slpcomposer_slpmsg_writeString_charPtr(&request_data_content, st /*"service:washer"/*slpmsg_get_service_type(slpmsg)*/);
	slpcomposer_slpmsg_writeString_charPtr(&request_data_content, slpmsg_get_scope_list(slpmsg));
	slpcomposer_slpmsg_writeString_charPtr(&request_data_content, slpmsg_get_predicate(slpmsg));
	slpcomposer_slpmsg_writeString_charPtr(&request_data_content, NULL); //spi
	
	fprintf(stdout, "request_MSG->DATA = %p\n",&request_msg->data );
	
	return request_msg;	
}



/*
	public byte[] SrvReply(int xid, String ltag, byte[] buf) {
		int len = ConstantSlp.header_len + strlen(ltag) + buf.length;
		
		Header(ConstantSlp.SrvRply, len, ConstantSlp.normal_flag, xid);
		
		putString(ltag); // language tag
		
		try {
			d.write(buf, 0, buf.length); // ErrCode + #URL + each entry
		} catch (Exception e) {
			System.err.println(e);
		}
		return b.toByteArray();
	}
*/	
	/**
	 * service reply (reply for service request) <#2>
	 * +----------------------------+---------------------------+ 
	 * | Error Code 				|		URL entry count		|
	 * +----------------------------+---------------------------+ 
	 * | 		<URl entry1> ... <URL entry N> 					\
	 * +----------------------------+---------------------------+
	 *
	public byte[] SrvReply(int xid, String ltag, int errorCode, int urlCount, String[] urls) {
		
		// assert (urlCount = urls.length)
		
		int len = ConstantSlp.header_len + strlen(ltag) + 2 /*errorCode/ + 2 /*URL Entry count/;

		//int len = ConstantSlp.header_len + strlen(ltag) + 2 + 2 ;
				
		for (int i=0; i<urlCount; i++) {
			int lenURLEntry = 1 /*reserved/+2 /*lifetime/ + strlen(urls[i]) +1 /* no auth blocks/;
			len += lenURLEntry;
		}
		
		Header(ConstantSlp.SrvRply, len, ConstantSlp.normal_flag, xid);
		
		putString(ltag); // language tag
		
		try {
			d.writeShort(errorCode);
			d.writeShort(urlCount);
			for (int i=0; i<urlCount; i++) {
				d.writeByte(0);
				d.writeShort(65535);
				putString(urls[i]);
				d.writeByte(0);
			}
			//d.write(buf, 0, buf.length); // ErrCode + #URL + each entry
		} catch (Exception e) {
			System.err.println(e);
		}
		return b.toByteArray();
	}
	*/
	
	/**
	 * directory agent advertisement <#8>
	 * +-------------------------------+--------------------------------+ 
	 * |		Error Code 			   | DA Stateless Boot Timestamp 	|
	 * +-------------------------------+--------------------------------+ 
	 * | DA	Stateless Boot Time cont.  | Length of URL 					|
	 * +-------------------------------+--------------------------------+ 
	 * | 							URL 								\
	 * +-------------------------------+--------------------------------+ 
	 * |	Length of <scope-list>	   |	<scope-list>				\
	 * +-------------------------------+--------------------------------+ 
	 * |	Length of <attr-list>	   |<attr-list>						\
	 * +-------------------------------+--------------------------------+
	 * |	Length of SLP <SPI>		   | SLP <SPI>string 				\
	 * +---------------+---------------+--------------------------------+ 
	 * | #Auth Blocks  | 		Authentication blocl (if any) 			\
	 * +---------------+---------------+--------------------------------+
	 
	public byte[] DAAdvert(int xid, int flag, String ltag, int ts, String url,
			String scope, String attr, String spi) {
		
		int len = ConstantSlp.header_len + 7 + strlen(ltag) + strlen(url)
				+ strlen(scope) + strlen(attr) + strlen(spi);
		
		Header(ConstantSlp.DAAdvert, len, flag, xid);
		
		putString(ltag); // language tag
		putShort(0); // ErrCode
		putInt(ts); // boot timestamp
		putString(url); // URL
		putString(scope); // scope list
		putString(attr); // attribute list
		putString(spi); // SLP SPI
		putByte(0); // # Auth blocks
		return b.toByteArray();
	}
*/

void *slp_run_composer(void* ptr)
{

	COMPOSETHREADDATA_PTR data = (COMPOSETHREADDATA_PTR)ptr;
	
	EVENTQUEUE_TABLE_ENTRY_PTR entry = (EVENTQUEUE_TABLE_ENTRY_PTR)data->entry_event_queue;
	COMPOSER_PTR composer = (COMPOSER_PTR)data->composer;
	
pthread_mutex_lock(&(entry->mutex));	
	
	
	// Add the identifier of the thread composer to the eventqueue_table 
	pthread_t thread_composer = pthread_self();


	SLP_SERVICE_DISCOVER_TABLE services_table;
	slp_service_discover_table_init(&services_table);
	/*
	char* reply_dest_addr;
	int reply_dest_port;
	SLPMSG_PTR slpmsg = slpmsg_create();
	*/
	fprintf(stdout,"slp_run_composer: starts. number of events=%d\n",entry->event_queue->size);
	
	while (1)
	{
		EVENT_PTR evt = eventqueue_table_get_event(entry);
		if (evt != NULL)
		{
			fprintf(stdout,"slp_run_composer: evt is type=%d, src=%p\n", evt->type,evt->stream_id);
			event_print(evt);  
			
			switch (evt->type) 
			{
			
			
			/*
			 * The following events are received when SLP composer is used to generate an SLP
			 * reply message
			 * 
			 */
			case SDP_SOURCE_ADDR:
			{
				fprintf(stdout,"slp_run_composer: before table.n_services=%d, \n",services_table.n_services);
				SLPMSG_PTR slpmsg;
				if (slp_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					slpmsg = slp_service_discover_table_get_slpmsg_by_stream_id(services_table, evt->stream_id);
				else
				{
					slpmsg = slpmsg_create();
					slp_service_discover_table_add_entry(&services_table, evt->stream_id, NULL, slpmsg);
				}
				slpmsg_set_dest_addr(slpmsg, evt->value.value_string);
				
				fprintf(stdout,"slp_run_composer: after table.n_services=%d, \n",services_table.n_services);
			}
				//reply_dest_addr = strdup(evt->value.value_string);
				//slpmsg_set_dest_addr(slpmsg, reply_dest_addr);
				break;		
			case SDP_SOURCE_PORT:
			{
				SLPMSG_PTR slpmsg;
				if (slp_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					slpmsg = slp_service_discover_table_get_slpmsg_by_stream_id(services_table, evt->stream_id);
				else
				{
					slpmsg = slpmsg_create();
					slp_service_discover_table_add_entry(&services_table, evt->stream_id, NULL, slpmsg);
				}
				slpmsg_set_dest_port(slpmsg, evt->value.value_int);
			}
				
				//fprintf(stdout,"slp_run_composer: SDP_SOURCE_PORT, previous value = %d new value= %d\n",reply_dest_port, evt->value.value_int); 
				//reply_dest_port = evt->value.value_int;
				//slpmsg_set_dest_port(slpmsg, reply_dest_port);
				break;	
			
			case SDP_REQ_LANGAGE:
			{
				SLPMSG_PTR slpmsg;
				if (slp_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					slpmsg = slp_service_discover_table_get_slpmsg_by_stream_id(services_table, evt->stream_id);
				else
				{
					slpmsg = slpmsg_create();
					slp_service_discover_table_add_entry(&services_table, evt->stream_id, NULL, slpmsg);
				}
				slpmsg_set_lang_tag(slpmsg, evt->value.value_string);
			}
	    		//	slpmsg_set_lang_tag(slpmsg, evt->value.value_string);
				break;
			case SDP_REQ_SCOPE:
			{
				SLPMSG_PTR slpmsg;
				if (slp_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					slpmsg = slp_service_discover_table_get_slpmsg_by_stream_id(services_table, evt->stream_id);
				else
				{
					slpmsg = slpmsg_create();
					slp_service_discover_table_add_entry(&services_table, evt->stream_id, NULL, slpmsg);
				}
				slpmsg_set_scope_list(slpmsg, evt->value.value_string);
			}
				//slpmsg_set_scope_list(slpmsg, evt->value.value_string);
				break;	
			case SDP_REQ_PREDICAT:
			{
				SLPMSG_PTR slpmsg;
				if (slp_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					slpmsg = slp_service_discover_table_get_slpmsg_by_stream_id(services_table, evt->stream_id);
				else
				{
					slpmsg = slpmsg_create();
					slp_service_discover_table_add_entry(&services_table, evt->stream_id, NULL, slpmsg);
				}
				slpmsg_set_predicate(slpmsg, evt->value.value_string);
			}
				//slpmsg_set_predicate(slpmsg, evt->value.value_string);
				break;	
			case SDP_REQ_REQUESTER:
			{
				SLPMSG_PTR slpmsg;
				if (slp_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					slpmsg = slp_service_discover_table_get_slpmsg_by_stream_id(services_table, evt->stream_id);
				else
				{
					slpmsg = slpmsg_create();
					slp_service_discover_table_add_entry(&services_table, evt->stream_id, NULL, slpmsg);
				}
				slpmsg_set_lang_tag(slpmsg, evt->value.value_string);
			}
				//slpmsg_set_pr_list(slpmsg, evt->value.value_string);
				break;	
			case SDP_REQ_SERVICE_TYPE:
			{
				SLPMSG_PTR slpmsg;
				if (slp_service_discover_table_contains_stream_id(services_table, evt->stream_id))
				{
					slpmsg = slp_service_discover_table_get_slpmsg_by_stream_id(services_table, evt->stream_id);
					slp_service_discover_table_set_service_type(services_table, evt->stream_id, evt->value.value_string);
				}
				else
				{
					slpmsg = slpmsg_create();
					slp_service_discover_table_add_entry(&services_table, evt->stream_id, evt->value.value_string, slpmsg);
				}
				slpmsg_set_service_type(slpmsg, evt->value.value_string);
			}
				//slpmsg_set_service_type(slpmsg, evt->value.value_string);
				break;	
			case SDP_REQ_ID:
			{
				SLPMSG_PTR slpmsg;
				if (slp_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					slpmsg = slp_service_discover_table_get_slpmsg_by_stream_id(services_table, evt->stream_id);
				else
				{
					slpmsg = slpmsg_create();
					slp_service_discover_table_add_entry(&services_table, evt->stream_id, NULL, slpmsg);
				}
				slpmsg_set_xid(slpmsg, evt->value.value_string);
			}
				//fprintf(stdout,"slp_run_composer: SDP_REQ_ID, previous value = %d new value= %d\n",slpmsg_get_xid(slpmsg), evt->value.value_int); 
				//slpmsg_set_xid(slpmsg, evt->value.value_int);
				break;		
			case SDP_VERSION:
			{
				SLPMSG_PTR slpmsg;
				if (slp_service_discover_table_contains_stream_id(services_table, evt->stream_id))
					slpmsg = slp_service_discover_table_get_slpmsg_by_stream_id(services_table, evt->stream_id);
				else
				{
					slpmsg = slpmsg_create();
					slp_service_discover_table_add_entry(&services_table, evt->stream_id, NULL, slpmsg);
				}
				slpmsg_set_version(slpmsg, evt->value.value_int);
			}
				//slpmsg_set_version(slpmsg, evt->value.value_int);
				break;		

				
			case SDP_SERVICE_CTRL_URL_NOPATH:
				break;
				
			case SDP_INTERFACE_CTRL_URL_PATH:
				break;
				
			case SDP_SERVICE_METHOD_DESCRIPTION:
				break;

			case SDP_SERVICEPROXY_URL_CTRL:
			{
				fprintf(stdout, "SDP_SERVICEPROXY_URL_CTRL  evt->stream_id=%p (value=%s)\n",evt->stream_id,evt->value.value_string);
				SLPMSG_PTR slpmsg;
				if (slp_service_discover_table_contains_stream_id(services_table, evt->stream_id))
				{
					slpmsg = slp_service_discover_table_get_slpmsg_by_stream_id(services_table, evt->stream_id);
				}
				else
				{
					slpmsg = slpmsg_create();
					slp_service_discover_table_add_entry(&services_table, evt->stream_id, evt->value.value_string, slpmsg);
				}

				slpmsg_set_url_list(slpmsg, evt->value.value_string);
			}
				break;	
				
			//case SDP_STOP:	
			case SDP_SEND_SERVICE_REPLY:
			{
				fprintf(stdout, "SDP_STOP before1 slpcomposer_slp_reply evt->stream_id=%p\n",evt->stream_id);
				if (slp_service_discover_table_contains_stream_id(services_table, evt->stream_id))
				{
					fprintf(stdout, "SDP_STOP before2 slpcomposer_slp_reply\n");
					
					SLPMSG_PTR slpmsg = slp_service_discover_table_get_slpmsg_by_stream_id(services_table, evt->stream_id);
					
					MSG_PTR msg = slpcomposer_slp_reply(slpmsg);
					fprintf(stdout, "SDP_STOP after slpcomposer_slp_reply\n");
					if (msg != NULL)
						composer_publish_msg(msg, composer);
				}
				else
					fprintf(stdout, "SDP_STOP before2 slpcomposer_slp_reply : NOT CONTAINED \n");
			}
				break;
				
			/*
			 * The following events are received when SLP composer is used to generate an SLP
			 * request message
			 * 
			 */
			case SDP_SERVICE_REQUEST:
				break;
				
			case SDP_SEND_SERVICE_REQUEST:
				
				fprintf(stdout, "SDP_SEND_SERVICE_REQUEST\n");
				if (slp_service_discover_table_contains_stream_id(services_table, evt->stream_id))
				{
					fprintf(stdout, "SDP_STOP before2 slpcomposer_slp_request\n");
					
					SLPMSG_PTR slpmsg = slp_service_discover_table_get_slpmsg_by_stream_id(services_table, evt->stream_id);
				
					
					if (slpmsg_get_version(slpmsg) == 0)
						slpmsg_set_version(slpmsg, slp_version);
					
					slpmsg_set_function_id(slpmsg, SrvRqst);
					
					if (slpmsg_get_xid(slpmsg) == 0)
						slpmsg_set_xid(slpmsg, "12345");
					
					if (slpmsg_get_lang_tag(slpmsg) == NULL)
						slpmsg_set_lang_tag(slpmsg, "en");
					
					slpmsg_set_scope_list(slpmsg, "DEFAULT");
					slpmsg_set_predicate(slpmsg, NULL);
					slpmsg_set_pr_list(slpmsg, NULL);
					
					
					MSG_PTR msg = slpcomposer_slp_request(slpmsg);
					
					
					
					fprintf(stdout, "slp_run_composer: (before remove) eventqueue_table_get_composer_thread_list_length(entry=%p) = %d\n",entry, eventqueue_table_get_composer_thread_list_length(entry));
					COMPOSERTHREAD_LIST_ENTRY_PTR first_composer_thread  = eventqueue_table_remove_first_composer_thread(entry);
					// set current_socket_reply_port for ssdp parser to find the right entry on the table
					entry->current_socket_reply_port = first_composer_thread->socket_reply_port;	
					
					
					composer_publish_msg(msg, composer);			
				
					
					pthread_cond_signal(&(first_composer_thread->cond));
					

					fprintf(stdout, "slp_run_composer: (after remove) eventqueue_table_get_composer_thread_list_length(entry=%p) = %d\n",entry, eventqueue_table_get_composer_thread_list_length(entry));
					
					
					pthread_mutex_unlock(&(entry->mutex));
					
					fprintf(stdout, "slp_run_composer: signal cond var %p\n", &(first_composer_thread->cond));
					
					
				}
				else
					fprintf(stdout, "SDP_STOP before2 slpcomposer_slp_request : NOT CONTAINED \n");
				
				
				

				
				return;
				
				
				
				break;
				
			default:
				break;
			}	
			
		}
		usleep(10);

		
		
		//else
		//	fprintf(stdout,"slp_run_composer: NO evt !\n"); 
	}
}

void slp_composer_event_received(EVENT_PTR evt, LISTENER_PTR node)
{
	fprintf(stdout,"SLP");
	composer_event_received(evt, node);
}

COMPOSER_PTR slpcomposer_create(UNIT_PTR u)
{
	fprintf(stdout, "Creting SLP composer\n");
		
	
	COMPOSER_PTR c = composer_create(u);

	c->run_composer = slp_run_composer;
	c->factory = slpcomposer_create;

	c->func_event_received = slp_composer_event_received;
	return c;	
}




void slp_service_discover_table_init(SLP_SERVICE_DISCOVER_TABLE* table)
{
	table->n_services = 0;
	int i =0;
	for (i=0 ; i<100; i++)
	{
		table->services[i].stream_id = -1;
		table->services[i].service_type = NULL;
		table->services[i].slpmsg = NULL;
	}
}

void slp_service_discover_table_add_entry(SLP_SERVICE_DISCOVER_TABLE* table, int stream_id, char* service_type, SLPMSG_PTR slpmsg)
{
	fprintf(stdout, "slp_service_discover_table_add_entry(table->n_services=%d). stream_id=%p \n",table->n_services, stream_id);
	
	table->services[table->n_services].stream_id = stream_id;
	if (service_type != NULL)
		table->services[table->n_services].service_type = strdup(service_type);
	else
		table->services[table->n_services].service_type = NULL;
	table->services[table->n_services].slpmsg = slpmsg;
	table->n_services += 1;
	
	fprintf(stdout, "slp_service_discover_table_add_entry END (table->n_services=%d). stream_id=%p \n",table->n_services, stream_id);
}

int slp_service_discover_table_contains_stream_id(SLP_SERVICE_DISCOVER_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		fprintf(stdout, "slp_service_discover_table_contains_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return 1;
	}
	return 0;
}


void slp_service_discover_table_set_service_type(SLP_SERVICE_DISCOVER_TABLE table, int stream_id, char* service_type)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		if (table.services[i].stream_id == stream_id)
			if (service_type != NULL)
				table.services[i].service_type = strdup(service_type);
			else
				table.services[i].service_type = NULL;
	}
}

SLPMSG_PTR slp_service_discover_table_get_slpmsg_by_service_type(SLP_SERVICE_DISCOVER_TABLE table, char* service_type)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		if (!strcmp(table.services[i].service_type, service_type))
			return table.services[i].slpmsg;
	}
	return NULL;
}

SLPMSG_PTR slp_service_discover_table_get_slpmsg_by_stream_id(SLP_SERVICE_DISCOVER_TABLE table, int stream_id)
{
	int i =0;
	for (i=0 ; i<table.n_services; i++)
	{
		
		fprintf(stdout, "slp_service_discover_table_get_slpmsg_by_stream_id. str1=%p str2=%p\n",table.services[i].stream_id, stream_id);
		if (table.services[i].stream_id == stream_id)
			return table.services[i].slpmsg;
	}
	return NULL;
}
