#include "composer/composer.h"
#include "unit/unit.h"
#include "protocol/wsdlmsg.h"

#include "io/io.h"
#include <stdio.h>
#include "event/eventqueue_table.h"
#include <pthread.h>

MSG_PTR wsdlcomposer_wsdl_reply(char *url,char *nourl)
{
	char *IP = NULL , *PORT = NULL;
	int iPort = 0;
	
	if(strstr(nourl,HTTP_STR) != NULL)
	{
		char *url_extract = (char*)malloc(sizeof(char)*(strlen(nourl)-strlen(HTTP_STR)));
		int index = 0;
		for(index = 0 ; index < (strlen(nourl)-strlen(HTTP_STR)) ; index++)
		{
			url_extract[index] = nourl[index+strlen(HTTP_STR)];
		}
		
		char *token = NULL , seps[] = ":";	
		int counter = 0;
		
		token = strtok( url_extract, seps );
		
		while( token != NULL )
		{
			if(counter == 0 )
				IP = token;
			else
				PORT = token;
			counter++;
			token = strtok( NULL, seps );
		}
		iPort = atoi(PORT);		
	}

	// GET %s HTTP/1.0\r\nHost: %s:%d\r\n\r\n
	char *data=NULL;
	int iSize = 0;
	iSize += strlen("GET ");
	iSize += strlen(url);
	iSize += strlen(" HTTP/1.0Host: ");
	iSize += 2;
	iSize += strlen(IP);
	iSize += 1;
	iSize += strlen(PORT);
	iSize += 4;
	
	data = (char*)malloc(sizeof(char)*(iSize));	
	
	strcpy(data,"GET ");
	strcat(data,url);
	strcat(data," HTTP/1.0\r\nHost: ");
	strcat(data,IP);
	strcat(data,":");
	strcat(data,PORT);
	strcat(data,"\r\n\r\n");
	
	MSG_PTR reply_msg = msg_create(data,strlen(data), get_host_ip(),0, IP, iPort, NULL);
	
	fprintf(stdout, "REPLY_MSG->DATA = %p\n",&reply_msg->data );
	
	return reply_msg;
}
void *wsdl_run_composer(void* ptr)
{
	COMPOSETHREADDATA_PTR data = (COMPOSETHREADDATA_PTR)ptr;
	
	EVENTQUEUE_TABLE_ENTRY_PTR entry = (EVENTQUEUE_TABLE_ENTRY_PTR)data->entry_event_queue;
	COMPOSER_PTR composer = (COMPOSER_PTR)data->composer;	
	
	
	pthread_mutex_lock(&(entry->mutex));
	
	
	
	// Add the identifier of the thread composer to the eventqueue_table 
	pthread_t thread_composer = pthread_self();	
	fprintf(stdout, "wsdl_run_composer: (test length) eventqueue_table_get_composer_thread_list_length(entry=%p event_size=%d) = %d\n", entry,entry->event_queue->size, eventqueue_table_get_composer_thread_list_length(entry));

	if (eventqueue_table_get_composer_thread_list_length(entry) > 1)
	{
		
		// get first composer thread. if different from current compsoer thread, thsi thread must lock fro the mutex of the last 
		// thread of composer_thread_list
		COMPOSERTHREAD_LIST_ENTRY_PTR first_composer_thread  = eventqueue_table_get_first_composer_thread(entry);		
	
		fprintf(stdout, "wsdl_run_composer: first  = %s (entry=%p)\n", first_composer_thread->composer_listener_string, entry);
		
		
		if (first_composer_thread->composer != composer)
		{
			// get last composer thread. ITs reference is used to lock current compsoer thread until the end
			// of the previous composer thread
			COMPOSERTHREAD_LIST_ENTRY_PTR previous_composer_thread  = eventqueue_table_get_secondlast_composer_thread(entry);
			
			fprintf(stdout, "wsdl_run_composer: BEFORE LOCKING on cond var %p\n", &(previous_composer_thread->cond));
	/*		
			struct timeval now;
            struct timespec timeout;
            
            gettimeofday(&now);
            timeout.tv_sec = now.tv_sec + 5;
            timeout.tv_nsec = now.tv_usec * 1000;
            pthread_cond_timedwait(&(previous_composer_thread->cond), &(entry->mutex), &timeout);
      */      

			
			
			pthread_cond_wait(&(previous_composer_thread->cond), &(entry->mutex));
			// lock this thread
			//int lock = eventqueue_table_composer_thread_lock_entry_mutex(previous_composer_thread);
			fprintf(stdout, "wsdl_run_composer: AFTER LOCKING on cond var  %p \n",&(previous_composer_thread->cond));
		} 
			
	}	
	
	char* reply_dest_addr;
	char *nourl,*url;
	int reply_dest_port;
	WSDLMSG *wsdlmsg = wsdlmsg_create(); // TODO : change this to real function			
	
	while (1)
	{
		EVENT_PTR evt = eventqueue_table_get_event(entry);
		
		if (evt != NULL)
		{
			fprintf(stdout,"wsdl_run_composer: evt is type=%d, src=%p\n", evt->type,evt->stream_id);
			event_print(evt);  
			
			switch (evt->type) 
			{
			case SDP_SOURCE_ADDR :
				fprintf(stdout,"wsdl_run_composer: SDP_SOURCE_ADDR\n");				
				reply_dest_addr = strdup(evt->value.value_string);
				break;		
			case SDP_SOURCE_PORT :
				fprintf(stdout,"wsdl_run_composer: SDP_SOURCE_PORT\n");
				reply_dest_port = evt->value.value_int;				
				break;				
			case SDP_SERVICE_RESPONSE :
				fprintf(stdout,"wsdl_run_composer: SDP_SERVICE_RESPONSE\n");
				break;				
			case SDP_SERVICE_DESCR_URL_PATH :
				fprintf(stdout,"wsdl_run_composer: SDP_SERVICE_DESCR_URL_PATH\n");
				url = strdup(evt->value.value_string);				
				break;				
			case SDP_SERVICE_DESCR_URL_NOPATH :
				fprintf(stdout,"wsdl_run_composer: SDP_SERVICE_DESCR_URL_NOPATH\n");
				nourl = strdup(evt->value.value_string);				
				break;								
			case SDP_STOP :								
				fprintf(stdout,"wsdl_run_composer: SDP_STOP url=%s ,nourl=%s\n",url,nourl);				
				if (url != NULL & nourl != NULL)
				{
					MSG_PTR msg = wsdlcomposer_wsdl_reply(url,nourl);
					//MSG_PTR msg = wsdlcomposer_wsdl_reply("/MyService/service.asmx","http://192.168.2.10:4444");
					composer_publish_msg(msg, composer);
					fprintf(stdout, "wsdl_run_composer: (before remove) eventqueue_table_get_composer_thread_list_length(entry=%p) = %d\n",entry, eventqueue_table_get_composer_thread_list_length(entry));
	
	
					COMPOSERTHREAD_LIST_ENTRY_PTR first_composer_thread  = eventqueue_table_remove_first_composer_thread(entry);
					
					// set current_socket_reply_port for ssdp parser to find the right entry on the table
					entry->current_socket_reply_port = first_composer_thread->socket_reply_port;				
					
					pthread_cond_signal(&(first_composer_thread->cond));
					
	
					fprintf(stdout, "wsdl_run_composer: (after remove) eventqueue_table_get_composer_thread_list_length(entry=%p) = %d\n",entry, eventqueue_table_get_composer_thread_list_length(entry));
					
					
					pthread_mutex_unlock(&(entry->mutex));
					
					fprintf(stdout, "wsdl_run_composer: signal cond var %p\n", &(first_composer_thread->cond));
					return;		
				}
				break;
			}				
		}
	}
}
void wsdl_composer_event_received(EVENT_PTR evt, LISTENER_PTR node)
{
	fprintf(stdout,"WSDL");
	composer_event_received(evt, node);
}
COMPOSER_PTR wsdlcomposer_create(UNIT_PTR u)
{
	fprintf(stdout, "Creating WSDL composer\n");		
	
	COMPOSER_PTR c = composer_create(u);

	c->run_composer = wsdl_run_composer;
	c->factory = wsdlcomposer_create;
	c->func_event_received = wsdl_composer_event_received;	
	
	return c;	
}
