/*
 * 
 *             Author  @Youssef Laarouchi : laarouchi_yous@yahoo.fr
 * 
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "engine/graph.h"



/* Fabrique un new NODE */
NODE *
new_node(const char *name,ACTION * entry)
{
  NODE *node= (NODE *) malloc(sizeof(NODE));
  if (node != NULL)
    {
      node->name= strdup(name);
      node->entry=entry;
      if (node->name != NULL)
        {
          node->arcs= NULL;
          node->next= NULL;
        }
      else
        {
          free(node);
          node= NULL;
        }
    }

  return node;
}

/* insert un NODE dans la liste de NODEs du GRAPH */
NODE *
insert_node(GRAPH *graph, NODE *node)
{
  /* Insertion */
  //node->next= graph->nodes;
  //graph->nodes= node;
   
   NODE *node_tmp;
  
   if (graph->nodes==NULL) 
     {
		graph->nodes= node;     
     } else {
     	for(node_tmp=graph->nodes;node_tmp->next!=NULL;node_tmp=node_tmp->next);
     	node_tmp->next=node;
    }
  
  
  return node;
}

NODE *
find_node(const GRAPH *graph, const char *name)
{
  NODE *node;
  //printf("DANS Find_node avec name == |%s| \n",name);	
  for (node= graph->nodes; node != NULL; node= node->next) {
   	//printf("DANS Find_node01 node->name = |%s|\n",node->name);	
    if (strcmp(name, node->name) == 0) {
    	 //printf("DANS Find_node02\n");
      	break;
    }      
  }
//printf("DANS Find_node\n");	
  return node;
}

/* Cherche si un NODE d'apres son name, en creee un new s'il
   n'existe pas */
NODE *
add_node(GRAPH *graph, const char *name,ACTION * entry)
{

	//printf("DANS Add_node\n");	
 	NODE *node= find_node(graph, name);

 	if (node != NULL)
 	{

 		if(entry!=NULL)
 		{
 			node->entry=entry;
 	 	}
 	}
 	else
	{	

    	node= new_node(name,entry);
      	if (node != NULL)
        {

        	graph->n_nodes++;
         	return insert_node(graph, node);
        }
    }
	
	
  return node;
}

void
add_arc(NODE *depart, const NODE *arrivee,char *filter, ACTION* actions)
{
  ARC *arc= (ARC *) malloc(sizeof(ARC));
  ARC *arc_tmp= NULL;
  if (arc != NULL)
    {
      arc->node= (NODE *) arrivee;
      //arc->cost= cost;
      arc->filter=filter;
      arc->actions=actions;
    //  printf("INSERTED LABELS %s :: %s \n",arc->filter,arc->actions->name);
      /* Insertion de l'arc dans la liste des arcs */
      
      //arc->next= depart->arcs;
      //depart->arcs= arc;
      arc->next=NULL;
     
     if (depart->arcs==NULL) 
     {
		depart->arcs=arc;     
     } else {
     	for(arc_tmp=depart->arcs;arc_tmp->next!=NULL;arc_tmp=arc_tmp->next);
     	arc_tmp->next=arc;
    }
      
    }
}



int
stateExists(const GRAPH *graph, const char *name)
{
	NODE *node;
	int result=0;
	//printf("DANS stateExists 01 name = |%s|\n",name);
	for (node= graph->nodes; node != NULL; node= node->next) {
		//printf("DANS stateExists 02 node->name = |%s|\n",node->name);
		if (strcmp(name, node->name) == 0) {
			result =1;
			break;
		}      
	}
	return result;
}



void printGraph(GRAPH * graph) {

NODE * node; 
ARC * arc ;
ACTION * action;

/*
printf("*************************************\n");
for(node=graph->nodes;node!=NULL;node=node->next)
	for(arc=node->arcs;arc!=NULL;arc=arc->next) {
		for(action=arc->actions;action!=NULL;action=action->next_action) {
				printf("%s ---------> %s, filter = '%s' and	 actions = '%s' \n",
					node->name, 
					arc->node->name, 
					arc->filter, action->name);	
				//(* arc->actions->function.function1)(action->name);	
		
				
		}
	}
printf("*************************************\n");
*/

/*
node=graph->nodes;
while(node!=NULL) {
	arc=node->arcs;
	while(arc!=NULL) {
		 printf("depart de %s arrive  %s avec un filtre %s et des actions %s\n",
			node->name,arc->node->name,arc->filter,arc->actions);
		arc->
*/


}






/*
GRAPH *
read_GRAPH(FILE *entree)
{
  int numero_ligne= 0;
  char buffer[BUFSIZ];
  GRAPH *graph= (GRAPH *) malloc(sizeof(GRAPH));

  if (graph != NULL)
    {
      graph->nodes= NULL;
      graph->n_nodes= 0;

      while (fgets(buffer, BUFSIZ, entree))
        {
          char *name1= strtok(buffer, " \n\r");
          char *name2= strtok(NULL, " \n\r");
          char *cost_ch= strtok(NULL, " \n\r");

          numero_ligne++;

          if (name1 != NULL && name2 != NULL)
            {
              NODE *n1, *n2;
              int cost;

              n1= insert_node(graph, name1);
              n2= insert_node(graph, name2);

              if (cost_ch == NULL || sscanf(cost_ch, "%d", &cost) != 1)
                cost= 1;

              add_arc(n1, n2, cost);
            }
          else
            {
              fprintf(stderr, "Ligne %d: erreur de syntaxe\n", numero_ligne);
            }
        }
    }

  return graph;
}

CHEMIN *plus_court= NULL;
int longueur= 0;

void
copie_chemin(const CHEMIN *chemin)
{
  longueur= 0;
  while (chemin)
    {
      // Copie des etapes 
      plus_court[longueur]= *chemin;
      chemin= chemin->next;
      longueur++;
    }
}

*/
/*
void
traite_chemin(const CHEMIN *chemin)
{
  if (longueur == 0 || chemin->cost < plus_court->cost)
    copie_chemin(chemin);
}

void
tous_chemins(const GRAPH *GRAPH, NODE *depart,
             const NODE *arrivee, CHEMIN *chemin, int cost)
{
  CHEMIN etape;
  etape.NODE= depart;
  etape.next= chemin;
  etape.cost= cost;

  if (depart == arrivee)
    {
      traite_chemin(&etape);
    }
  else
    {
      ARC *arc;

      depart->marque= 1;

      for (arc= depart->arcs; arc != NULL; arc= arc->next)
        {
          // Est-on pass par l? 
          if (arc->NODE->marque == 0)
            {
              // Non 
              if (longueur == 0 || etape.cost < plus_court->cost)
                tous_chemins(GRAPH, arc->NODE, arrivee, &etape,
                             cost + arc->cost);
            }
        }

      depart->marque= 0;
    }
}




void
imprime_plus_court(void)
{
  int index;
  for (index= longueur - 1; index >= 0; index--)
    printf("%s %d\n",
           plus_court[index].NODE->name,
           plus_court[index].cost);
}
*/
/*
int
main(int argc, char **argv)
{
  if (argc == 3)
    {
      GRAPH *GRAPH= read_GRAPH(stdin);
      NODE *depart, *arrivee;

      plus_court= (CHEMIN *) calloc(GRAPH->n_NODEs, sizeof(CHEMIN));

      depart= find_NODE(GRAPH, argv[1]);
      
      if (depart == NULL)
        {
          fprintf(stderr, "NODE pas find: %s\n", argv[1]);
          return EXIT_FAILURE;
        }

      arrivee= find_NODE(GRAPH, argv[2]);

      if (arrivee == NULL)
        {
          fprintf(stderr, "NODE pas find: %s\n", argv[2]);
          return EXIT_FAILURE;
        }

      tous_chemins(GRAPH, depart, arrivee, NULL, 0);

      imprime_plus_court();

      return EXIT_SUCCESS;
    }
  else
    {
      fprintf(stderr, "GRAPH <depart> <arrivee>\n");
      return EXIT_FAILURE;
    }
}*/
