#include "event/eventqueue_table.h"
#include "composer/composer.h"
#include "socket/socket.h"
#include <stdio.h>

EVENTQUEUE_TABLE_PTR eventqueue_table_create()
{
	EVENTQUEUE_TABLE_PTR table = malloc(sizeof(EVENTQUEUE_TABLE));
	table->table = NULL;
	table->size = 0;
	return table;
}

/*
typedef struct eventqueue_table_entry 
{
	void* event_src_request; //event_src_id
	void* thread_composer;
	
	int socket_port;
	
	EVENTQUEUE_PTR event_queue;
	
	struct eventqueue_table_entry*  next;
	
} EVENTQUEUE_TABLE_ENTRY;
typedef EVENTQUEUE_TABLE_ENTRY* EVENTQUEUE_TABLE_ENTRY_PTR;
*/

EVENTQUEUE_TABLE_ENTRY_PTR eventqueue_table_add_entry(EVENTQUEUE_TABLE_PTR table, int stream_id , int sub_stream_id /*, void* thread_composer*/)
{
	EVENTQUEUE_TABLE_ENTRY_PTR entry = malloc(sizeof(EVENTQUEUE_TABLE_ENTRY));

	
	pthread_mutex_init(&(entry->mutex), NULL);
	
	entry->stream_id = stream_id;
	entry->sub_stream_id = sub_stream_id;

	entry->composers_threads_list = NULL;
//	entry->socket_reply_port = -1;
	
	entry->event_queue = malloc(sizeof(EVENTQUEUE));
	entry->event_queue->queue = NULL;
	entry->event_queue->size = 0;
	
	
	
	entry->next = NULL;
	
	if (table->table == NULL)
	{
		table->table = entry;
		table->size = 1;
	}
	else
	{
		entry->next = table->table;
		table->table = entry;
		table->size++;
	}
	return entry;
}

EVENTQUEUE_TABLE_ENTRY_PTR eventqueue_table_copy_entry(EVENTQUEUE_TABLE_PTR table, EVENTQUEUE_TABLE_ENTRY_PTR entry_tmp)
{
	/*
	 * 	
	 int stream_id; 
	int sub_stream_id;
		pthread_mutex_t mutex;
	int current_socket_reply_port;
	struct eventqueue_table_entry*  next;	
	EVENTQUEUE_PTR event_queue;	
	
	
	COMPOSERTHREAD_LIST_ENTRY_PTR composers_threads_list;
	 */
	
	EVENTQUEUE_TABLE_ENTRY_PTR entry = malloc(sizeof(EVENTQUEUE_TABLE_ENTRY));

	pthread_mutex_init(&(entry->mutex), NULL);
	entry->stream_id = entry_tmp->stream_id;
	entry->sub_stream_id = entry_tmp->sub_stream_id;
	entry->current_socket_reply_port = entry_tmp->current_socket_reply_port;
	

	// copy envent queue
	entry->event_queue = malloc(sizeof(EVENTQUEUE));
	entry->event_queue->queue = NULL;
	entry->event_queue->size = 0;
	
	EVENTQUEUE_ENTRY_PTR event_entry_tmp;
	for (event_entry_tmp = entry->event_queue->queue;  event_entry_tmp != NULL; event_entry_tmp = event_entry_tmp->next)
	{
		EVENT_PTR evt_tmp = event_entry_tmp->evt;
		eventqueue_table_enqueue_event(entry, evt_tmp);
	}
	
	// copy composer_threads
	entry->composers_threads_list = NULL;
	COMPOSERTHREAD_LIST_ENTRY_PTR composers_threads_list_tmp;
	for (composers_threads_list_tmp = entry_tmp->composers_threads_list;  composers_threads_list_tmp != NULL; 
				composers_threads_list_tmp = composers_threads_list_tmp->next)
	{
		COMPOSER_PTR composer = composers_threads_list_tmp->composer->factory(composers_threads_list_tmp->composer->unit);
		
		SOCKET_PTR socket_reply;
		
		if (composers_threads_list_tmp->socket_reply != NULL)
		{
			socket_reply  = composers_threads_list_tmp->socket_reply->factory(composers_threads_list_tmp->socket_reply->unit);
			socket_set_localport(socket_reply, socket_get_localport(composers_threads_list_tmp->socket_reply));
			
			// if socket_reply has got any parser that listens to msg published by the socket, 
			// then create the parsers and add as socket's msg listeners
			if (composers_threads_list_tmp->socket_reply->msg_listeners != NULL)
			{
				fprintf(stdout, "\neventqueue_table_copy_entry: socket_Reply  msg_listeners != NULL\n");
				LISTENER_LIST_ENTRY_PTR listeners;
				for (listeners=composers_threads_list_tmp->socket_reply->msg_listeners; listeners!=NULL; listeners=listeners->next)
				{
					fprintf(stdout, "\neventqueue_table_copy_entry: socket_Reply  msg_listeners != NULL - 2 \n");
					if (listeners->node->type == LISTENER_PARSER)
					{
						fprintf(stdout, "\neventqueue_table_copy_entry: socket_Reply  msg_listeners != NULL - 3 PARSER \n");
						
						PARSER_PTR parser = listeners->node->listener.parser->factory(listeners->node->listener.parser->unit);
						socket_add_msglistener_parser(socket_reply, parser);
						parser_add_evtlistener_unit(parser, parser->unit);
					}
					else 
						if (listeners->node->type == LISTENER_UNIT)
						{
							fprintf(stdout, "\neventqueue_table_copy_entry: socket_Reply  msg_listeners != NULL - 3 UNIT \n");
						}
				}
			}
			
			// add the socket to the list of the composer's msg_listeners
			composer_add_msglistener_socket(composer, socket_reply);
		} else
			socket_reply  = NULL;
		
		eventqueue_table_add_composer_thread(entry, composers_threads_list_tmp->composer_listener_string, composer,
			socket_reply, composers_threads_list_tmp->socket_reply_port );
		

		
		// launch the thread of the composer to receive the events generated by the unit
		pthread_t composer_thread;
		COMPOSETHREADDATA_PTR data = malloc(sizeof(COMPOSETHREADDATA));
		data->entry_event_queue = (EVENTQUEUE_TABLE_ENTRY_PTR)entry;
		data->composer = composer;
		fprintf(stdout, "\nCREATING PTHREAD composer (%s)= %p\n", composers_threads_list_tmp->composer_listener_string, composer_thread);
			

		pthread_create(&composer_thread, NULL, composer->run_composer, (void*)data);
	}
	
	entry->next = NULL;
	
	if (table->table == NULL)
	{
		table->table = entry;
		table->size = 1;
	}
	else
	{
		entry->next = table->table;
		table->table = entry;
		table->size++;
	}
	return entry;
}

/*
int eventqueue_table_contain_entry(EVENTQUEUE_TABLE_PTR table, int stream_id, void* thread_composer)
{
	EVENTQUEUE_TABLE_ENTRY_PTR entry; 
	for (entry = table->table; entry != NULL; entry = entry->next)
	{
		if (entry->stream_id == stream_id && entry->composer_evtlistener_thread == thread_composer)
			return 1;		
	}
	return 0;
}
*/

int eventqueue_table_contain_entry_event_src(EVENTQUEUE_TABLE_PTR table, int stream_id)
{
	EVENTQUEUE_TABLE_ENTRY_PTR entry; 
	for (entry = table->table; entry != NULL; entry = entry->next)
	{
		if (entry->stream_id == stream_id)
			return 1;		
	}
	return 0;
}

EVENTQUEUE_TABLE_ENTRY_PTR eventqueue_table_get_entry_by_stream_id(EVENTQUEUE_TABLE_PTR table, int stream_id)
{
	if (table != NULL)
	{
		EVENTQUEUE_TABLE_ENTRY_PTR entry; 
		for (entry = table->table; entry != NULL; entry = entry->next)
		{
			if (entry->stream_id == stream_id)
				return entry;		
		}
	}
	return NULL;
}

EVENTQUEUE_TABLE_ENTRY_PTR eventqueue_table_get_entry_by_sub_stream_id(EVENTQUEUE_TABLE_PTR table, int sub_stream_id)
{
	if (table != NULL)
	{
		EVENTQUEUE_TABLE_ENTRY_PTR entry; 
		for (entry = table->table; entry != NULL; entry = entry->next)
		{
			if (entry->sub_stream_id == sub_stream_id)
				return entry;		
		}
	}
	return NULL;
}


EVENTQUEUE_TABLE_ENTRY_PTR eventqueue_table_get_entry_by_current_socket_reply_port(EVENTQUEUE_TABLE_PTR table, int socket_reply_port)
{
	if (table != NULL)
	{
		EVENTQUEUE_TABLE_ENTRY_PTR entry; 
		for (entry = table->table; entry != NULL; entry = entry->next)
		{
			//COMPOSERTHREAD_LIST_ENTRY_PTR composer_thread = eventqueue_table_get_first_composer_thread(entry);
			fprintf(stdout, " ENTRY PORT = %d\n", entry->current_socket_reply_port);
			if (entry->current_socket_reply_port == socket_reply_port)
				return entry;		
		}
	}
	return NULL;
}




/*
EVENTQUEUE_TABLE_ENTRY_PTR eventqueue_table_get_entry(EVENTQUEUE_TABLE_PTR table, int stream_id, void* thread_composer)
{
	EVENTQUEUE_TABLE_ENTRY_PTR entry; 
	for (entry = table->table; entry != NULL; entry = entry->next)
	{
		if (entry->stream_id == stream_id && entry->composer_evtlistener_thread == thread_composer)
			return entry;		
	}
	return NULL;
}
*/

void eventqueue_table_enqueue_event(EVENTQUEUE_TABLE_ENTRY_PTR entry, EVENT_PTR evt)
{	
	EVENTQUEUE_ENTRY_PTR event_queue_entry = malloc(sizeof(EVENTQUEUE_ENTRY));
	//event_queue_entry->evt = evt;
	event_queue_entry->evt = malloc(sizeof(EVENT));
	memcpy(event_queue_entry->evt, evt, sizeof(EVENT));
	event_queue_entry->next = NULL;
	
	if (entry->event_queue->queue == NULL)
	{
		entry->event_queue->queue = event_queue_entry;
		entry->event_queue->size = 1;
	}
	else
	{
		EVENTQUEUE_ENTRY_PTR entry_tmp;
		for (entry_tmp = entry->event_queue->queue; entry_tmp->next !=NULL; entry_tmp = entry_tmp->next) ;
		entry_tmp->next = event_queue_entry;
		entry->event_queue->size++;
	}
}

/*
void eventqueue_table_enqueue_event(EVENTQUEUE_TABLE_PTR table, void* event_src_request, void* thread_composer, EVENT_PTR evt)
{
	EVENTQUEUE_TABLE_ENTRY_PTR entry = eventqueue_table_get_entry(table, event_src_request, thread_composer);
	
	EVENTQUEUE_ENTRY_PTR event_queue_entry = malloc(sizeof(EVENTQUEUE_ENTRY));
	event_queue_entry->evt = evt;
	event_queue_entry->next = NULL;
	
	if (entry->event_queue->queue == NULL)
	{
		entry->event_queue->queue = event_queue_entry;
		entry->event_queue->size = 1;
	}
	else
	{
		EVENTQUEUE_ENTRY_PTR entry_tmp;
		for (entry_tmp = entry->event_queue->queue; entry_tmp->next !=NULL; entry_tmp = entry_tmp->next) ;
		entry_tmp->next = event_queue_entry;
		entry->event_queue->size++;
	}
}
*/


EVENT_PTR eventqueue_table_get_event(EVENTQUEUE_TABLE_ENTRY_PTR entry)
{
	if (entry != NULL && entry->event_queue->size > 0) 
	{
		entry->event_queue->size--;
		EVENT_PTR evt = entry->event_queue->queue->evt;
		entry->event_queue->queue = entry->event_queue->queue->next;
		return evt;
	}
	return NULL;
}

/*
EVENT_PTR eventqueue_table_get_event(EVENTQUEUE_TABLE_PTR table, void* event_src_request, void* thread_composer)
{
	EVENTQUEUE_TABLE_ENTRY_PTR entry = eventqueue_table_get_entry(table, event_src_request, thread_composer);
	
	if (entry->event_queue->size > 0) 
	{
		entry->event_queue->size--;
		EVENT_PTR evt = entry->event_queue->queue->evt;
		entry->event_queue->queue = entry->event_queue->queue->next;
		return evt;
	}
	return NULL;
}
*/

int eventqueue_table_get_sub_stream_ids_by_stream_id(EVENTQUEUE_TABLE_PTR table, int stream_id, int* n_sub_stream_ids, int* sub_stream_ids)
{
	if (table == NULL)
	{
		*n_sub_stream_ids = 0;
		sub_stream_ids = NULL;
		return 0;
	}
	
	
	EVENTQUEUE_TABLE_ENTRY_PTR entry; 
	
	// count the number of sub_stream_ids matching stream_id
	*n_sub_stream_ids = 0;
	for (entry = table->table; entry != NULL; entry = entry->next)
	{
		if (entry->stream_id == stream_id)
			(*n_sub_stream_ids)++;		
	}
	
	// fill in an array containing the sub_stream_ids matching stream_id
	if (*n_sub_stream_ids > 0)
	{
		sub_stream_ids = malloc(sizeof(int)*(*n_sub_stream_ids));	
		int i = 0;
		for (entry = table->table; entry != NULL; entry = entry->next)
		{
			if (entry->stream_id == stream_id)
			{
				*(sub_stream_ids+i) = entry->sub_stream_id;
				i++;
			}
		}
		return 1;
	}
	else
	{
		sub_stream_ids = NULL;
		return 0;
	}
}
int eventqueue_table_get_stream_id_by_sub_stream_id(EVENTQUEUE_TABLE_PTR table, int sub_stream_id, int* stream_id)
{
	if (table != NULL)
	{
		EVENTQUEUE_TABLE_ENTRY_PTR entry; 
		for (entry = table->table; entry != NULL; entry = entry->next)
		{
			if (entry->sub_stream_id == sub_stream_id)
			{
				*stream_id = entry->stream_id;
				return 1;
			}
		}
	}
	return 0;
}

void eventqueue_table_print(EVENTQUEUE_TABLE_PTR table)
{
	fprintf(stdout,"\nTABLE event queue. size = %d\n",table->size);
	EVENTQUEUE_TABLE_ENTRY_PTR entry; 
	for (entry = table->table; entry != NULL; entry = entry->next)
	{
		int length = eventqueue_table_get_composer_thread_list_length(entry);
		fprintf(stdout,"\nTABLE ENTRY: stream_id = %p, sub_stream_id = %p,  length thread_compose_listr=%d, size_events=%d\n", entry->stream_id, entry->sub_stream_id, length, entry->event_queue->size);
		
	}
}



/*
void eventqueue_table_add_composer_thread(EVENTQUEUE_TABLE_ENTRY_PTR entry, pthread_t composer_thread_evtlistener)
{
	COMPOSERTHREAD_LIST_ENTRY_PTR entry_composer = malloc(sizeof(COMPOSERTHREAD_LIST_ENTRY));
	entry_composer->composer_thread_evtlistener = composer_thread_evtlistener;
	entry_composer->next = NULL;
	
	if (entry->composers_threads_list == NULL)
	{
		entry->composers_threads_list = entry_composer;
	}
	else
	{
		COMPOSERTHREAD_LIST_ENTRY_PTR entry_composer_tmp = NULL;
		for (entry_composer_tmp = entry->composers_threads_list; entry_composer_tmp->next != NULL; 
			entry_composer_tmp = entry_composer_tmp->next) ;
			
		entry_composer_tmp->next = entry_composer;
	}
}

pthread_t eventqueue_table_get_last_composer_thread(EVENTQUEUE_TABLE_ENTRY_PTR entry)
{
	if (entry->composers_threads_list == NULL)
	{
		return (pthread_t)NULL;
	}
	else
	{
		COMPOSERTHREAD_LIST_ENTRY_PTR entry_composer_tmp = NULL;
		for (entry_composer_tmp = entry->composers_threads_list; entry_composer_tmp->next != NULL; 
			entry_composer_tmp = entry_composer_tmp->next) ;
			
		return entry_composer_tmp->composer_thread_evtlistener;
	}		
}

pthread_t eventqueue_table_get_first_composer_thread(EVENTQUEUE_TABLE_ENTRY_PTR entry)
{
	if (entry->composers_threads_list == NULL)
	{
		return (pthread_t)NULL;
	}
	else
	{
		pthread_t composer = entry->composers_threads_list->composer_thread_evtlistener;
		return composer; 
	}	
}

pthread_t eventqueue_table_remove_first_composer_thread(EVENTQUEUE_TABLE_ENTRY_PTR entry)
{
	if (entry->composers_threads_list == NULL)
	{
		return (pthread_t)NULL;
	}
	else
	{
		pthread_t composer = entry->composers_threads_list->composer_thread_evtlistener;
		entry->composers_threads_list = entry->composers_threads_list->next;
		return composer; 
	}	
}

int eventqueue_table_get_composer_thread_list_length(EVENTQUEUE_TABLE_ENTRY_PTR entry)
{
	int count = 0;
	
	COMPOSERTHREAD_LIST_ENTRY_PTR entry_composer_tmp = NULL;
	for (entry_composer_tmp = entry->composers_threads_list; entry_composer_tmp != NULL; 
			entry_composer_tmp = entry_composer_tmp->next) 
		count ++;

	return count;
}


int eventqueue_table_lock_entry_mutex(EVENTQUEUE_TABLE_ENTRY_PTR entry)
{
	pthread_mutex_lock(&(entry->mutex));
}

int eventqueue_table_unlock_entry_mutex(EVENTQUEUE_TABLE_ENTRY_PTR entry)
{
	pthread_mutex_unlock(&(entry->mutex));
}
*/






void eventqueue_table_add_composer_thread(EVENTQUEUE_TABLE_ENTRY_PTR entry, char* composer_listener_string, struct composer* composer,
		struct socket* socket_reply, int socket_reply_port /*, pthread_cond_t* cond*/)
{

	COMPOSERTHREAD_LIST_ENTRY_PTR entry_composer = malloc(sizeof(COMPOSERTHREAD_LIST_ENTRY));
	//entry_composer->composer_thread_evtlistener = composer_thread_evtlistener;
	entry_composer->composer = composer;
	fprintf(stdout, "eventqueue_table_add_composer_thread 1. socket_reply_port=%d\n",socket_reply_port);
	entry_composer->composer_listener_string = strdup(composer_listener_string);
	fprintf(stdout, "eventqueue_table_add_composer_thread 2. socket_reply_port=%d\n",entry_composer->socket_reply_port);
	entry_composer->socket_reply = socket_reply;
	fprintf(stdout, "eventqueue_table_add_composer_thread 3. socket_reply_port=%d\n",entry_composer->socket_reply_port);
	entry_composer->socket_reply_port = socket_reply_port;
	fprintf(stdout, "eventqueue_table_add_composer_thread 4. socket_reply_port=%d\n",entry_composer->socket_reply_port);
	
	pthread_cond_t cond;
	pthread_cond_init(&cond, NULL);
	entry_composer->cond = cond;
	
	entry_composer->next = NULL;
	
	if (entry->composers_threads_list == NULL)
	{
		fprintf(stdout, "eventqueue_table_add_composer_thread 5. socket_reply_port=%d\n",entry_composer->socket_reply_port);
		entry->composers_threads_list = entry_composer;
	}
	else
	{
		fprintf(stdout, "eventqueue_table_add_composer_thread 6. socket_reply_port=%d\n",entry_composer->socket_reply_port);
		COMPOSERTHREAD_LIST_ENTRY_PTR entry_composer_tmp = NULL;
		for (entry_composer_tmp = entry->composers_threads_list; entry_composer_tmp->next != NULL; 
			entry_composer_tmp = entry_composer_tmp->next) ;
			
		entry_composer_tmp->next = entry_composer;
	}
}

COMPOSERTHREAD_LIST_ENTRY_PTR eventqueue_table_get_last_composer_thread(EVENTQUEUE_TABLE_ENTRY_PTR entry)
{
	if (entry->composers_threads_list == NULL)
	{
		return (COMPOSERTHREAD_LIST_ENTRY_PTR)NULL;
	}
	else
	{
		COMPOSERTHREAD_LIST_ENTRY_PTR entry_composer_tmp = NULL;
		for (entry_composer_tmp = entry->composers_threads_list; entry_composer_tmp->next != NULL; 
			entry_composer_tmp = entry_composer_tmp->next) ;
			
		return entry_composer_tmp;
	}		
}

COMPOSERTHREAD_LIST_ENTRY_PTR eventqueue_table_get_secondlast_composer_thread(EVENTQUEUE_TABLE_ENTRY_PTR entry)
{
	if (entry->composers_threads_list == NULL)
	{
		return (COMPOSERTHREAD_LIST_ENTRY_PTR)NULL;
	}
	else
	{
		COMPOSERTHREAD_LIST_ENTRY_PTR entry_composer_tmp = NULL;
		for (entry_composer_tmp = entry->composers_threads_list; entry_composer_tmp->next != NULL && entry_composer_tmp->next->next != NULL; 
			entry_composer_tmp = entry_composer_tmp->next) ;
			
		return entry_composer_tmp;
	}		
}

COMPOSERTHREAD_LIST_ENTRY_PTR eventqueue_table_get_first_composer_thread(EVENTQUEUE_TABLE_ENTRY_PTR entry)
{
	if (entry->composers_threads_list == NULL)
	{
		return (COMPOSERTHREAD_LIST_ENTRY_PTR)NULL;
	}
	else
	{
		return entry->composers_threads_list;
	}	
}

COMPOSERTHREAD_LIST_ENTRY_PTR eventqueue_table_remove_first_composer_thread(EVENTQUEUE_TABLE_ENTRY_PTR entry)
{
	if (entry->composers_threads_list == NULL)
	{
		return (COMPOSERTHREAD_LIST_ENTRY_PTR)NULL;
	}
	else
	{
		COMPOSERTHREAD_LIST_ENTRY_PTR elem = entry->composers_threads_list;
		entry->composers_threads_list = entry->composers_threads_list->next;
		return elem; 
	}	
}

int eventqueue_table_get_composer_thread_list_length(EVENTQUEUE_TABLE_ENTRY_PTR entry)
{
	int count = 0;
	
	COMPOSERTHREAD_LIST_ENTRY_PTR entry_composer_tmp = NULL;
	for (entry_composer_tmp = entry->composers_threads_list; entry_composer_tmp != NULL; 
			entry_composer_tmp = entry_composer_tmp->next)
	{
		count ++;

		fprintf(stdout, "eventqueue_table_get_composer_thread_list_length(%d): = %s,  %p\n", count, entry_composer_tmp->composer_listener_string, entry_composer_tmp->composer);
		
	}
	
	return count;
}

/*
int eventqueue_table_composer_thread_lock_entry_mutex(COMPOSERTHREAD_LIST_ENTRY_PTR composer)
{
	pthread_mutex_lock(composer->mutex);
}

int eventqueue_table_composer_thread_unlock_entry_mutex(COMPOSERTHREAD_LIST_ENTRY_PTR composer)
{
	pthread_mutex_unlock(composer->mutex);
}
*/
