#include "msg/msg.h"
#include <stdio.h>

MSG_PTR msg_create(char* data, int length, char* src_addr, int src_port, char* dest_addr, int dest_port, void* src)
{
	
	fprintf(stdout, "msg_create: before malloc MSGPTR (%d)\n",sizeof(MSG));
	MSG_PTR msg = (MSG_PTR)malloc(sizeof(MSG));

	msg->length = length;
	//msg->data = malloc(strlen(data));
	//strcpy(msg->data, data);
	fprintf(stdout, "msg_create: before malloc MSG->data\n");
	//msg->data = (char*)malloc(length*sizeof(char));
	msg->data = (char*)calloc(length, sizeof(char));
	fprintf(stdout, "msg_create: after malloc MSG->data\n");
	memcpy(msg->data, data, length);
	fprintf(stdout, "msg_create: after memcpy MSG->data\n");
		
	msg->src_port = src_port;
	
	if (src_addr == NULL)
		msg->src_address = NULL;
	else {
		msg->src_address = malloc(strlen(src_addr)+1);
		strcpy(msg->src_address, src_addr);
	}
	
	msg->dest_port = dest_port;
	
	if (dest_addr == NULL)
		msg->dest_address = NULL;
	else
	{
		msg->dest_address = malloc(strlen(dest_addr)+1);
		strcpy(msg->dest_address, dest_addr);
	}
	
	msg->src = src;
	msg->src_socket_id = -1;
	
	return msg;
}

MSG_PTR msg_create_sock_id(char* data, int length, char* src_addr, int src_port, char* dest_addr, int dest_port, int src_socket_id, void* src)
{
	MSG_PTR m = msg_create(data, length, src_addr, src_port, dest_addr, dest_port, src);
	m->src_socket_id = src_socket_id;
	return m;
}

void msg_free(MSG_PTR msg)
{
	//free(msg->data);
	free(msg->dest_address);
	free(msg->src_address);
	free(msg);
}
