#include "parser/parser.h"
#include "unit/unit.h"
#include "parser/JRMPParser.h"
#include "composer/JRMPComposer.h"
#include <ser/classdescription.h>
#include "protocol/rmi.h"

#include "monitor/tools.h"

j_long calc_method_hash(char* hash_method_name);
//char* get_method_signature(ARGUMENTDEFPTR args, char* returnType);

/*
 *  used to make RMI calls on rmiholders.XHolder.setValue() on RMI clients to modify their values
 */
int composeJRMP_Call_on_RMIObject(OBJECTDESCPTR obj, ARGUMENTDEFPTR argument) {
	
	fprintf(stdout, "composeJRMP_Call_on_RMIObject. Addr=%s, port=%d",obj->ip, obj->port);
    int fd = (open_fd_client(obj->ip, obj->port));

    writeJRMPHeader(fd);
    
    j_long objNum = obj->objNum;
    j_int unique = obj->unique;
    j_long time = obj->time;
    j_short count = obj->count;

	//write code
    j_byte code = Call;
	writejByte(fd, code);
    fprintf(stdout,"Code: %x=Call\n",code);
	

    METHODDEFPTR method  = methoddef_new(NULL);
   	methoddef_set_name(method, "setValue");
  	ARGUMENTDEFPTR arg = argumentdef_new();
	argumentdef_set_name(arg, "value");
	
	char type[50];
	if (strstr(argument->datatype, "boolean") != NULL || strstr(argument->datatype, "Boolean") != NULL)
		strcpy(type, "java/lang/Boolean");
	else if (strstr(argument->datatype, "int") != NULL || strstr(argument->datatype, "Int") != NULL)
		strcpy(type,  "java/lang/Integer");
	else if (strstr(argument->datatype, "string") != NULL || strstr(argument->datatype, "String") != NULL)
		strcpy(type,  "java/lang/String");
	else
		strcpy(type, "");
	
	fprintf(stdout, "\nargument->datatype = %s\n",type);
	if (strcmp(type, ""))
	{
		argumentdef_set_datatype(arg, type);
	    argumentdef_set_index(arg, ARG_IN);
	    methoddef_add_argument(method, arg); 
	    
	    
	    char* methSignature = get_method_signature(method->args, "V");
	    char hash_method_name[1000];
	    strcpy(hash_method_name, method->name);
	    strcat(hash_method_name, methSignature);
	    
	    //makeRMICall(fdOut, objNum, unique,  time,  count , hash_method_name); 
	
		//	length= 34 bytes for packet without any Arguments
		/* 
		 * objNum, unique, time, count must correspond
		 * exactly to the values associated to the remote
		 * object and provided by RMI registry lookup call
		 * otherwise a NoSuchObjectException is raised
		 *
		 *			
		 */
		writeJRMP_ObjID(fd, 34, objNum, unique, time, count);
	
				
		//Parsing du numero de l'operation
		//Si <0 alors jdk1.2
		//Si >0 alors jdk1.1		
		
		//j_int opNum = -1; //jdk1.2
		j_int opNum = -1; //jdk 1.1
		writejInt(fd, opNum);		
		//j_long hash = -7538657168040752697ULL;  //jdk1.2
		//j_long hash = 6789062971934848498ULL; // --> t() : no args
		//j_long hash = -8053588565580120904ULL; // titi() : 3 integers args
	
	
		j_long calcHash = calc_method_hash(hash_method_name);
		writejLong(fd, calcHash);
	
		
		OBJECTDESCPTR obj_ptr = malloc(sizeof(OBJECTDESC));
		obj_ptr->classDescr = malloc(sizeof(CLASSDESC));
		obj_ptr->classDescr->id = 10;
		
		char type_tmp[50];
		replace_slash_with_dot(type, type_tmp);
		obj_ptr->classDescr->name = type_tmp; //"java.lang.Boolean";
		obj_ptr->classDescr->sizeField = 1;
		
		//obj_ptr->classDescr->serial = RMIHOLDER_BOOLEAN_SETVALUE_SERIAL; //1360826667806852920L; //RMIHOLDER_SETVALUE_SERIAL; //-3665804199014368530L; //4550814117179556397ULL; /2; //-2440459149728079141; //4550814117179556397ULL;
		obj_ptr->classDescr->flag = SC_SERIALIZABLE  ;
		obj_ptr->classDescr->superClass = NULL;
		
		SER_FIELDPTR fields = malloc(sizeof(SER_FIELD) * obj_ptr->classDescr->sizeField);
		fields[0].name = strdup("value");

		char t;
		if (!strcmp(type, "java/lang/Boolean"))
		{
			obj_ptr->classDescr->serial = RMIHOLDER_BOOLEAN_SETVALUE_SERIAL;
			
			fields[0].type_code = 'Z';
			fields[0].value.boolean_value = atoi(argument->value);
			fields[0].class_name = NULL;
		}
		else if (!strcmp(type, "java/lang/Integer"))
		{
			obj_ptr->classDescr->serial = RMIHOLDER_INTEGER_SETVALUE_SERIAL;
			
			fields[0].type_code  = 'I';
			fields[0].value.int_value = atoi(argument->value);
			fields[0].class_name = NULL;
		}
		else if (!strcmp(type, "java/lang/String"))
		{
			obj_ptr->classDescr->serial = RMIHOLDER_STRING_SETVALUE_SERIAL;
			
			fprintf(stdout,"\targument->value= %s",argument->value);
			fields[0].type_code  = 'L';
			fields[0].value.string_value = strdup(argument->value);
			fields[0].class_name = "java.lang.String";
			fprintf(stdout,"\fields[0].value.string_value =  %s",fields[0].value.string_value);
			/*fields[0].type_code  = 'I';
			fields[0].value.int_value = 4;
			fields[0].class_name = NULL;*/

		}
		
		
		// fixed value for rmiholder.BooleanHolder.setValue(1)
		
		
		obj_ptr->classDescr->field = fields;
		
		
		composeObjectOutputStream(fd, obj_ptr);
		
				
		// if I dont write a final zero-byte after the end of the stream (not required in specifications)
		// the last byte of the return value of the RMI call is not read from the return stream
		//writejByte(fd, 0);
	    
		   parseJRMP_receiveStub_Return(fd);
		   parseJRMP_receiveStub_Header(fd);
	
		   parseJRMP_receiveStub_BLOCKDATA(fd);
	
		   parseJRMP_receiveStub_RemotePort(fd);
	
		   parseJRMP_receiveStub_NormalReturn(fd);
		   
	
		   
		j_int ret_unique;
	    j_long ret_time;
	    j_short ret_count;
	
	    parsejInt(fd, &ret_unique);
	    parsejLong(fd, &ret_time);
	    //parsejShort(fd, &ret_unique);
	    parsejShort(fd, &ret_count);
	    
	    fprintf(stdout,"\tunique= %i / ret_unique=%i\n",unique, ret_unique);
	    fprintf(stdout,"\ttime= %llu / ret_time=%llu\n",time, ret_time);
	    fprintf(stdout,"\tcount= %i / ret_count=%i\n",count , ret_count);
		
	    /*
	     *	USED TO PARSE EXCEPTION 
	     */
	    fprintf(stdout,"\t\nPARSE 1st OBJECT STREAM\n\n");
	  parseObjectOutputStream(fd);	
	  fprintf(stdout,"\t\nPARSE 2nd OBJECT STREAM\n\n");
	  parseObjectOutputStream(fd);
	  fprintf(stdout,"\t\nPARSE 3rd OBJECT STREAM\n\n");
	  parseObjectOutputStream(fd);	
	  fprintf(stdout,"\t\nPARSE 4th OBJECT STREAM\n\n");
	  parseObjectOutputStream(fd);	
	
	  
		int ind_x1;
		j_byte x1;
		for (ind_x1 = 0; ind_x1 < 40; ind_x1++ )
		{
			parsejByte(fd, &x1);
			fprintf(stdout,"\nread=>%02x",x1&0xff);
		}

	}
	//fflush(stdout);	
    
}

void jrmp_parse_msg(PARSER_PTR parser, MSG_PTR message , EVENTSRC_PTR evt_src)
{
	char* msg = message->data;
	int len = message->length;	

//	jrmp_processEvents(parser, evt_src, message);
}




void jrmp_processEvents(PARSER_PTR parser, EVENTSRC_PTR evt_src, METHODDEFPTR method, char* service_path)
{	
	fprintf(stdout, "\njrmp_processEvents start\n");
	int evt_stream_id = (int)(evt_src->src_thread_parser);
	parser_publish_event(event_create(SDP_START,evt_stream_id,(void*)evt_src), parser);	
	parser_publish_event(event_create(SCP_RMI,evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create_string(SCP_SERVICE_NAME, service_path, evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create(SCP_REQUEST,evt_stream_id, (void*)evt_src), parser);
	
	parser_publish_event(event_create_string(SCP_METHOD_NAME, method->name, evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create_string(SCP_METHOD_NAMESPACE, method->namespace, evt_stream_id, (void*)evt_src), parser);
	
	ARGUMENTDEFPTR args1_tmp = method->args;
    while (args1_tmp != NULL)
    {
    	if (args1_tmp->dir == ARG_IN)
    		parser_publish_event(event_create_void_pointer(SCP_ARGUMENT_IN, args1_tmp, evt_stream_id, (void*)evt_src), parser);
    	else if (args1_tmp->dir == ARG_OUT)
    		parser_publish_event(event_create_void_pointer(SCP_ARGUMENT_OUT, args1_tmp, evt_stream_id, (void*)evt_src), parser);
    	args1_tmp = args1_tmp->next;
    }
    
    
//	parser_publish_event(event_create_string(SDP_SOURCE_ADDR, message->src_address/*wsdmsg_get_src_addr(wsdmsg)*/,evt_stream_id, (void*)evt_src), parser);
//	parser_publish_event(event_create_int(SDP_SOURCE_PORT, message->src_port /*wsdmsg_get_src_port(wsdmsg)*/,evt_stream_id, (void*)evt_src), parser);
	
//	parser_publish_event(event_create_string(SCP_SERVICE_NAME, "/washer_rmislp.WasherImpl/control", evt_stream_id, (void*)evt_src), parser);

	
	parser_publish_event(event_create(SDP_STOP,evt_stream_id, (void*)evt_src), parser);
	
	fprintf(stdout, "\njrmp_processEvents stop\n");
}	


int parseJRMP_MethodCall(PARSER_PTR parser, EVENTSRC_PTR evt_src, int fd, METHODDEFPTR method_from_servicedef, char* service_path)
{
	
	int evt_stream_id = (int)(evt_src->src_thread_parser);
	parser_publish_event(event_create(SDP_START,evt_stream_id,(void*)evt_src), parser);	
	parser_publish_event(event_create(SCP_RMI,evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create_string(SCP_SERVICE_NAME, service_path, evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create(SCP_REQUEST,evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create_string(SCP_METHOD_NAME, method_from_servicedef->name, evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create_string(SCP_METHOD_NAMESPACE, method_from_servicedef->namespace, evt_stream_id, (void*)evt_src), parser);
	
	// Parse argument of the RMI call
	int nargs = method_from_servicedef->nArgs;
	int index_arg = 0;
	while (1)
	{
		OBJECTDESCPTR obj = (OBJECTDESCPTR)parseObjectOutputStream(fd);
		fprintf(stdout, "Object read: name=%s, class=%s\n", obj->name,obj->classDescr->name);
		if (!strcmp(obj->classDescr->name, "java.lang.Integer"))
		{
			
			j_int value;
			//parsejInt(fd, &value);
			value = obj->classDescr->field[0].value.int_value;
			fprintf(stdout,"Int read => %d\n",value&0xffffffff);
			
	    		ARGUMENTDEFPTR args1_tmp = method_from_servicedef->args;
	    		int found = 0;
	        	while (!found && args1_tmp != NULL)
	        	{
				if (args1_tmp->dir == ARG_IN && args1_tmp->index == index_arg
						&& (!strcmp(args1_tmp->datatype, "I") || !strcmp(args1_tmp->datatype, "int")))
				{
					found = 1;
					char str_value[20];
					sprintf(str_value, "%d", value&0xffffffff);
					argumentdef_set_value(args1_tmp, str_value);					        		
				}
				args1_tmp = args1_tmp->next;
	        	}
	        
	        
		} 
		else if (!strcmp(obj->classDescr->name, "java.lang.Boolean"))
		{
			j_byte value;
			//parsejByte(fd, &value);
			value = obj->classDescr->field[0].value.boolean_value;
			fprintf(stdout,"Boolean read => %x\n",value&0xff);
		
			ARGUMENTDEFPTR args1_tmp = method_from_servicedef->args;
	    		int found = 0;
	        	while (!found && args1_tmp != NULL)
	        	{
				if (args1_tmp->dir == ARG_IN && args1_tmp->index == index_arg
						&& (!strcmp(args1_tmp->datatype, "B") || !strcmp(args1_tmp->datatype, "boolean")))
				{
					found = 1;
					char str_value[20];
					sprintf(str_value, "%d", value&0xffffffff);
					argumentdef_set_value(args1_tmp, str_value);					        		
				}
				args1_tmp = args1_tmp->next;
	        	}
	        
			
		}
		else if (!strcmp(obj->classDescr->name, "java.lang.String"))
		{
			//j_byte value;
			j_char* value;
			value = obj->classDescr->field[0].value.string_value;
			fprintf(stdout,"String read => %s\n",value);
			
			
			ARGUMENTDEFPTR args1_tmp = method_from_servicedef->args;
	    		int found = 0;
	        	while (!found && args1_tmp != NULL)
	        	{
				if (args1_tmp->dir == ARG_IN && args1_tmp->index == index_arg
						&& (!strcmp(args1_tmp->datatype, "string")))
				{
					found = 1;
					argumentdef_set_value(args1_tmp, (char*)value);					        		
				}
				args1_tmp = args1_tmp->next;
	        	}
	        
		
			
		}
		else if (!strncmp(obj->classDescr->name, "rmiholders.",11))
		{
			fprintf(stdout,"RmiHolder read => !\n");
			
			// TEST: try to modify the value of BooleanHolder on the RMI Client
			//composeJRMP_Call_on_RMIObject(obj);
			
			//sendVoid(fd); 
			RMIHOLDER_STUB_OBJ_PTR obj_stub = (RMIHOLDER_STUB_OBJ_PTR)malloc(sizeof(RMIHOLDER_STUB_OBJ));
			obj_stub->arg_index = index_arg;
			obj_stub->obj = obj;
			obj_stub->next = NULL;
			
			parser_publish_event(event_create_void_pointer(SCP_RMI_STUB_OBJ, obj_stub, evt_stream_id,(void*)evt_src), parser);	
			
			fprintf(stdout,"sendVoid!\n");
		} 
		
		if (peekCode(fd) == TC_ENDBLOCKDATA)
			break;
	}
	
	methoddef_print(method_from_servicedef);
	
	ARGUMENTDEFPTR args1_tmp = method_from_servicedef->args;
    while (args1_tmp != NULL)
    {
    	if (args1_tmp->dir == ARG_IN)
    		parser_publish_event(event_create_void_pointer(SCP_ARGUMENT_IN, args1_tmp, evt_stream_id, (void*)evt_src), parser);
    	else if (args1_tmp->dir == ARG_OUT)
    		parser_publish_event(event_create_void_pointer(SCP_ARGUMENT_OUT, args1_tmp, evt_stream_id, (void*)evt_src), parser);
    	args1_tmp = args1_tmp->next;
    }
    
    parser_publish_event(event_create_int(SCP_SOCKET_ID, fd, evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create(SDP_STOP,evt_stream_id, (void*)evt_src), parser);
	//jrmp_processEvents(parser,  evt_src, method_from_servicedef, service_path);
	
	//sendVoid(fd); 
	//writejByte(fd, 0);
}
	
void *jrmp_threaded_msg_parsing(void* ptr)
{
	
	fprintf(stdout, "\njrmp_threaded_msg_parsing\n");
	PARSINGTHREADDATA_JRMPPARSER_PTR data = (PARSINGTHREADDATA_JRMPPARSER_PTR)ptr;
	
	
	pthread_t thread_event_src = pthread_self();
	
	fprintf(stdout, "\nJRMP PTHREAD parser = %p fd=%d\n", thread_event_src, data->fd);
	
	EVENTSRC_PTR evt_src = event_create_src((void*)thread_event_src, data->parser->unit);
			
	//jrmp_parse_msg(data->parser, data->msg , evt_src);
	parseJRMP(data->parser, data->fd, evt_src );
	
}


PARSER_PTR jrmp_parser_create(UNIT_PTR u)
{
	fprintf(stdout, "Creating JRMP parser\n");
		
	PARSER_PTR p = (PARSER_PTR)malloc(sizeof(PARSER));
	p->func_msg_received = parser_msg_received;	
	p->func_parse =  jrmp_threaded_msg_parsing;	
	p->func_publish_event = parser_publish_event;
	p->evt_listeners = NULL;
	p->factory = jrmp_parser_create;
	
	return p;	
}

