#include "parser/parser.h"
#include "unit/unit.h"

#include "protocol/wsdlmsg.h"
#include "parser/WSDLParser.h"
#include "io/io.h"


struct MESSAGE* messages = NULL; 	
struct PORT_TYPE* port_type = NULL;
struct BINDING* binding = NULL;
struct SERVICE* service = NULL;
struct TYPES* types = NULL;
char *targetNameSpace = NULL;

EVENT_METHOD_DEF_PTR event_methoddef = NULL;


char *FindSoapActionByMethodName(char *methodName)
{
    char *soapAction = NULL;
   
    struct BINDING_OP* temp = ((BINDING*)binding)->binding_Op;

    while(temp != NULL)
    {
        if(strstr( ((BINDING_OP*)temp)->name , methodName) != NULL)
        {
            if(((BINDING_OP*)temp)->soapOp != NULL)
            {
                soapAction = ((SOAP_OP*)((BINDING_OP*)temp)->soapOp)->soapAction;
            }
            break;
        }
        temp = ((BINDING_OP*)temp)->next;
    }
    printf("FindSoapActionByMethodName : SoapAction for method %s is %s\n",methodName,soapAction);
   
    return soapAction;
}


void PrintTypes(TYPES* type)
{
	if(type != NULL)
	{
		fprintf(stdout,"Types : \n");
		if(((TYPES*)types)->schema != NULL)
		{
			fprintf(stdout,"\tTypes : Schema :\n");
			fprintf(stdout,"\tTypes : Schema : ElementFormDefault : %s\n",((SCHEMA*)((TYPES*)types)->schema)->elementFormDefault);
			fprintf(stdout,"\tTypes : Schema : TargetNameSpace : %s\n",((SCHEMA*)((TYPES*)types)->schema)->targetNameSpace);			
			if(((SCHEMA*)((TYPES*)types)->schema)->elements != NULL)
			{
				struct ELEMENT_HEAD* temp = ((SCHEMA*)((TYPES*)types)->schema)->elements;
				while(temp != NULL)
				{
					fprintf(stdout,"\tTypes : Schema : Element_Head : \n");					
					fprintf(stdout,"\tTypes : Schema : Element_Head : Name : %s\n",((ELEMENT_HEAD*)temp)->name);						
					if(((ELEMENT_HEAD*)temp)->complextypes != NULL)									
					{
						fprintf(stdout,"\tTypes : Schema : Element_Head : ComplexTypes : \n");							
						if(((COMPLEX_TYPE*)((ELEMENT_HEAD*)temp)->complextypes)->sequence != NULL)									
						{
							fprintf(stdout,"\tTypes : Schema : Element_Head : ComplexTypes : Sequence : \n");							
							if(((SEQUENCE*)((COMPLEX_TYPE*)((ELEMENT_HEAD*)temp)->complextypes)->sequence)->elements != NULL)
							{
								struct ELEMENT_PART* temp_part = ((SEQUENCE*)((COMPLEX_TYPE*)((ELEMENT_HEAD*)temp)->complextypes)->sequence)->elements;
								while(temp_part != NULL)
								{
									fprintf(stdout,"\t\tTypes : Schema : Element_Head : ComplexTypes : Sequence : Element_Part : \n");							
									fprintf(stdout,"\t\tTypes : Schema : Element_Head : ComplexTypes : Sequence : Element_Part : Name : %s\n",((ELEMENT_PART*)temp_part)->name);							
									fprintf(stdout,"\t\tTypes : Schema : Element_Head : ComplexTypes : Sequence : Element_Part : Type : %s\n",((ELEMENT_PART*)temp_part)->type);							
									fprintf(stdout,"\t\tTypes : Schema : Element_Head : ComplexTypes : Sequence : Element_Part : MinOccurs : %s\n",((ELEMENT_PART*)temp_part)->minOccurs);							
									fprintf(stdout,"\t\tTypes : Schema : Element_Head : ComplexTypes : Sequence : Element_Part : MaxOccurs : %s\n",((ELEMENT_PART*)temp_part)->maxOccurs);							
									
									temp_part = ((ELEMENT_PART*)temp_part)->next;
								}
							}									
						}
					}
					temp = ((ELEMENT_HEAD*)temp)->next;
				}
			}						
		}
	}
}

void PrintMessage(struct MESSAGE* message)
{
	if(message != NULL)
	{
		do
		{
			fprintf(stdout,"Message : Name :  %s\n",((struct MESSAGE*)message)->name);
			if(((struct MESSAGE*)message)->parts != NULL)
			{
				fprintf(stdout,"\tMessage : Part \n");
				fprintf(stdout,"\tMessage : Part : Name : %s\n",((PART*)((struct MESSAGE*)message)->parts)->name);
				fprintf(stdout,"\tMessage : Part : Type : %s\n",((PART*)((struct MESSAGE*)message)->parts)->type);
				fprintf(stdout,"\tMessage : Part : Element :  %s\n",((PART*)((struct MESSAGE*)message)->parts)->element);				
			}
			message = ((struct MESSAGE*)message)->next;
		}
		while(message != NULL);				
	}
}
void PrintService(SERVICE* service)
{
	fprintf(stdout,"Service : Name :  %s\n",service->name);
	if(service->port != NULL)
	{
		fprintf(stdout,"\tService : Port :\n");
		fprintf(stdout,"\tService : Port : Name : %s\n",((PORT*)service->port)->name);
		fprintf(stdout,"\tService : Port : Binding : %s\n",((PORT*)service->port)->binding);
		if(((PORT*)service->port)->address != NULL)
		{
			fprintf(stdout,"\t\tService : Port : Address \n");
			fprintf(stdout,"\t\tService : Port : Address : Location %s\n",((ADDRESS*)((PORT*)service->port)->address)->location);				
		}
	}
}
void PrintBinding(BINDING* binding)
{
	fprintf(stdout,"Binding : Name :  %s\n",binding->name);
	fprintf(stdout,"Binding : Type :  %s\n",binding->type);	
	if(binding->soapBinding != NULL)
	{
		fprintf(stdout,"\tBinding : SoapBinding :\n");
		fprintf(stdout,"\tBinding : SoapBinding : Style : %s\n",((SOAPBINDING*)binding->soapBinding)->style);
		fprintf(stdout,"\tBinding : SoapBinding : Transport : %s\n",((SOAPBINDING*)binding->soapBinding)->transport);		
	}	
	
	struct BINDING_OP* temp = binding->binding_Op;
	
	while(temp != NULL)
	{
		fprintf(stdout,"\tBinding : BindingOp :\n");
		fprintf(stdout,"\tBinding : BindingOp : Name : %s\n",((BINDING_OP*)binding->binding_Op)->name);
		if(((BINDING_OP*)temp)->soapOp != NULL)
		{
			fprintf(stdout,"\t\tBinding : BindingOp : SoapOp : \n");
			fprintf(stdout,"\t\tBinding : BindingOp : SoapOp : SoapAction : %s \n",((SOAP_OP*)((BINDING_OP*)temp)->soapOp)->soapAction);
			fprintf(stdout,"\t\tBinding : BindingOp : SoapOp : Style : %s \n",((SOAP_OP*)((BINDING_OP*)temp)->soapOp)->style);			
		}
		/*
		if(((BINDING_OP*)temp)->binOpInput != NULL)
		{
			fprintf(stdout,"\t\tBinding : BindingOp : BindingOpInput : \n");		
			if(((BIN_OP_INPUT*)((BINDING_OP*)temp)->binOpInput)->soapBody != NULL)
			{
				fprintf(stdout,"\t\t\tBinding : BindingOp : BindingOpInput : EncodingStyle :  %s\n",((SOAP_BODY*)((BIN_OP_INPUT*)((BINDING_OP*)temp)->binOpInput)->soapBody)->encodingStyle);						
				fprintf(stdout,"\t\t\tBinding : BindingOp : BindingOpInput : NameSpace :  %s\n",((SOAP_BODY*)((BIN_OP_INPUT*)((BINDING_OP*)binding->binding_Op)->binOpInput)->soapBody)->nameSpace);						
				fprintf(stdout,"\t\t\tBinding : BindingOp : BindingOpInput : Use :  %s\n",((SOAP_BODY*)((BIN_OP_INPUT*)((BINDING_OP*)binding->binding_Op)->binOpInput)->soapBody)->use);										
			}
		}
		if(((BINDING_OP*)binding->binding_Op)->binOpOutput != NULL)
		{
			fprintf(stdout,"\t\tBinding : BindingOp : BindingOpOutput : \n");		
			if(((BIN_OP_OUTPUT*)((BINDING_OP*)binding->binding_Op)->binOpOutput)->soapBody != NULL)
			{
				fprintf(stdout,"\t\t\tBinding : BindingOp : BindingOpOutput : EncodingStyle :  %s\n",((SOAP_BODY*)((BIN_OP_OUTPUT*)((BINDING_OP*)binding->binding_Op)->binOpOutput)->soapBody)->encodingStyle);						
				fprintf(stdout,"\t\t\tBinding : BindingOp : BindingOpOutput : NameSpace :  %s\n",((SOAP_BODY*)((BIN_OP_OUTPUT*)((BINDING_OP*)binding->binding_Op)->binOpOutput)->soapBody)->nameSpace);						
				fprintf(stdout,"\t\t\tBinding : BindingOp : BindingOpOutput : Use :  %s\n",((SOAP_BODY*)((BIN_OP_OUTPUT*)((BINDING_OP*)binding->binding_Op)->binOpOutput)->soapBody)->use);													
			}			
		}	
		*/
		temp = ((BINDING_OP*)temp)->next;	
	}
}
void PrintPortType(PORT_TYPE* portType)
{
	fprintf(stdout,"PortType : Name :  %s\n",portType->name);

	
	printf("=========TEST STRING ==== %s\n", ((OPERATION_ELEMENT*)((OPERATION*)portType->operations)->outputs)->message);
	
	
	if(portType->operations != NULL)
	{
		struct OPERATION* temp = portType->operations;
	
		fprintf(stdout,"\tPortType : Operations :\n");
		do
		{
			fprintf(stdout,"\tPortType : Operation : Name : %s \n",((OPERATION*)temp)->name);
			if(((OPERATION*)temp)->inputs != NULL)
			{
				fprintf(stdout,"\t\tPortType : Operation : Inputs  \n");
				fprintf(stdout,"\t\t\tPortType : Operation : Inputs : Name : %s \n",((OPERATION_ELEMENT*)((OPERATION*)temp)->inputs)->name);
				fprintf(stdout,"\t\t\tPortType : Operation : Inputs : Message : %s\n",((OPERATION_ELEMENT*)((OPERATION*)temp)->inputs)->message);			
			}
			if(((OPERATION*)temp)->outputs != NULL)
			{
				fprintf(stdout,"\t\tPortType : Operation : Outputs \n");
				fprintf(stdout,"\t\t\tPortType : Operation : Outputs : Name : %s \n",((OPERATION_ELEMENT*)((OPERATION*)temp)->outputs)->name);
				fprintf(stdout,"\t\t\tPortType : Operation : Outputs : Message : %s \n",((OPERATION_ELEMENT*)((OPERATION*)temp)->outputs)->message);			
			}
			if(((OPERATION*)temp)->faults != NULL)
			{
				fprintf(stdout,"\t\tPortType : Operation : Faults \n");
				fprintf(stdout,"\t\t\tPortType : Operation : Faults : Name : %s\n",((OPERATION_ELEMENT*)((OPERATION*)temp)->faults)->name);
				fprintf(stdout,"\t\t\tPortType : Operation : Faults : Message : %s\n",((OPERATION_ELEMENT*)((OPERATION*)temp)->faults)->message);			
			}		
			temp = ((OPERATION*)temp)->next;
		}while(temp != NULL);
	}
}
void wsdl_processEvents(PARSER_PTR parser, EVENTSRC_PTR evt_src )
{
	int evt_stream_id = (int)(evt_src->src_thread_parser);
	char *serviceDescInterfaceType = NULL;
	char *serviceDescInterfaceNameSpace = targetNameSpace;
	char *serviceDescServiceType = NULL;
	char *temp_serviceInterfaceCtrlURLPath = NULL;
	char *serviceInterfaceCtrlURLPath = NULL;
	char *service_URLnoPath = NULL;
		
	if(binding != NULL)
	{
		serviceDescInterfaceType = ((BINDING*)binding)->name;
	}
	if(service != NULL)
	{
		serviceDescServiceType = ((SERVICE*)service)->name;
		if(((SERVICE*)service)->port != NULL)
		{
			if(((PORT*)((SERVICE*)service)->port)->address != NULL)
			{
				temp_serviceInterfaceCtrlURLPath = ((ADDRESS*)((PORT*)((SERVICE*)service)->port)->address)->location; 
				//char *ip;
				//int port;
				//parseURL_host_port(temp_serviceInterfaceCtrlURLPath, &ip, &port, &serviceInterfaceCtrlURLPath);
		    	char* location_url_nopath;
		    	char* location_url_path;
		    	
		    	parseURL_nopath_path(temp_serviceInterfaceCtrlURLPath, &service_URLnoPath, &serviceInterfaceCtrlURLPath);
			}
		}
	}
	
	
	printf("IN WSDL Parser Process Events\n");
	parser_publish_event(event_create(SDP_SERVICE_DESCRIPTION, evt_stream_id, (void*)evt_src), parser);	
	parser_publish_event(event_create(SDP_START, evt_stream_id, (void*)evt_src), parser);	
	
	ExtractFunctionDefinitions(parser,evt_src);
	
	parser_publish_event(event_create_string(SDP_SERVICE_CTRL_URL_NOPATH, (char*)service_URLnoPath, evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create_string(SDP_INTERFACE_CTRL_URL_PATH, (char*)serviceInterfaceCtrlURLPath, evt_stream_id, (void*)evt_src), parser);
	
	parser_publish_event(event_create_string(SDP_SERVICE_DESCRIPTION_INTERFACETYPE, (char*)serviceDescInterfaceType, evt_stream_id, (void*)evt_src), parser);
	parser_publish_event(event_create_string(SDP_SERVICE_DESCRIPTION_INTERFACE_NAMESPACE, (char*)serviceDescInterfaceNameSpace, evt_stream_id,(void*)evt_src), parser);
	parser_publish_event(event_create_string(SDP_SERVICE_DESCRIPTION_SERVICETYPE, (char*)serviceDescServiceType, evt_stream_id, (void*)evt_src), parser);	
	parser_publish_event(event_create(SDP_STOP, evt_stream_id, (void*)evt_src), parser);    
}
void ParseMessage(WSDLMSG *wsdlMessage,char *Msg)
{
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTagSize = 0;
	unsigned int iMsgStartIndex=0,iMsgEndIndex=0,iPartStartIndex=0,iPartEndIndex=0;

	char *TAG = NULL,*MSG = NULL,*PART_STR = NULL;

	while(index < strlen(Msg))
	{
		if((bStartTagFound == FALSE) && Msg[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && (Msg[index] == TAG_END))
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = Msg[i+iStartTagIndex];
			TAG[i]='\0';
			//printf("Next TAG is %s\n",TAG);

			if(strstr(TAG,STR_PART_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iPartStartIndex = iStartTagIndex+1;
				iPartEndIndex = iEndTagIndex-1;

				PART_STR = (char*)malloc(sizeof(char)*(iPartEndIndex-iPartStartIndex));
				for(i=0;i<(iPartEndIndex-iPartStartIndex);i++)
					PART_STR[i] = Msg[i+iPartStartIndex];
				PART_STR[i] = '\0';

				if(messages != NULL)
				{
					if(((struct MESSAGE*)messages)->next == NULL)
					{
						((struct MESSAGE*)messages)->parts = (struct PART*)malloc(sizeof(PART));

						if(strstr(PART_STR,STR_NAME) != NULL)				
							((PART*)((struct MESSAGE*)messages)->parts)->name    = ExtractAttributeByTag(strdup(PART_STR),STR_NAME);				
						if(strstr(PART_STR,STR_ELEMENT) != NULL)				
							((PART*)((struct MESSAGE*)messages)->parts)->element = ExtractAttributeByTag(strdup(PART_STR),STR_ELEMENT);				
						if(strstr(PART_STR,STR_TYPE) != NULL)				
							((PART*)((struct MESSAGE*)messages)->parts)->type    = ExtractAttributeByTag(strdup(PART_STR),STR_TYPE);							
					}
					else
					{									
						struct PART* newPart = (struct PART*)malloc(sizeof(PART));
						
						if(strstr(PART_STR,STR_NAME) != NULL)				
							((PART*)newPart)->name    = ExtractAttributeByTag(strdup(PART_STR),STR_NAME);				
						if(strstr(PART_STR,STR_ELEMENT) != NULL)				
							((PART*)newPart)->element = ExtractAttributeByTag(strdup(PART_STR),STR_ELEMENT);				
						if(strstr(PART_STR,STR_TYPE) != NULL)				
							((PART*)newPart)->type    = ExtractAttributeByTag(strdup(PART_STR),STR_TYPE);						
					
						struct MESSAGE* temp = messages;						
						while(((struct MESSAGE*)temp)->next != NULL)
						{
							temp = ((struct MESSAGE*)temp)->next;
						}						
						((struct MESSAGE*)temp)->parts = newPart;															
					}
				}								
			}

			bStartTagFound = FALSE;
			bEndTagFound = FALSE;
		}
	}	
	
}
void ParsePartElement(char *PartElement)
{
	char *Name=NULL,*Element=NULL,*Type=NULL,*token,seps[]=" \t\n",equ[]="=",*NameVal=NULL,*ElementVal=NULL,*TypeVal=NULL;
	char *tempStr = NULL;
	
	token = (char*)strtok( PartElement, seps );
	while( token != NULL )
	{
		//printf("token %s\n",token);
		if(strstr(token,STR_NAME) != NULL)
		{
			Name = token;
		}
		else if(strstr(token,STR_ELEMENT) != NULL)
		{
			Element = token;
		}
		else if(strstr(token,STR_TYPE) != NULL)
		{
			Type = token;
		}		
		token = (char*)strtok( NULL, seps );		
	}	
	
	if(Name != NULL)
	{
		token = (char*)strtok(Name,equ);	
		while(token != NULL)
		{
			//printf("token %s\n",token);
			if(strstr(token,STR_NAME) == NULL)
			{
				NameVal = token;
				break;
			}		
			token = (char*)strtok( NULL, equ );	
		}
		tempStr = (char*)malloc(sizeof(char)*(strlen(NameVal)-2));
		strncpy(tempStr,++NameVal,strlen(NameVal)-2);
		printf("Name Value is %s\n",tempStr);
	}
	
	if(Element != NULL)
	{
		token = (char*)strtok(Element,equ);	
		while(token != NULL)
		{
			//printf("token %s\n",token);
			if(strstr(token,STR_ELEMENT) == NULL)
			{
				ElementVal = token;
				break;
			}		
			token = (char*)strtok( NULL, equ );	
		}
		tempStr = (char*)malloc(sizeof(char)*(strlen(ElementVal)-2));
		strncpy(tempStr,++ElementVal,strlen(ElementVal)-2);
		printf("Element Value is %s\n",tempStr);				
	}
	
	if(Type != NULL)
	{
		token = (char*)strtok(Type,equ);	
		while(token != NULL)
		{
			//printf("token %s\n",token);
			if(strstr(token,STR_TYPE) == NULL)
			{
				TypeVal = token;
				break;
			}		
			token = (char*)strtok( NULL, equ );	
		}
		tempStr = (char*)malloc(sizeof(char)*(strlen(TypeVal)-2));
		strncpy(tempStr,++TypeVal,strlen(TypeVal)-2);	
		printf("Type Value is %s\n",tempStr);					
	}
}
char* ExtractNameFromQualifiedName(char *qualifiedName)
{
	char *token = NULL,seps[]=":";
	char *name;
	int index = 0;
		
	token = (char*)strtok( qualifiedName, seps );
	
	while( token != NULL )
	{
		if(index == 1)
		{
			name = token;
		}
		index++;
		token = (char*)strtok( NULL, seps );		
	}	
	return name;
}
char* ExtractSoapActionByMethodName(char *methodName)
{
	char *soapAction = NULL;
	if(binding != NULL)
	{
		struct BINDING_OP *temp = ((BINDING*)binding)->binding_Op;
		
		if(temp != NULL)//while(temp != NULL)
		{
			printf("Method to lookup is %s\n",methodName);
			if( strstr(strdup(((BINDING_OP*)temp)->name),methodName) != NULL )			
			{
				if(((BINDING_OP*)temp)->soapOp != NULL)
				{
					soapAction = ((SOAP_OP*)((BINDING_OP*)temp)->soapOp)->soapAction;
					printf("Soap Action Extracted is %s\n",soapAction);
				}		
			}	
			//temp = ((BINDING_OP*)temp)->next;
		}		
	}
	return soapAction;
}
struct MESSAGE* GetMessageByName(char *msgName)
{
	struct MESSAGE *temp = messages;
	while(temp != NULL)
	{
		if(strstr(((struct MESSAGE*)temp)->name,msgName) != NULL)
		{
			break;
		}
		temp = ((struct MESSAGE*)temp)->next;
	}
	return (struct MESSAGE*)temp;
}
ELEMENT_HEAD* GetElementByName(char *elementName)
{
	struct ELEMENT_HEAD *temp = NULL;
	if(types != NULL)
	{
		if(((TYPES*)types)->schema != NULL)
		{
			temp = ((SCHEMA*)((TYPES*)types)->schema)->elements;
			while(temp != NULL)
			{
				if(strstr(((ELEMENT_HEAD*)temp)->name,elementName) != NULL)
				{
					break;
				}
				temp = ((ELEMENT_HEAD*)temp)->next;
			}			
		}
	}
	return (ELEMENT_HEAD*)temp;
}
void AppendtoMethodsList(METHODDEFPTR methodsHead,METHODDEFPTR methodsNew)
{
	methodsNew->next = NULL;
	if(methodsHead == NULL)
	{
		methodsHead = methodsNew;
	}
	else
	{
		METHODDEFPTR temp = malloc(sizeof(METHODDEF));
		temp = methodsHead;
		
		while(temp->next == NULL)
		{
			temp = temp->next;
		}
		temp->next = methodsNew;
	}
}
void AppendtoArgumentsList(ARGUMENTDEFPTR argsHead,ARGUMENTDEFPTR argsNew)
{
	argsNew->next = NULL;
	if(argsHead == NULL)
	{
		argsHead = argsNew;
	}
	else
	{
		ARGUMENTDEFPTR temp = malloc(sizeof(ARGUMENTDEF));
		temp = argsHead;
		
		while(temp->next == NULL)
		{
			temp = temp->next;
		}
		temp->next = argsNew;
	}
}

void ExtractFunctionDefinitions(PARSER_PTR parser, EVENTSRC_PTR evt_src)
{	
	int evt_stream_id = (int)(evt_src->src_thread_parser);
	
	EVENT_METHOD_DEF_PTR event_methoddef = NULL ;	
	
	char *interfaceName = NULL;

	printf("===============================================================\n");
	printf("===================== FUNCTION DEFINITIONS ====================\n");
	printf("===============================================================\n\n");
	
	METHODDEFPTR methodsHead = NULL,methodsNew = NULL;	
	if(port_type != NULL)
	{
		struct OPERATION *temp = ((PORT_TYPE*)port_type)->operations;
		interfaceName = strdup(((PORT_TYPE*)port_type)->name);
		
		while(temp != NULL)
		{
		  	methodsNew = methoddef_new2();
			char *operationName = ((OPERATION*)temp)->name;			
			struct MESSAGE *pMsg = NULL;
			
			printf("%s\n",operationName);
			
			methoddef_set_name(methodsNew, operationName);
			methoddef_set_namespace(methodsNew, FindSoapActionByMethodName(operationName));
		
			
			ARGUMENTDEFPTR argsHead = NULL,argsNew = NULL;
			
			if(((OPERATION*)temp)->inputs != NULL)
			{
			  char *type,*name;
				char *inputOperationMessageName = ExtractNameFromQualifiedName(((OPERATION_ELEMENT*)((OPERATION*)temp)->inputs)->message);
				printf("Input Parameters : %s \n",inputOperationMessageName);			
				pMsg = (struct MESSAGE*)GetMessageByName(inputOperationMessageName); 
				if(pMsg != NULL)
				{
					if(((struct MESSAGE*)pMsg)->parts != NULL)
					{
						char *elementName = ExtractNameFromQualifiedName(((PART*)((struct MESSAGE*)pMsg)->parts)->element);
						printf("Element is %s\n",elementName);
						struct ELEMENT_HEAD *pElement = (struct ELEMENT_HEAD*)GetElementByName(elementName);
						if(pElement != NULL)
						{
							if(((ELEMENT_HEAD*)pElement)->complextypes != NULL)
							{
								if(((COMPLEX_TYPE*)((ELEMENT_HEAD*)pElement)->complextypes)->sequence != NULL)
								{
									struct ELEMENT_PART *pEleParts = ((SEQUENCE*)((COMPLEX_TYPE*)((ELEMENT_HEAD*)pElement)->complextypes)->sequence)->elements;		
									
									while(pEleParts != NULL)
									{
										type = ExtractNameFromQualifiedName(((ELEMENT_PART*)pEleParts)->type);
										name = ((ELEMENT_PART*)pEleParts)->name;
										pEleParts = ((ELEMENT_PART*)pEleParts)->next;
										printf("%s %s\n",type,name);
										
										
										argsNew = argumentdef_new();
										argumentdef_set_name(argsNew, name);
										argumentdef_set_dir(argsNew, ARG_IN);
										argumentdef_set_datatype(argsNew, type);
										methoddef_add_argument(methodsNew, argsNew);	
										//methoddef_print(methodsNew);
										
										
									}
								}
							}
						}
					}					
				}	
				
							
			}
			if(((OPERATION*)temp)->outputs != NULL)
			{
				char *outputOperationMessageName = ExtractNameFromQualifiedName(((OPERATION_ELEMENT*)((OPERATION*)temp)->outputs)->message);
				printf("Output Parameters : %s\n",outputOperationMessageName);						
				pMsg = (struct MESSAGE*)GetMessageByName(outputOperationMessageName);
				char *type,*name;				
				if(pMsg != NULL)
				{
					if(((struct MESSAGE*)pMsg)->parts != NULL)
					{
						char *elementName = ExtractNameFromQualifiedName(((PART*)((struct MESSAGE*)pMsg)->parts)->element);
						printf("Element is %s\n",elementName);
						struct ELEMENT_HEAD *pElement = (struct ELEMENT_HEAD*)GetElementByName(elementName);
						if(pElement != NULL)
						{
							if(((ELEMENT_HEAD*)pElement)->complextypes != NULL)
							{
								if(((COMPLEX_TYPE*)((ELEMENT_HEAD*)pElement)->complextypes)->sequence != NULL)
								{
									struct ELEMENT_PART *pEleParts = ((SEQUENCE*)((COMPLEX_TYPE*)((ELEMENT_HEAD*)pElement)->complextypes)->sequence)->elements;
									while(pEleParts != NULL)
									{
										type = ExtractNameFromQualifiedName(((ELEMENT_PART*)pEleParts)->type);
										name = ((ELEMENT_PART*)pEleParts)->name;
										pEleParts = ((ELEMENT_PART*)pEleParts)->next;
										printf("%s %s\n",type,name);
										argsNew = argumentdef_new();
										argumentdef_set_name(argsNew, name);
										argumentdef_set_dir(argsNew, ARG_OUT);
										argumentdef_set_datatype(argsNew, type);
										methoddef_add_argument(methodsNew, argsNew);			

									}
								}
							}
						}						
					}					
				}	
				
			}
			if(((OPERATION*)temp)->faults != NULL)
			{
				printf("Faults : \n");						
			}
			temp = ((OPERATION*)temp)->next;
			
			
			METHODDEFPTR meths2 = malloc(sizeof(METHODDEF));
			memcpy(meths2, methodsNew, sizeof(METHODDEF));
			meths2->next = NULL;
			
			event_methoddef = malloc(sizeof(EVENT_METHOD_DEF));
			if(service != NULL)
			{
				event_methoddef->service_name = ((SERVICE*)service)->name;
			}
			else
			{
				event_methoddef->service_name = "Service";
			}
			
			event_methoddef->interface_name = interfaceName;
			event_methoddef->method = meths2;
			
			methoddef_print(event_methoddef->method);
			
			parser_publish_event(event_create_void_pointer(SDP_SERVICE_METHOD_DESCRIPTION,(void*)event_methoddef,evt_stream_id,(void*)evt_src),parser);
			
		}
	}
	
		    

	printf("\n\n\n===============================================================\n");
}
void wsdl_parse_msg(PARSER_PTR parser, MSG_PTR message , EVENTSRC_PTR evt_src)
{
	char *data = message->data;
	//printf("\nWSDL Parse : ParseWSDL : very start \n");
	WSDLMSG *wsdlMessage;
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTagSize = 0;
	unsigned int iXMLStartIndex=0,iXMLEndIndex=0,iDefStartIndex=0,iDefEndIndex=0;

	char *TAG = NULL,*XMLTAG = NULL,*DEFINITION = NULL;

	//printf("\nWSDL Parse : ParseWSDL : Before While loop the while loop  index = %d strlen(data) = %d\n",index,strlen(data));
	
	while(index < strlen(data))
	{
		//printf("\nWSDL Parse : ParseWSDL : In the while loop  \n");
		if((bStartTagFound == FALSE) && data[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && (data[index] == TAG_END))
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = data[i+iStartTagIndex];
			TAG[i]='\0';
			//printf("Next TAG is %s\n",TAG);

			if(strstr(TAG,STR_XML_TAG) != NULL )
			{
				iXMLStartIndex = iStartTagIndex;
				iXMLEndIndex = iEndTagIndex;

				
				XMLTAG = (char*)malloc(sizeof(char)*(iXMLEndIndex-iXMLStartIndex));
				for( i = 0 ; i < (iXMLEndIndex-iXMLStartIndex) ; i++ )
					XMLTAG[i] = data[i+iXMLStartIndex];
				XMLTAG[i] = '\0';
		       	//printf("XML Tag is %s\n",XMLTAG);				
			}
			if(strstr(TAG,STR_DEFINITION_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iDefStartIndex = iEndTagIndex;
			}
			if(strstr(TAG,STR_DEFINITION_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iDefEndIndex = iStartTagIndex;
				DEFINITION = (char*)malloc(sizeof(char)*(iDefEndIndex-iDefStartIndex));
				for(i=0;i<(iDefEndIndex-iDefStartIndex);i++)
					DEFINITION[i] = data[i+iDefStartIndex];
				DEFINITION[i] = '\0';
			 	//printf("Def Tag is %s\n",DEFINITION);
				ParseDefinition(wsdlMessage,DEFINITION);
			} 

			bStartTagFound = FALSE;
			bEndTagFound = FALSE;
		}
	}	
}
void ParseDefinition(WSDLMSG *wsdlMessage,char *Def)
{ 	
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTagSize = 0;
	unsigned int iTypesStartIndex = 0,iTypesEndIndex = 0;
	unsigned int iMsgStartIndex = 0,iMsgEndIndex = 0,iMsgTagStartIndex = 0,iMsgTagEndIndex = 0;
  unsigned int iPortTypeStartIndex=0,iPortTypeEndIndex=0,iPortTypeTagStartIndex=0,iPortTypeTagEndIndex=0;
  unsigned int iBinStartIndex=0,iBinEndIndex=0,iBinTagStartIndex=0,iBinTagEndIndex=0;
	unsigned int iServStartIndex=0,iServEndIndex=0,iServTagStartIndex=0,iServTagEndIndex=0;
	
	char *TAG = NULL, *STR_TYPES = NULL , *STR_MSG = NULL , *STR_PORTTYPE=NULL ,*STR_PORTTYPETAG=NULL, *STR_BINDINGTAG = NULL , *BINDING_STR=NULL;
	char *STR_SERVICE=NULL,*STR_SERVICETAG=NULL,*STR_MSG_TAG = NULL;
	
	while(index < strlen(Def))
	{
		if((bStartTagFound == FALSE) && Def[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && (Def[index] == TAG_END))
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = Def[i+iStartTagIndex];
			TAG[i]='\0';
			//printf("Next Tag is %s\n",TAG);
			if(strstr(TAG,STR_TYPES_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iTypesStartIndex = iEndTagIndex;
			}
			if(strstr(TAG,STR_TYPES_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iTypesEndIndex = iStartTagIndex;
				STR_TYPES = (char*)malloc(sizeof(char)*(iTypesEndIndex-iTypesStartIndex));
				for(i=0;i<(iTypesEndIndex-iTypesStartIndex);i++)
					STR_TYPES[i] = Def[i+iTypesStartIndex];
				STR_TYPES[i] = '\0';
				types = (struct TYPES*)malloc(sizeof(TYPES));
				ParseTypes(wsdlMessage,STR_TYPES);
			}			
			if(strstr(TAG,STR_MESSAGE_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iMsgStartIndex = iEndTagIndex;
				iMsgTagStartIndex = iStartTagIndex;
				iMsgTagEndIndex = iEndTagIndex;
				
				STR_MSG_TAG = (char*)malloc(sizeof(char)*(iMsgTagEndIndex-iMsgTagStartIndex));
				for(i = 0 ; i < (iMsgTagEndIndex-iMsgTagStartIndex) ; i++)
					STR_MSG_TAG[i] = Def[i+iMsgTagStartIndex];
				
				if(messages == NULL)
				{
					messages = (struct MESSAGE*)malloc(sizeof(struct MESSAGE));
					if(strstr(STR_MSG_TAG,STR_NAME) != NULL)
					{
						((struct MESSAGE*)messages)->name = ExtractAttributeByTag(strdup(STR_MSG_TAG),STR_NAME);
					}
					((struct MESSAGE*)messages)->parts = NULL;
					((struct MESSAGE*)messages)->next = NULL;
				}
				else
				{
					struct MESSAGE* newMsg = (struct MESSAGE*)malloc(sizeof(struct MESSAGE));
					if(strstr(STR_MSG_TAG,STR_NAME) != NULL)
					{
						((struct MESSAGE*)newMsg)->name = ExtractAttributeByTag(strdup(STR_MSG_TAG),STR_NAME);
					}
					((struct MESSAGE*)newMsg)->parts = NULL;
					((struct MESSAGE*)newMsg)->next = NULL;
					
					struct MESSAGE* temp = messages;
					while(((struct MESSAGE*)temp)->next != NULL)
					{
						temp = ((struct MESSAGE*)temp)->next;
					}
					((struct MESSAGE*)temp)->next = newMsg;									
				}		
			}
			if(strstr(TAG,STR_MESSAGE_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iMsgEndIndex = iStartTagIndex;
				STR_MSG = (char*)malloc(sizeof(char)*(iMsgEndIndex-iMsgStartIndex));
				for(i=0;i<(iMsgEndIndex-iMsgStartIndex);i++)
					STR_MSG[i] = Def[i+iMsgStartIndex];
				STR_MSG[i] = '\0';
				printf("Parsing Message --------\n");
				ParseMessage(wsdlMessage,STR_MSG);
			}                                     			
			if(strstr(TAG,STR_PORTTYPE_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iPortTypeStartIndex = iEndTagIndex;
				iPortTypeTagStartIndex = iStartTagIndex;
 				iPortTypeTagEndIndex = iEndTagIndex;
				port_type = (struct PORT_TYPE*)malloc(sizeof(PORT_TYPE));
				
				STR_PORTTYPETAG = (char*)malloc(sizeof(char)*(iPortTypeTagEndIndex-iPortTypeTagStartIndex));
				
				for(i=0;i<(iPortTypeTagEndIndex-iPortTypeTagStartIndex);i++)
					STR_PORTTYPETAG[i] = Def[i+iPortTypeTagStartIndex];
				STR_PORTTYPETAG[i] = '\0';	

				if(strstr(STR_PORTTYPETAG,STR_NAME) != NULL)
				{
					((PORT_TYPE*)port_type)->name = ExtractAttributeByTag(strdup(STR_PORTTYPETAG),STR_NAME);
					printf("PortType Element Name Attribute value is %s\n",((PORT_TYPE*)port_type)->name);
				}							
			}
			if(strstr(TAG,STR_PORTTYPE_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iPortTypeEndIndex = iStartTagIndex;
				STR_PORTTYPE = (char*)malloc(sizeof(char)*(iPortTypeEndIndex-iPortTypeStartIndex));
				for(i=0;i<(iPortTypeEndIndex-iPortTypeStartIndex);i++)
					STR_PORTTYPE[i] = Def[i+iPortTypeStartIndex];
				STR_PORTTYPE[i] = '\0';					
				printf("Parsing Port Type --------\n");
				ParsePortType(wsdlMessage,STR_PORTTYPE);
			}			
			if(strstr(TAG,STR_BINDING_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				printf("Parsing Binding --------\n"); 					
				iBinStartIndex = iEndTagIndex;				
				binding = malloc(sizeof(BINDING));				
				iBinTagStartIndex = iStartTagIndex;
 				iBinTagEndIndex = iEndTagIndex;
				STR_BINDINGTAG = (char*)malloc(sizeof(char)*(iBinTagEndIndex-iBinTagStartIndex));
				for(i=0;i<(iBinTagEndIndex-iBinTagStartIndex);i++)
					STR_BINDINGTAG[i] = Def[i+iBinTagStartIndex];
				STR_BINDINGTAG[i] = '\0';	
				
				if(strstr(STR_BINDINGTAG,STR_NAME) != NULL)
				{
					((BINDING*)binding)->name = ExtractAttributeByTag(strdup(STR_BINDINGTAG),STR_NAME);
					printf("Binding Element Name Attribute value is %s\n",((BINDING*)binding)->name);
				}			
				if(strstr(STR_BINDINGTAG,STR_TYPE) != NULL)
				{
					((BINDING*)binding)->type = ExtractAttributeByTag(strdup(STR_BINDINGTAG),STR_TYPE);
					printf("Binding Element Type Attribute value is %s\n",((BINDING*)binding)->type);
				}							
			}
			if(strstr(TAG,STR_BINDING_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iBinEndIndex = iStartTagIndex;
				BINDING_STR = (char*)malloc(sizeof(char)*(iBinEndIndex-iBinStartIndex));
				for(i=0;i<(iBinEndIndex-iBinStartIndex);i++)
					BINDING_STR[i] = Def[i+iBinStartIndex];
				BINDING_STR[i] = '\0';			
				ParseBinding(wsdlMessage,BINDING_STR);
			}			
			if(strstr(TAG,STR_SERVICE_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				printf("Parsing Service --------\n");	
				service = malloc(sizeof(SERVICE));			
				
				iServStartIndex = iEndTagIndex;				
				iServTagStartIndex = iStartTagIndex;
				iServTagEndIndex = iEndTagIndex;
								
				STR_SERVICETAG = (char*)malloc(sizeof(char)*(iServTagEndIndex-iServTagStartIndex));
				
				for(i=0;i<(iServTagEndIndex-iServTagStartIndex);i++)
					STR_SERVICETAG[i] = Def[i+iServTagStartIndex];
				STR_SERVICETAG[i] = '\0';				
				
				if(strstr(STR_SERVICETAG,STR_NAME) != NULL)
				{
				  char *servName = ExtractAttributeByTag(strdup(STR_SERVICETAG),STR_NAME);					
					((SERVICE*)service)->name = servName;				
					printf("Service Name Attribute is %s\n",((SERVICE*)service)->name);
				}
			}
			if(strstr(TAG,STR_SERVICE_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iServEndIndex = iStartTagIndex;
				STR_SERVICE = (char*)malloc(sizeof(char)*(iServEndIndex-iServStartIndex));
				for(i=0;i<(iServEndIndex-iServStartIndex);i++)
					STR_SERVICE[i] = Def[i+iServStartIndex];
				STR_SERVICE[i] = '\0';
				ParseService(wsdlMessage,STR_SERVICE);	
			}			
			bStartTagFound = FALSE;
			bEndTagFound = FALSE;			
		}
	}	
	printf("\n=============================================================\n");
	printf("=============================================================\n");
	PrintTypes((TYPES*)types);
	PrintMessage((struct MESSAGE*)messages);
 	PrintPortType((PORT_TYPE*)port_type);
	PrintBinding((BINDING*)binding);			
	PrintService((SERVICE*)service);	
	printf("\n=============================================================\n");	
}
void ParseTypes(WSDLMSG *wsdlMessage,char *Types)
{
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTagSize = 0;
	unsigned int iSchemaStartIndex=0,iSchemaEndIndex=0,iSchemaTagStartIndex=0,iSchemaTagEndIndex=0;

	char *TAG = NULL,*SCHEMA_STR = NULL,*SCHEMA_TAG = NULL;

	while(index < strlen(Types))
	{
		if((bStartTagFound == FALSE) && Types[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && Types[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = Types[i+iStartTagIndex];
			TAG[i]='\0';			
			
			if(strstr(TAG,STR_SCHEMA_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iSchemaTagStartIndex = iStartTagIndex;
				iSchemaTagEndIndex = iEndTagIndex;
				
				iSchemaStartIndex = iEndTagIndex;
				
				SCHEMA_TAG = (char*)malloc(sizeof(char)*(iSchemaTagEndIndex-iSchemaTagStartIndex));
				for(i=0;i<(iSchemaTagEndIndex-iSchemaTagStartIndex);i++)
					SCHEMA_TAG[i] = Types[i+iSchemaTagStartIndex];
				SCHEMA_TAG[i] = '\0';
				
				((TYPES*)types)->schema = (struct SCHEMA*)malloc(sizeof(SCHEMA));
				
				if(strstr(SCHEMA_TAG,STR_ELEMENT_FORM_DEFAULT) != NULL)
				{	
					((SCHEMA*)((TYPES*)types)->schema)->elementFormDefault = ExtractAttributeByTag(strdup(SCHEMA_TAG),STR_ELEMENT_FORM_DEFAULT);
				}
				if(strstr(SCHEMA_TAG,STR_TARGET_NAMESPACE) != NULL)
				{
					((SCHEMA*)((TYPES*)types)->schema)->targetNameSpace = ExtractAttributeByTag(strdup(SCHEMA_TAG),STR_TARGET_NAMESPACE);			
				}				
			}
			if(strstr(TAG,STR_SCHEMA_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iSchemaEndIndex = iStartTagIndex;
				SCHEMA_STR = (char*)malloc(sizeof(char)*(iSchemaEndIndex-iSchemaStartIndex));
				for(i=0;i<(iSchemaEndIndex-iSchemaStartIndex);i++)
					SCHEMA_STR[i] = Types[i+iSchemaStartIndex];
				SCHEMA_STR[i] = '\0';
			 	//printf("Schema Tag is %s\n",SCHEMA_STR);
				ParseSchema(wsdlMessage,SCHEMA_STR);
			}
			
			bStartTagFound = FALSE;
			bEndTagFound = FALSE;
		}
	}	
}
void ParseSchema(WSDLMSG *wsdlMessage,char *Schema)
{
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE,bElementOpen = FALSE;
	unsigned int iStartTagIndex=0,iEndTagIndex=0,iTagSize = 0;
	unsigned int iElementStartIndex=0,iElementEndIndex=0,iElementTagStartIndex=0,iElementTagEndIndex=0;
	
	char *TAG = NULL,*STR_ELEMENT_HEAD = NULL,*STR_ELEMENT_HEAD_TAG = NULL;

	while(index < strlen(Schema))
	{
		if((bStartTagFound == FALSE) && Schema[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && Schema[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = Schema[i+iStartTagIndex];
			TAG[i]='\0';	
			
			if(strstr(TAG,STR_ELEMENT) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL && bElementOpen == FALSE)
			{
				bElementOpen = TRUE;
				iElementTagStartIndex = iStartTagIndex;
				iElementTagEndIndex = iEndTagIndex;
				
				iElementStartIndex = iEndTagIndex;
				
				STR_ELEMENT_HEAD_TAG = (char*)malloc(sizeof(char)*(iElementTagEndIndex-iElementTagStartIndex));
				for(i = 0 ; i < (iElementTagEndIndex-iElementTagStartIndex) ; i++)
					STR_ELEMENT_HEAD_TAG[i] = Schema[i+iElementTagStartIndex];
				STR_ELEMENT_HEAD_TAG[i] = '\0';
				if(((SCHEMA*)((TYPES*)types)->schema)->elements == NULL)
				{
					((SCHEMA*)((TYPES*)types)->schema)->elements = (struct ELEMENT_HEAD*)malloc(sizeof(ELEMENT_HEAD));	
					if(strstr(STR_ELEMENT_HEAD_TAG,STR_NAME) != NULL)
					{
						((ELEMENT_HEAD*)((SCHEMA*)((TYPES*)types)->schema)->elements)->name = ExtractAttributeByTag(strdup(STR_ELEMENT_HEAD_TAG),STR_NAME);
					}
					((ELEMENT_HEAD*)((SCHEMA*)((TYPES*)types)->schema)->elements)->simpletypes = NULL;
					((ELEMENT_HEAD*)((SCHEMA*)((TYPES*)types)->schema)->elements)->complextypes = NULL;
					((ELEMENT_HEAD*)((SCHEMA*)((TYPES*)types)->schema)->elements)->next = NULL;
				}
				else
				{
					struct ELEMENT_HEAD* curElementHead = (struct ELEMENT_HEAD*)malloc(sizeof(ELEMENT_HEAD));
					if(strstr(STR_ELEMENT_HEAD_TAG,STR_NAME) != NULL)
					{
						((ELEMENT_HEAD*)curElementHead)->name = ExtractAttributeByTag(strdup(STR_ELEMENT_HEAD_TAG),STR_NAME);
					}
					((ELEMENT_HEAD*)curElementHead)->simpletypes = NULL;
					((ELEMENT_HEAD*)curElementHead)->complextypes = NULL;
					((ELEMENT_HEAD*)curElementHead)->next = NULL;			
					
					struct ELEMENT_HEAD* temp = (struct ELEMENT_HEAD*)((SCHEMA*)((TYPES*)types)->schema)->elements;
					while(((ELEMENT_HEAD*)temp)->next != NULL)
					{
						temp = ((ELEMENT_HEAD*)temp)->next;
					}
					((ELEMENT_HEAD*)temp)->next = curElementHead;								
				}								
			}
			if(strstr(TAG,STR_ELEMENT) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{			
				bElementOpen = FALSE;
				iElementEndIndex = iStartTagIndex;
				
				STR_ELEMENT_HEAD = (char*)malloc(sizeof(char)*(iElementEndIndex-iElementStartIndex));
				for(i = 0 ; i < (iElementEndIndex-iElementStartIndex) ; i++)
					STR_ELEMENT_HEAD[i] = Schema[i+iElementStartIndex];				
				STR_ELEMENT_HEAD[i] = '\0';
				
				// Getting the last element Head pointer
				struct ELEMENT_HEAD* temp = ((SCHEMA*)((TYPES*)types)->schema)->elements;				
				while(((ELEMENT_HEAD*)temp)->next != NULL )
				{
					temp = ((ELEMENT_HEAD*)temp)->next;
				}
				//printf("Next Element Head is %s\n",STR_ELEMENT_HEAD);
				ParseElementHead(wsdlMessage,(ELEMENT_HEAD*)temp,STR_ELEMENT_HEAD);								
			}							
			bStartTagFound = FALSE;
			bEndTagFound = FALSE;
		}
	}	
}
void ParseElementHead(WSDLMSG *wsdlMessage,ELEMENT_HEAD *element_Head,char *ElementHead)
{
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE;
	unsigned int iStartTagIndex = 0,iEndTagIndex = 0,iTagSize = 0;
	unsigned int iComplexTypeStartIndex = 0,iComplexTypeEndIndex = 0;
	
	char *TAG = NULL;
	char *COMPLEX_TYPE_STR = NULL;

	while(index < strlen(ElementHead))
	{
		if((bStartTagFound == FALSE) && ElementHead[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && ElementHead[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = ElementHead[i+iStartTagIndex];
			TAG[i]='\0';	
			
			if(strstr(TAG,STR_COMPLEX_TYPE) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iComplexTypeStartIndex = iEndTagIndex;
			}
			if(strstr(TAG,STR_COMPLEX_TYPE) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iComplexTypeEndIndex = iStartTagIndex;
				COMPLEX_TYPE_STR = (char*)malloc(sizeof(char)*(iComplexTypeEndIndex-iComplexTypeStartIndex));
				for(i = 0 ; i < (iComplexTypeEndIndex-iComplexTypeStartIndex) ; i++)
					COMPLEX_TYPE_STR[i] = ElementHead[i+iComplexTypeStartIndex];
				COMPLEX_TYPE_STR[i] = '\0';
				//printf("Next Complex Type is %s\n",COMPLEX_TYPE_STR);
				element_Head->complextypes = (struct COMPLEX_TYPE*)malloc(sizeof(COMPLEX_TYPE));
				ParseComplexType(wsdlMessage,(COMPLEX_TYPE*)element_Head->complextypes,COMPLEX_TYPE_STR);				
			}			
					
			bStartTagFound = FALSE;
			bEndTagFound = FALSE;
		}
	}	
}
void ParseComplexType(WSDLMSG *wsdlMessage,COMPLEX_TYPE *pComplexType,char *ComplexType)
{
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE;
	unsigned int iStartTagIndex = 0,iEndTagIndex = 0,iTagSize = 0;
	unsigned int iSequenceStartIndex = 0,iSequenceEndIndex = 0;
	
	char *TAG = NULL , *SEQUENCE_STR = NULL;

	while(index < strlen(ComplexType))
	{
		if((bStartTagFound == FALSE) && ComplexType[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && ComplexType[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = ComplexType[i+iStartTagIndex];
			TAG[i]='\0';	

			if(strstr(TAG,STR_SEQUENCE) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iSequenceStartIndex = iEndTagIndex;
			}
			if(strstr(TAG,STR_SEQUENCE) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iSequenceEndIndex = iStartTagIndex;
				SEQUENCE_STR = (char*)malloc(sizeof(char)*(iSequenceEndIndex-iSequenceStartIndex));
				for(i = 0 ; i < (iSequenceEndIndex-iSequenceStartIndex) ; i++)
					SEQUENCE_STR[i] = ComplexType[i+iSequenceStartIndex];
				SEQUENCE_STR[i] = '\0';	
				//printf("Next Sequence String is %s\n",SEQUENCE_STR);			
				pComplexType->sequence = (struct SEQUENCE*)malloc(sizeof(SEQUENCE));
				ParseSequence(wsdlMessage,(SEQUENCE*)pComplexType->sequence,SEQUENCE_STR);
			}						
		
			bStartTagFound = FALSE;
			bEndTagFound = FALSE;
		}
	}	
}
void ParseSequence(WSDLMSG *wsdlMessage,SEQUENCE *pSequence,char *Sequence)
{
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE;
	unsigned int iStartTagIndex = 0,iEndTagIndex = 0,iTagSize = 0;
	unsigned int iElementStartIndex = 0,iElementEndIndex = 0;
	
	char *TAG = NULL , *ELEMENT_STR = NULL;

	//printf("ParseElementsSequence : Sequence String : %s \n",Sequence);
	while(index < strlen(Sequence))
	{
		if((bStartTagFound == FALSE) && Sequence[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && Sequence[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = Sequence[i+iStartTagIndex];
			TAG[i]='\0';	
			
			//printf("Next Tag is %s\n",TAG);
			if(strstr(TAG,STR_ELEMENT) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iElementStartIndex = iStartTagIndex;
			}
			if(strstr(TAG,STR_ELEMENT) != NULL && strstr(TAG,MARKUP_END_TAG_OTHER) != NULL)
			{
				iElementEndIndex = iEndTagIndex;
				ELEMENT_STR = (char*)malloc(sizeof(char)*(iElementEndIndex-iElementStartIndex));
				for(i = 0 ; i < (iElementEndIndex-iElementStartIndex) ; i++)
					ELEMENT_STR[i] = Sequence[i+iElementStartIndex];
				ELEMENT_STR[i] = '\0';

				struct ELEMENT_PART* curElementPart = (struct ELEMENT_PART*)malloc(sizeof(ELEMENT_PART));
				
				if(strstr(ELEMENT_STR,STR_NAME) != NULL)
				{
					((ELEMENT_PART*)curElementPart)->name = ExtractAttributeByTag(strdup(ELEMENT_STR),STR_NAME);
				}
				if(strstr(ELEMENT_STR,STR_TYPE) != NULL)
				{
					((ELEMENT_PART*)curElementPart)->type = ExtractAttributeByTag(strdup(ELEMENT_STR),STR_TYPE);
				}
				if(strstr(ELEMENT_STR,STR_MINOCCURS) != NULL)
				{
					((ELEMENT_PART*)curElementPart)->minOccurs = ExtractAttributeByTag(strdup(ELEMENT_STR),STR_MINOCCURS);
				}
				if(strstr(ELEMENT_STR,STR_MAXOCCURS) != NULL)
				{
					((ELEMENT_PART*)curElementPart)->maxOccurs = ExtractAttributeByTag(strdup(ELEMENT_STR),STR_MAXOCCURS);
				}					
				((ELEMENT_PART*)curElementPart)->next = NULL;
				
				//printf("ParseElementsSequence : Element String : %s \n",ELEMENT_STR);
								
				if(((SEQUENCE*)pSequence)->elements == NULL)
				{
					//printf("ParseElementsSequence : First Element \n");
					((SEQUENCE*)pSequence)->elements = curElementPart;										
				}
				else
				{
					//printf("ParseElementsSequence : Further Element \n"); 					
					struct ELEMENT_PART* temp = (struct ELEMENT_PART*)((SEQUENCE*)pSequence)->elements;
					while(((ELEMENT_PART*)temp)->next != NULL)
					{
						temp = ((ELEMENT_PART*)temp)->next;
					}
					((ELEMENT_PART*)temp)->next = curElementPart;													
				}
			}						
		
			bStartTagFound = FALSE;
			bEndTagFound = FALSE;
		}
	}	
}
void ParsePortType(WSDLMSG *wsdlMessage,char *PortType)
{
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTagSize = 0;
	unsigned int iOpStartIndex=0,iOpEndIndex=0,iOpAttrStartIndex=0,iOpAttrEndIndex=0;
	unsigned int iInputStartIndex=0,iInputEndIndex=0,iOutputStartIndex=0,iOutputEndIndex=0;
	
	char *TAG = NULL,*OP = NULL,*OPATTR = NULL,*INPUT = NULL,*OUTPUT = NULL;

	struct OPERATION* operation = NULL;
	
	while(index < strlen(PortType))
	{
		if((bStartTagFound == FALSE) && PortType[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && PortType[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = PortType[i+iStartTagIndex];
			TAG[i]='\0';	
					
			if(strstr(TAG,STR_OPERATION_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iOpStartIndex = iEndTagIndex;
				
				iOpAttrStartIndex = iStartTagIndex+1;
				iOpAttrEndIndex = iEndTagIndex-1;
				
				operation = (struct OPERATION*)malloc(sizeof(OPERATION));
				
				OPATTR = (char*)malloc(sizeof(char)*(iOpAttrEndIndex-iOpAttrStartIndex));
				for(i=0;i<(iOpAttrEndIndex-iOpAttrStartIndex);i++)
					OPATTR[i] = PortType[i+iOpAttrStartIndex];
				OPATTR[i] = '\0';
	
				((OPERATION*)operation)->name = ExtractAttributeByTag(strdup(OPATTR),STR_NAME);			
								
			 	printf("Operation Name Value is %s\n",((OPERATION*)operation)->name);												
			}
			if(strstr(TAG,STR_OPERATION_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iOpEndIndex = iStartTagIndex;				
				
				OP = (char*)malloc(sizeof(char)*(iOpEndIndex-iOpStartIndex));
				for(i=0;i<(iOpEndIndex-iOpStartIndex);i++)
					OP[i] = PortType[i+iOpStartIndex];
				OP[i] = '\0';					
				ParseOperation((OPERATION*)operation,OP);		
				
				// TODO : Add Code to insert it in the linked list
				((OPERATION*)operation)->next = NULL;
				if(((PORT_TYPE*)port_type)->operations == NULL)
				{
					printf("There is no other operation already\n");
					((PORT_TYPE*)port_type)->operations = operation;
				}
				else
				{
					printf("There is another operation already\n");
					struct OPERATION* temp = ((PORT_TYPE*)port_type)->operations;
					
					while(((OPERATION*)temp)->next != NULL)
					{
						printf("Moving on to the next node\n");
						temp = ((OPERATION*)temp)->next;
					}
					
					((OPERATION*)temp)->next = operation;
				}
			}
			bStartTagFound = FALSE;
			bEndTagFound = FALSE;
		}
	}	
}
void ParseOperation(OPERATION* operation,char *Operation)
{
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTagSize = 0;
	unsigned int iInputStartIndex=0,iInputEndIndex=0,iOutputStartIndex=0,iOutputEndIndex=0;
	
	char *TAG = NULL,*INPUT = NULL,*OUTPUT = NULL;

	while(index < strlen(Operation))
	{
		if((bStartTagFound == FALSE) && Operation[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && Operation[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = Operation[i+iStartTagIndex];
			TAG[i]='\0';	
		
			if(strstr(TAG,STR_INPUT_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iInputStartIndex = iStartTagIndex;
			}
			if(strstr(TAG,STR_INPUT_TAG) != NULL && (strstr(TAG,MARKUP_END_TAG) != NULL || strstr(TAG,MARKUP_END_TAG_OTHER) != NULL))
			{
				iInputEndIndex = iEndTagIndex;
				INPUT = (char*)malloc(sizeof(char)*(iInputEndIndex-iInputStartIndex));
				for(i=0;i<(iInputEndIndex-iInputStartIndex);i++)
					INPUT[i] = Operation[i+iInputStartIndex];
				INPUT[i] = '\0';
				((OPERATION*)operation)->inputs = (struct OPERATION_ELEMENT*)malloc(sizeof(OPERATION_ELEMENT));
				((OPERATION_ELEMENT*)((OPERATION*)operation)->inputs)->message = ExtractAttributeByTag(strdup(INPUT),STR_MESSAGE);
				
				printf("The Input Element Message Attribute is %s\n",((OPERATION_ELEMENT*)((OPERATION*)operation)->inputs)->message);
			}						
			if(strstr(TAG,STR_OUTPUT_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iOutputStartIndex = iStartTagIndex;
			}
			if(strstr(TAG,STR_OUTPUT_TAG) != NULL && (strstr(TAG,MARKUP_END_TAG) != NULL || strstr(TAG,MARKUP_END_TAG_OTHER) != NULL))
			{
				iOutputEndIndex = iEndTagIndex;
				OUTPUT = (char*)malloc(sizeof(char)*(iOutputEndIndex-iOutputStartIndex));
				for(i=0;i<(iOutputEndIndex-iOutputStartIndex);i++)
					OUTPUT[i] = Operation[i+iOutputStartIndex];
				OUTPUT[i] = '\0';
				
				((OPERATION*)operation)->outputs = (struct OPERATION_ELEMENT*)malloc(sizeof(OPERATION_ELEMENT));
				((OPERATION_ELEMENT*)((OPERATION*)operation)->outputs)->message = ExtractAttributeByTag(strdup(OUTPUT),STR_MESSAGE);;				
								
				printf("The Output Element Message Attribute is %s\n",((OPERATION_ELEMENT*)((OPERATION*)operation)->outputs)->message);				
			}		
			
			bStartTagFound = FALSE;
			bEndTagFound = FALSE;
		}
	}
}
void ParseBinding(WSDLMSG *wsdlMessage,char *Binding)
{
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTagSize = 0;
	unsigned int iSoapBinStartIndex=0,iSoapBinEndIndex=0,iOpStartIndex=0,iOpEndIndex=0,iOpTagStartIndex=0,iOpTagEndIndex=0;
	
	char *TAG = NULL,*SOAPBIN = NULL,*OP = NULL,*OPTAG = NULL;

	struct BINDING_OP* binding_Op = NULL;
	
	while(index < strlen(Binding))
	{
		if((bStartTagFound == FALSE) && Binding[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && Binding[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = Binding[i+iStartTagIndex];
			TAG[i]='\0';	
		
			if(strstr(TAG,STR_SOAP_BINDING_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iSoapBinStartIndex = iStartTagIndex;
			}
			if(strstr(TAG,STR_SOAP_BINDING_TAG) != NULL && (strstr(TAG,MARKUP_END_TAG) != NULL || strstr(TAG,MARKUP_END_TAG_OTHER) != NULL))
			{
				iSoapBinEndIndex = iEndTagIndex;
				SOAPBIN = (char*)malloc(sizeof(char)*(iSoapBinEndIndex-iSoapBinStartIndex));
				for(i=0;i<(iSoapBinEndIndex-iSoapBinStartIndex);i++)
					SOAPBIN[i] = Binding[i+iSoapBinStartIndex];
				SOAPBIN[i] = '\0';
				((BINDING*)binding)->soapBinding = malloc(sizeof(SOAPBINDING));
				if(strstr(SOAPBIN,STR_TRANSPORT) != NULL)
				{
					((SOAPBINDING*)((BINDING*)binding)->soapBinding)->transport = ExtractAttributeByTag(strdup(SOAPBIN),STR_TRANSPORT);
					//strcpy(((SOAPBINDING*)((BINDING*)binding)->soapBinding)->transport,ExtractAttributeByTag(strdup(SOAPBIN),STR_TRANSPORT));
					printf("The Soap Binding Element transport Attribute is %s\n",((SOAPBINDING*)((BINDING*)binding)->soapBinding)->transport);
				}
				if(strstr(SOAPBIN,STR_STYLE) != NULL)
				{
					((SOAPBINDING*)((BINDING*)binding)->soapBinding)->style = ExtractAttributeByTag(strdup(SOAPBIN),STR_STYLE);
					printf("The Soap Binding Element style Attribute is %s\n",((SOAPBINDING*)((BINDING*)binding)->soapBinding)->style);
				}
			}				
			if(strstr(TAG,STR_OPERATION_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				
				iOpStartIndex = iEndTagIndex;
				
				iOpTagStartIndex = iStartTagIndex;
				iOpTagEndIndex = iEndTagIndex;
				OPTAG = (char*)malloc(sizeof(char)*(iOpTagEndIndex-iOpTagStartIndex));
				for(i=0;i<(iOpTagEndIndex-iOpTagStartIndex);i++)
					OPTAG[i] = Binding[i+iOpTagStartIndex];
				OPTAG[i] = '\0';				

				binding_Op = (struct BINDING_OP*)malloc(sizeof(BINDING_OP));				
								
				if(strstr(OPTAG,STR_NAME) != NULL)
				{
					((BINDING_OP*)binding_Op)->name = ExtractAttributeByTag(strdup(OPTAG),STR_NAME);
					printf("WSDL Operation Element Name Attribute is %s\n",((BINDING_OP*)binding_Op)->name);					
				}		
						
			}
			if(strstr(TAG,STR_OPERATION_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				iOpEndIndex = iStartTagIndex;
				OP = (char*)malloc(sizeof(char)*(iOpEndIndex-iOpStartIndex));
				for(i=0;i<(iOpEndIndex-iOpStartIndex);i++)
					OP[i] = Binding[i+iOpStartIndex];
				OP[i] = '\0';				
				ParseBindingOperation(wsdlMessage,(BINDING_OP*)binding_Op,OP);				
							
				((BINDING_OP*)binding_Op)->next = NULL;				
				
				if(((BINDING*)binding)->binding_Op == NULL)
				{
					printf("There is no other binding operation already\n");
					((BINDING*)binding)->binding_Op = binding_Op;				
				}
				else
				{
					printf("There is another binding operation already\n");
					struct BINDING_OP* temp = ((BINDING*)binding)->binding_Op;
					
					while(((BINDING_OP*)temp)->next != NULL)
					{
						printf("Moving on to the next node\n");
						temp = ((BINDING_OP*)temp)->next;
					}					
					((BINDING_OP*)temp)->next = binding_Op;
				}				
			}		
			
			bStartTagFound = FALSE;
			bEndTagFound = FALSE;
		}
	}	
}
void ParseBindingOperation(WSDLMSG *wsdlMessage,BINDING_OP *binding_Op, char *BindingOp)
{
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTagSize = 0;
 	unsigned int iSoapOpTagStartIndex=0,iSoapOpTagEndIndex=0,iSoapInputStartIndex=0,iSoapInputEndIndex=0;
	unsigned int iSoapOutputStartIndex=0,iSoapOutputEndIndex=0;
	
	char *TAG = NULL,*SOAPOP = NULL,*SOAPINPUT = NULL,*SOAPOUTPUT = NULL;

	while(index < strlen(BindingOp))
	{
		if((bStartTagFound == FALSE) && BindingOp[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && BindingOp[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = BindingOp[i+iStartTagIndex];
			TAG[i]='\0';			
			
			if(strstr(TAG,STR_SOAP_OP_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				((BINDING_OP*)binding_Op)->soapOp = malloc(sizeof(SOAP_OP));
				
				iSoapOpTagStartIndex = iStartTagIndex;
				iSoapOpTagEndIndex = iEndTagIndex;
				SOAPOP = (char*)malloc(sizeof(char)*(iSoapOpTagEndIndex-iSoapOpTagStartIndex));
				for(i=0;i<(iSoapOpTagEndIndex-iSoapOpTagStartIndex);i++)
					SOAPOP[i] = BindingOp[i+iSoapOpTagStartIndex];
				SOAPOP[i] = '\0';
				
				if(strstr(SOAPOP,STR_SOAP_ACTION) != NULL)
				{
					((SOAP_OP*)((BINDING_OP*)binding_Op)->soapOp)->soapAction = ExtractAttributeByTag(strdup(SOAPOP),STR_SOAP_ACTION);					
					
					printf("Soap Operation Element SoapAction Attribute is %s\n",((SOAP_OP*)((BINDING_OP*)binding_Op)->soapOp)->soapAction);
				}				
				if(strstr(SOAPOP,STR_STYLE) != NULL)
				{
					((SOAP_OP*)((BINDING_OP*)binding_Op)->soapOp)->style = ExtractAttributeByTag(strdup(SOAPOP),STR_STYLE);
					
					printf("Soap Operation Element Style Attribute is %s\n",((SOAP_OP*)((BINDING_OP*)binding_Op)->soapOp)->style);	
				}								
			}
			if(strstr(TAG,STR_INPUT_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iSoapInputStartIndex = iEndTagIndex;
			}
			if(strstr(TAG,STR_INPUT_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				((BINDING_OP*)binding_Op)->binOpInput = malloc(sizeof(BIN_OP_INPUT));
				
				iSoapInputEndIndex = iStartTagIndex;
 				SOAPINPUT = (char*)malloc(sizeof(char)*(iSoapInputEndIndex-iSoapInputStartIndex));
				for(i=0;i<(iSoapInputEndIndex-iSoapInputStartIndex);i++)
					SOAPINPUT[i] = BindingOp[i+iSoapInputStartIndex];
				SOAPINPUT[i] = '\0';
				//ParseInputSoapBody(wsdlMessage,SOAPINPUT);
			}						
			if(strstr(TAG,STR_OUTPUT_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{
				iSoapOutputStartIndex = iEndTagIndex;
			}
			if(strstr(TAG,STR_OUTPUT_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL)
			{
				((BINDING_OP*)binding_Op)->binOpOutput = malloc(sizeof(BIN_OP_OUTPUT));				
				iSoapOutputEndIndex = iStartTagIndex;
 				SOAPOUTPUT = (char*)malloc(sizeof(char)*(iSoapOutputEndIndex-iSoapOutputStartIndex));
				for(i=0;i<(iSoapOutputEndIndex-iSoapOutputStartIndex);i++)
					SOAPOUTPUT[i] = BindingOp[i+iSoapOutputStartIndex];
				SOAPOUTPUT[i] = '\0';
				//ParseOutputSoapBody(wsdlMessage,SOAPOUTPUT);
			}						
			
			bStartTagFound = FALSE;
			bEndTagFound = FALSE;
		}
	}	
}
void ParseInputSoapBody(WSDLMSG *wsdlMessage,char *soapBody)
{
	((BIN_OP_INPUT*)((BINDING_OP*)((BINDING*)binding)->binding_Op)->binOpInput)->soapBody = malloc(sizeof(SOAP_BODY));	
	((SOAP_BODY*)((BIN_OP_INPUT*)((BINDING_OP*)((BINDING*)binding)->binding_Op)->binOpInput)->soapBody)->use = ExtractAttributeByTag(strdup(soapBody),STR_USE);
	printf("The soap Body Element use Attribute is %s\n",((SOAP_BODY*)((BIN_OP_INPUT*)((BINDING_OP*)((BINDING*)binding)->binding_Op)->binOpInput)->soapBody)->use);
}
void ParseOutputSoapBody(WSDLMSG *wsdlMessage,char *soapBody)
{
	((BIN_OP_INPUT*)((BINDING_OP*)((BINDING*)binding)->binding_Op)->binOpOutput)->soapBody = malloc(sizeof(SOAP_BODY));	
	((SOAP_BODY*)((BIN_OP_OUTPUT*)((BINDING_OP*)((BINDING*)binding)->binding_Op)->binOpOutput)->soapBody)->use = ExtractAttributeByTag(strdup(soapBody),STR_USE);	
	printf("The soap Body Element use Attribute is %s\n",((SOAP_BODY*)((BIN_OP_OUTPUT*)((BINDING_OP*)((BINDING*)binding)->binding_Op)->binOpOutput)->soapBody)->use);	
}
void ParseService(WSDLMSG *wsdlMessage,char *Service)
{
	unsigned int index = 0, i = 0;
	unsigned int bStartTagFound = FALSE,bEndTagFound = FALSE;
	unsigned int iStartTagIndex=0,iEndTagIndex=0;
	unsigned int iTagSize = 0;
	unsigned int iPortStartIndex=0,iPortEndIndex=0,iPortAttrStartIndex=0,iPortAttrEndIndex=0;
	
	char *TAG = NULL,*PORT_STR = NULL,*PORTATTR = NULL;

	while(index < strlen(Service))
	{
		if((bStartTagFound == FALSE) && Service[index] == TAG_START)
		{
			iStartTagIndex = index;
			bStartTagFound = TRUE;
		}
		if((bEndTagFound == FALSE) && Service[index] == TAG_END)
		{
			iEndTagIndex = index+1;
			bEndTagFound = TRUE;
		}
		index++;
		if(bStartTagFound == TRUE && bEndTagFound == TRUE)
		{
			iTagSize = iEndTagIndex - iStartTagIndex;
			TAG = (char*)malloc(sizeof(char)*(iTagSize));
			for(i = 0 ; i < iTagSize ; i++)
				TAG[i] = Service[i+iStartTagIndex];
			TAG[i]='\0';	
		
			if(strstr(TAG,STR_PORT_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) == NULL)
			{		
			  ((SERVICE*)service)->port = malloc(sizeof(PORT));
				iPortStartIndex = iEndTagIndex;
				
				iPortAttrStartIndex = iStartTagIndex+1;
				iPortAttrEndIndex = iEndTagIndex-1;
				
				PORTATTR = (char*)malloc(sizeof(char)*(iPortAttrEndIndex-iPortAttrStartIndex));
				for(i=0;i<(iPortAttrEndIndex-iPortAttrStartIndex);i++)
					PORTATTR[i] = Service[i+iPortAttrStartIndex];
				PORTATTR[i] = '\0';
			 	if(strstr(PORTATTR,STR_NAME) != NULL)
				{
					((PORT*)((SERVICE*)service)->port)->name = ExtractAttributeByTag(strdup(PORTATTR),STR_NAME);
					printf("Port Element Name Attribute Value is %s\n",((PORT*)((SERVICE*)service)->port)->name);																
				}				
				if(strstr(PORTATTR,STR_BINDING) != NULL)	
				{
					((PORT*)((SERVICE*)service)->port)->binding = ExtractAttributeByTag(strdup(PORTATTR),STR_BINDING);
			 		printf("Port Element Binding Attribute Value is %s\n",((PORT*)((SERVICE*)service)->port)->binding);													
				}				
			}
			if(strstr(TAG,STR_PORT_TAG) != NULL && strstr(TAG,MARKUP_END_TAG) != NULL )
			{
				iPortEndIndex = iStartTagIndex;
				PORT_STR = (char*)malloc(sizeof(char)*(iPortEndIndex-iPortStartIndex));
				for(i=0;i<(iPortEndIndex-iPortStartIndex);i++)
					PORT_STR[i] = Service[i+iPortStartIndex];
				PORT_STR[i] = '\0';
				ParsePort(wsdlMessage,PORT_STR);				
			}						
			bStartTagFound = FALSE;
			bEndTagFound = FALSE;
		}
	}	
}
void ParsePort(WSDLMSG *wsdlMessage,char *Addr)
{
	if(strstr(Addr,STR_LOCATION) != NULL)
	{
	  ((PORT*)((SERVICE*)service)->port)->address = malloc(sizeof(ADDRESS));
		((ADDRESS*)((PORT*)((SERVICE*)service)->port)->address)->location = ExtractAttributeByTag(strdup(Addr),STR_LOCATION);
		printf("Address Element Location Attribute is %s\n",((ADDRESS*)((PORT*)((SERVICE*)service)->port)->address)->location);
	}
}
char* ExtractAttributeByTag(char *AttrStr,char *AttrTag)
{
	char *Attribute = NULL,*token=NULL,seps[] = " \t\n" , equ[] = "=",*AttributeVal = NULL;
	
	token = (char*)strtok( AttrStr, seps );
	while( token != NULL )
	{
		if(strstr(token,AttrTag) != NULL)
		{
			Attribute = token;
			break;
		}
		token = (char*)strtok( NULL, seps );		
	}	
	token = (char*)strtok(Attribute,equ);
	
	while(token != NULL)
	{
		if(strstr(token,AttrTag) == NULL)
		{
			AttributeVal = token;
			break;
		}		
		token = (char*)strtok( NULL, equ );	
	}
	//printf("ExtractAttributeByTag : IntermediateString : %s\n",AttributeVal);
	
	unsigned int index = 0,bStartFound = FALSE,bEndFound = FALSE,iStartIndex = 0,iEndIndex = 0;

	for(index = 0 ; index < (unsigned int)strlen(AttributeVal) ; index ++)
	{
		if(AttributeVal[index] == '"')
		{
			if(bStartFound == FALSE && bEndFound == FALSE)
			{
				iStartIndex = index+1;
				bStartFound = TRUE;
				continue;
			}
			if(bStartFound == TRUE)
			{
				iEndIndex = index;
				break;
			}
		}
	}
	char *tempStr = (char*)malloc(sizeof(char)*(iEndIndex-iStartIndex+1));
	for(index = 0;index <(iEndIndex-iStartIndex) ; index++)
		tempStr[index] = AttributeVal[index+iStartIndex];
	tempStr[index] = '\0';
	
	return tempStr;
}
void *wsdl_threaded_msg_parsing(void* ptr)
{
	/*
	PARSINGTHREADDATA_PTR data = (PARSINGTHREADDATA_PTR)ptr;
	pthread_t thread_event_src = pthread_self();
	fprintf(stdout, "\nWSDL PTHREAD parser = %p\n", thread_event_src);
	EVENTSRC_PTR evt_src = event_create_src((void*)thread_event_src, data->parser->unit);
	fprintf(stdout, "\nWSDL PTHREAD parser data is \n%s\n",data->msg->data);
*/	
	
	PARSINGTHREADDATA_PTR data = (PARSINGTHREADDATA_PTR)ptr;
	MSG_PTR msg = (MSG_PTR)data->msg;
	PARSER_PTR parser = (PARSER_PTR)data->parser;
	
	// in case of the parsing of a reply message:
	//  - The events that are generated by this parser must not carry the identifier of this parser? thread  as their event src, but
	//    the thread identifier of the parser that received the request message and generated the related events. This identifier is stored in the
	//    unit eventqueue_table and the corresponding entry can be found using the dest port of the msg to be parsed (that corresponds to the 
	//	  port set in the table by "unit.c / set_socket_and_parser and set_socket_and_composer"
	EVENTQUEUE_TABLE_ENTRY_PTR entry = eventqueue_table_get_entry_by_current_socket_reply_port(parser->unit->event_table, msg->dest_port);
	
	if (entry == NULL)
		fprintf(stdout, "wsdl_threaded_msg_parsing. entry not found for socket_reply_port=%d\n", msg->dest_port);
	
	else 
	{
		fprintf(stdout, "wsdl_threaded_msg_parsing. parser=%p  parser->unit=%p msg=%p\n", parser, parser->unit,msg);
				
		//fprintf(stdout, "ssdp_threaded_msg_parsing. SOCKET port is %d. thread id is %p\n",msg->dest_port, entry->stream_id);
		
		// the sub_stream_id used for the events generated by the thread that parses this upnp_servicedescr reply msg 
		// is the value set by the ssdp parser 
		pthread_t thread_event_src = pthread_self();
		fprintf(stdout, "\nWSDL PTHREAD parser = %p\n", thread_event_src);
		//entry->sub_stream_id = (int)thread_event_src;
		fprintf(stdout, "\nWSDL PTHREAD parser entry->sub_stream_id = %p\n", entry->sub_stream_id);
		
		// the stream_id for the event is sub_stream_id to distinguish between the different event flows for reply messages 
		EVENTSRC_PTR evt_src = event_create_src((void*)entry->sub_stream_id, parser->unit);
	
		
		//upnp_servicedescr_parse_msg(parser, msg, evt_src /*thread_event_src*/);
		
		wsdl_parse_msg(parser, msg , evt_src);	
		wsdl_processEvents(parser, evt_src);
		//free(evt_src);
	}
}

PARSER_PTR wsdl_parser_create(UNIT_PTR u)
{
	fprintf(stdout, "Creating WSDL parser\n");
	
	PARSER_PTR p = parser_create(u);
	p->func_msg_received = parser_msg_received;	
	
	p->func_parse = wsdl_threaded_msg_parsing;
	
	p->func_publish_event = parser_publish_event;
	p->evt_listeners = NULL;
	p->factory = wsdl_parser_create;	
	
	return p;	
}
