#include "parser/parser.h"
#include "unit/unit.h"

#include <pthread.h>
#include <stdio.h>



void parser_msg_received(MSG_PTR msg, LISTENER_PTR node)
{
	fprintf(stdout, "parser receives msg from SRC=%p. length=%d src_addr=%s src_port=%d \n",msg->src, msg->length, msg->src_address, msg->src_port);
	
	PARSER_PTR p = (PARSER_PTR)node->listener.parser;
	//p->func_parse(p, msg->data, msg->length);
	
	pthread_t parse_thread;
	PARSINGTHREADDATA_PTR data = malloc(sizeof(PARSINGTHREADDATA));
	data->msg = msg;
	data->parser = p;
	
	fprintf(stdout, "\nCREATING PTHREAD parser = %p\n", parse_thread);
	
	pthread_create(&parse_thread, NULL, p->func_parse, (void*)data);
	pthread_join(parse_thread,  NULL);
	fprintf(stdout, "\nparser_msg_received thread finished: %p\n", parse_thread);
}

void parser_event_received(EVENT_PTR evt, LISTENER_PTR node)
{
	fprintf(stdout, "parser receives event type=%d src=%p. parser listeners=%p\n", evt->type, evt->stream_id, node->listener.parser);
	parser_publish_event(evt, node->listener.parser);
}

int parser_add_evtlistener(PARSER_PTR parser, struct listener* evt_list)
{
	fprintf(stdout, "parser_add_evtlistener\n");
        LISTENER_LIST_ENTRY_PTR list_entry = (LISTENER_LIST_ENTRY_PTR)malloc(sizeof(LISTENER_LIST_ENTRY));
	list_entry->node = evt_list;
	list_entry->next = NULL;
	
	if (parser->evt_listeners == NULL) {
		parser->evt_listeners = list_entry;	
	} else {
		list_entry->next = parser->evt_listeners;
		parser->evt_listeners = list_entry;
	}
}
	
int parser_add_evtlistener_unit(PARSER_PTR parser, struct unit* u)
{
	fprintf(stdout, "parser_add_evtlistener_unit\n");
	LISTENER_PTR evt_list = (LISTENER_PTR)malloc(sizeof(LISTENER/*_PTR*/));
	evt_list->type = LISTENER_UNIT;
	evt_list->listener.unit = u;
	parser_add_evtlistener(parser, evt_list);
}

void parser_publish_event(EVENT_PTR evt, PARSER_PTR parser)
{
	fprintf(stdout, "parser_publish_event\n");
	LISTENER_LIST_PTR l;

	for (l = parser->evt_listeners; l != NULL; l = l->next)
	{
	   LISTENER_PTR node = l->node;

	   /*if (node->type == LISTENER_PARSER) {
		PARSER_PTR p = (PARSER_PTR)node->listener.parser;
		fprintf(stdout, "parser_publish_event on parser %p\n",p);
		if (p != evt->src)
			p->func_event_received(evt, node);
	   }
	   else */if (node->type == LISTENER_COMPOSER) {
		COMPOSER_PTR p = (COMPOSER_PTR)node->listener.composer;
		fprintf(stdout, "parser_publish_event on composer %p\n",p);
		//if (p != (void*)(evt->stream_id))
			p->func_event_received(evt, node);
	   }
	   else if (node->type == LISTENER_UNIT) {
		UNIT_PTR u = (UNIT_PTR)node->listener.unit;
		fprintf(stdout, "parser_publish_event on unit %p\n",u);
		//if (u != (void*)(evt->stream_id))
			u->func_event_received(evt, node);
	   }
	}
}


PARSER_PTR parser_create(UNIT_PTR u)
{
	fprintf(stdout, "Creting parser\n");
		
	
	PARSER_PTR p = (PARSER_PTR)malloc(sizeof(PARSER));
	p->func_msg_received = parser_msg_received;
	p->func_publish_event = parser_publish_event;
	//unit_add_evtlistener_parser(u, p);
	p->evt_listeners = NULL;
	p->unit = u;	
	
	return p;	
}

