#include "parser/parser.h"
#include "unit/unit.h"

#include <stdio.h>
#include <pthread.h>
#include <string.h>
#include <ctype.h>


#include "protocol/ssdpmsg.h"


void ssdp_processEvents(PARSER_PTR parser, SSDPMSG_PTR ssdpmsg, EVENTSRC_PTR evt_src /*, pthread_t thread_event_src*/)
{
	int evt_stream_id = (int)(evt_src->src_thread_parser);

	
	/*switch(slpmsg_get_function_id(slpmsg)) 
	{
		case SrvRqst	: 	//CLASS DISCOVERY	
		*/	
	
	if (ssdpmsg_isReply(ssdpmsg))
	{
		
		parser_publish_event(event_create(SDP_START, evt_stream_id, (void*)evt_src), parser);	
		parser_publish_event(event_create(SDP_UPNP, evt_stream_id, (void*)evt_src), parser);
	    parser_publish_event(event_create(SDP_SERVICE_RESPONSE, evt_stream_id, (void*)evt_src), parser);
	    
	    char* location = ssdp_get_location(ssdpmsg);
    	char* location_url_nopath;
    	char* location_url_path;
    	
    	parseURL_nopath_path(location, &location_url_nopath, &location_url_path);
   /* 	
	    //http://128.93.8.23:4004/description.xml
	    	
	    //int i;
	    int last_index = -1;

	    char* last_char = strrchr (location, '/');
	    
	    if (last_char != NULL)
	    {
	    	location_url_nopath = (char*)strndup(location, (int)(last_char - location +1));
	    	location_url_path = strdup(last_char );
	    	fprintf(stdout,"\n 1 location=%s,  location_url_nopath=%s location_url_path=%s  \n",location ,location_url_nopath, location_url_path);
	    }
	    else
	    {
	    	location_url_nopath = strdup(location);
	    	location_url_path = NULL;
	    	fprintf(stdout,"\n 2 location=%s,  location_url_nopath=%s location_url_path=%s  \n",location ,location_url_nopath,location_url_path);
	    }
*/	    	
	    	
	    parser_publish_event(event_create_string(SDP_SERVICE_DESCR_URL_NOPATH, location_url_nopath, evt_stream_id, (void*)evt_src), parser);	
	    parser_publish_event(event_create_string(SDP_SERVICE_DESCR_URL_PATH, location_url_path, evt_stream_id, (void*)evt_src), parser);
	    parser_publish_event(event_create_string(SDP_SERVICE_CTRL_URL_NOPATH, location_url_nopath, evt_stream_id, (void*)evt_src), parser);
	    
//	    parser_publish_event(event_create_string(SDP_SERVICEPROXY_URL_CTRL, "http://serviceproxy_url", evt_stream_id, (void*)evt_src), parser);
		
		parser_publish_event(event_create_string(SDP_SOURCE_ADDR, ssdpmsg_get_src_addr(ssdpmsg), evt_stream_id, (void*)evt_src), parser);
		parser_publish_event(event_create_int(SDP_SOURCE_PORT, ssdpmsg_get_src_port(ssdpmsg), evt_stream_id, (void*)evt_src), parser);

		parser_publish_event(event_create(SDP_STOP, evt_stream_id, (void*)evt_src), parser);

	} 
	else if (ssdpmsg_isSearch(ssdpmsg))
	{
		
		parser_publish_event(event_create(SDP_START, evt_stream_id, (void*)evt_src), parser);	
		parser_publish_event(event_create(SDP_UPNP, evt_stream_id, (void*)evt_src), parser);
	    parser_publish_event(event_create(SDP_SERVICE_REQUEST, evt_stream_id, (void*)evt_src), parser);
	    //parser_publish_event(event_create_int(SDP_VERSION, slpmsg_get_version(slpmsg), evt_stream_id, (void*)evt_src), parser);
	    //parser_publish_event(event_create_string(SDP_REQ_LANGAGE, slpmsg_get_lang_tag(slpmsg), evt_stream_id, (void*)evt_src), parser);
	    //parser_publish_event(event_create_string(SDP_REQ_SCOPE, slpmsg_get_scope_list(slpmsg), evt_stream_id, (void*)evt_src), parser);
	    //parser_publish_event(event_create_string(SDP_REQ_PREDICAT, slpmsg_get_predicate(slpmsg), evt_stream_id, (void*)evt_src), parser);
	    //parser_publish_event(event_create_string(SDP_REQ_REQUESTER, slpmsg_get_pr_list(slpmsg), evt_stream_id, (void*)evt_src), parser);
	    //parser_publish_event(event_create_int(SDP_REQ_ID, slpmsg_get_xid(slpmsg), evt_stream_id, (void*)evt_src), parser);
	    
	    
	    char* service_type = ssdpmsg_get_header(ssdpmsg, "ST");
	    fprintf(stdout,"\n ST=%s  \n",service_type);
	    if (!strncmp(service_type, "urn:schemas-upnp-org:device:", 28))
	    {
	    	char* service_type_tmp = service_type + 28;
	    	char* service_type_tmp2 = strtok_r (service_type_tmp, ":", &service_type_tmp);
	    	parser_publish_event(event_create_string(SDP_REQ_SERVICE_TYPE, service_type_tmp2, evt_stream_id, (void*)evt_src), parser);
	    }
	    else
	    	parser_publish_event(event_create_string(SDP_REQ_SERVICE_TYPE, service_type, evt_stream_id, (void*)evt_src), parser);
		
		parser_publish_event(event_create_string(SDP_SOURCE_ADDR, ssdpmsg_get_src_addr(ssdpmsg), evt_stream_id, (void*)evt_src), parser);
		parser_publish_event(event_create_int(SDP_SOURCE_PORT, ssdpmsg_get_src_port(ssdpmsg), evt_stream_id, (void*)evt_src), parser);

		parser_publish_event(event_create(SDP_STOP, evt_stream_id, (void*)evt_src), parser);
	}

}


void ssdp_parse_msg_firstline(char** data, int length, SSDPMSG_PTR ssdpmsg)
{
	
	char* firstline = strtok_r (*data, "\r", data);
	char* token_first = strtok_r (firstline, " ", &firstline);
	char* token_second = strtok_r (NULL, " ", &firstline);
	char* token_third = strtok_r (NULL, " ", &firstline);
	
	// to remove "\r" from the char stream "data" 
	(*data)++;
	
	fprintf(stdout,"\n firstline=%s,  token_first=%s token_second=%s token_third =%s data=%s \n",firstline ,token_first,token_second,token_third , *data);
	
	if (!strcmp(token_first, "HTTP/1.1"))
	{
		/*
		 * SSDP REPLY
		 *  IF REPLY IS CORRECT: HTTP/1.1 200 OK
		 */
		ssdpmsg_set_isReply(ssdpmsg);
		ssdpmsg_set_version(ssdpmsg, token_first);
		ssdpmsg_set_code(ssdpmsg, token_second);
	} 
	else if (!strcmp(token_first, "M-SEARCH"))
	{
		ssdpmsg_set_isSearch(ssdpmsg);
		ssdpmsg_set_method(ssdpmsg, "M-SEARCH");
		ssdpmsg_set_uri(ssdpmsg, token_second);
		ssdpmsg_set_version(ssdpmsg, token_third);
	}
}

void ssdp_parse_msg_headers(char** data, int length, SSDPMSG_PTR ssdpmsg)
{
	
	char* line;
	int i = 0;
	
	line = strtok_r (*data, "\r", data);
	if (line != NULL)
	{
		char* header_name = strtok_r (line, ":", &line);
		char* header_value = strtok_r (NULL, "\r", &line);
		
		// remove spaces from the beginning of the header value
		while ((header_value != NULL) && isspace(*header_value))
				header_value++ ; 
		
		fprintf(stdout,"\n tline=%s i=%d, header_name=%s header_value=%s \n", line, i++ ,header_name,header_value );
		
		// to remove "\r" from the line of the char stream "data" 
		(*data)++;
		ssdpmsg_add_header(ssdpmsg, header_name,header_value);
		
		while ( (line = strtok_r (NULL, "\r", data)) && (line != NULL))
		{
			
			char* header_name = strtok_r (line, ":", &line);
			char* header_value = strtok_r (NULL, "\r", &line);
			 
			// remove spaces from the beginning of the header value
			while ((header_value != NULL) && isspace(*header_value))
					header_value++ ; 
			
			fprintf(stdout,"\n tline=%s i=%d,  header_name=%s header_value=%s \n", line, i++,header_name,header_value);
			
			// to remove "\r" from the line of the char stream "data" 
			(*data)++;
			
			ssdpmsg_add_header(ssdpmsg, header_name,header_value);
		
		}
	}



}

void ssdp_parse_msg(PARSER_PTR parser, MSG_PTR message, EVENTSRC_PTR evt_src /*, pthread_t thread_event_src*/)
{
	char* msg = message->data;
	int len = message->length;

	fprintf(stdout, "ssdp parse msg: ");
	int i;
	for (i=0; i<len; i++)
		fprintf(stdout,"%c",msg[i]);
	fprintf(stdout, "\n");
	
	SSDPMSG_PTR ssdpmsg = ssdpmsg_create();
	ssdpmsg_set_src_addr(ssdpmsg, message->src_address);
	ssdpmsg_set_src_port(ssdpmsg, message->src_port);
	
	ssdp_parse_msg_firstline(&message->data, message->length, ssdpmsg);
	ssdp_parse_msg_headers(&message->data, message->length, ssdpmsg);
	
	
	ssdp_processEvents(parser, ssdpmsg, evt_src /*thread_event_src*/);
}

void *ssdp_threaded_msg_parsing(void* ptr)
{
	PARSINGTHREADDATA_PTR data = (PARSINGTHREADDATA_PTR)ptr;
	MSG_PTR msg = (MSG_PTR)data->msg;
	PARSER_PTR parser = (PARSER_PTR)data->parser;
	
	// in case of the parsing of a reply message:
	//  - The events that are generated by this parser must not carry the identifier of this parser? thread  as their event src, but
	//    the thread identifier of the parser that received the request message and generated the related events. This identifier is stored in the
	//    unit eventqueue_table and the corresponding entry can be found using the dest port of the msg to be parsed (that corresponds to the 
	//	  port set in the table by "unit.c / set_socket_and_parser and set_socket_and_composer"
	EVENTQUEUE_TABLE_ENTRY_PTR entry_tmp = eventqueue_table_get_entry_by_current_socket_reply_port(parser->unit->event_table, msg->dest_port);
	
	if (entry_tmp == NULL && msg->dest_port == 1900)
	{
		/*
		 * In this case, the message is a discovery message received from a UPnP client
		 */
		fprintf(stdout, "ssdp_threaded_msg_parsing. entry not found for socket_reply_port=%d\n", msg->dest_port);
		
		pthread_t thread_event_src = pthread_self();	
		fprintf(stdout, "\nSSDP PTHREAD parser = %p\n", thread_event_src);
		
		EVENTSRC_PTR evt_src = event_create_src((void*)thread_event_src, data->parser->unit);
		
		ssdp_parse_msg(parser, msg, evt_src /*thread_event_src*/);
		//return;
	} 
	else if (entry_tmp != NULL)
	{
		/*
		 * In this case, the message is a reply to a discovery message received from a UPnP service
		 */
		
		EVENTQUEUE_TABLE_ENTRY_PTR entry = /*entry_tmp; */ eventqueue_table_copy_entry(parser->unit->event_table, entry_tmp);
	
		fprintf(stdout, "ssdp_threaded_msg_parsing. parser=%p  parser->unit=%p msg=%p\n", parser, parser->unit,msg);
				
		//fprintf(stdout, "ssdp_threaded_msg_parsing. SOCKET port is %d. thread id is %p\n",msg->dest_port, entry->stream_id);
		
		// the thread that parses this ssdp reply msg is used as an identifier for sub_stream_id
		pthread_t thread_event_src = pthread_self();
		fprintf(stdout, "\nSSDP PTHREAD parser = %p\n", thread_event_src);
		entry->sub_stream_id = (int)thread_event_src;
		fprintf(stdout, "\nSSDP PTHREAD parser entry->sub_stream_id = %p\n", entry->sub_stream_id);
		
		// the stream_id for the event is sub_stream_id to distinguish between the different event flows for reply messages 
		EVENTSRC_PTR evt_src = event_create_src((void*)entry->sub_stream_id, parser->unit);
		
		// add sub_stream_id to engine for handling the flow of events carrying sub_stream_id as stream_id
		//setCurrentState("UPNP_SLP_WAIT_UPNP_DEVICE_RESPONSE", entry->sub_stream_id, parser->unit->engine);
		setCurrentState("UPNP_SLP_SSDP_REPLY", entry->sub_stream_id, parser->unit->engine);
		
		
		//char* engine_current_state = getCurrentState(entry->sub_stream_id, parser->unit->engine);
		//setCurrentState(engine_current_state, entry->sub_stream_id, parser->unit->engine);
		
		ssdp_parse_msg(parser, msg, evt_src /*thread_event_src*/);
		
		//free(evt_src);
	}
	else
		fprintf(stdout, "\nSSDP PTHREAD parser : ENTRY NOT FOUND for ssdp reply to port %d\n",msg->dest_port);
	
	//msg_free(msg);
	//free(parser); NO!!! SEGFAULT if freed
	//free(ptr);
}

PARSER_PTR ssdp_parser_create(UNIT_PTR u)
{
	fprintf(stdout, "Creating SSDP parser\n");
		
	PARSER_PTR p = parser_create(u);
	p->func_msg_received = parser_msg_received;
	
	p->func_parse = ssdp_threaded_msg_parsing;
	
	p->func_publish_event = parser_publish_event;
	p->evt_listeners = NULL;
	
	p->factory = ssdp_parser_create;
	
	return p;	
}

