#include <stdio.h>
#include "protocol/ssdpmsg.h"


SSDPMSG_PTR ssdpmsg_create()
{
	SSDPMSG_PTR msg = malloc(sizeof(SSDPMSG));
	
	msg->method = NULL;
	msg->version = NULL;
	msg->uri = NULL;
	msg->code = NULL;
	msg->headers = NULL;
	
	int isSearch = 0;
	int isReply = 0;
	
	return msg;
}





int ssdpmsg_set_method(SSDPMSG_PTR msg, char* method)
{
	if (method != NULL)
	{
		msg->method = strdup(method);
	} else
		msg->method = NULL;
}

char* ssdpmsg_get_method(SSDPMSG_PTR msg)
{
	return msg->method;
} 		 

int ssdpmsg_set_version(SSDPMSG_PTR msg, char* version)
{
	if (version != NULL)
	{
		msg->version = strdup(version);
	} else
		msg->version = NULL;
}

char* ssdpmsg_get_version(SSDPMSG_PTR msg)
{
	return msg->version;
} 	

int ssdpmsg_set_uri(SSDPMSG_PTR msg, char* uri)
{
	if (uri != NULL)
		msg->uri = strdup(uri);
	else 
		msg->uri = NULL;
}

char* ssdpmsg_get_uri(SSDPMSG_PTR msg)
{
	return msg->uri;
} 	

int ssdpmsg_set_code(SSDPMSG_PTR msg, char* code)
{
	if (code != NULL)
	{
		msg->code = strdup(code);
	} else
		msg->code = NULL;
}

char* ssdpmsg_get_code(SSDPMSG_PTR msg)
{
	return msg->code;
} 	

int ssdpmsg_add_header(SSDPMSG_PTR msg, char* name, char* value)
{
	if (name != NULL)
	{
		SSDP_HEADER_PTR header = malloc(sizeof(SSDP_HEADER));
	
		header->name = strdup(name);
		if (value!= NULL)
			header->value = strdup(value);
		else
			header->value = NULL;
		header->next = NULL;
		
		if (msg->headers == NULL)
			msg->headers = header;
		else
		{
			header->next = msg->headers;
			msg->headers = header;
		}
	}
}

char* ssdpmsg_get_header(SSDPMSG_PTR msg, char* name)
{
	SSDP_HEADER_PTR header = NULL;
	for (header = msg->headers; header != NULL; header = header->next)
		if (!strcmp(header->name, name))
			return header->value;
	return NULL;
} 

SSDP_HEADER_PTR ssdpmsg_get_headers(SSDPMSG_PTR msg)
{
	return msg->headers;
} 

	



int ssdpmsg_set_src_addr(SSDPMSG_PTR msg, char* src_addr)
{
	msg->src_addr = malloc(strlen(src_addr)+1);
	strcpy(msg->src_addr, src_addr);
}

char* ssdpmsg_get_src_addr(SSDPMSG_PTR msg)
{
	return msg->src_addr;
}

int ssdpmsg_set_src_port(SSDPMSG_PTR msg, int src_port)
{
	msg->src_port = src_port;
}

int ssdpmsg_get_src_port(SSDPMSG_PTR msg)
{
	return msg->src_port;
}

int ssdpmsg_set_dest_addr(SSDPMSG_PTR msg, char* dest_addr)
{
	if (dest_addr == NULL)
		msg->dest_addr = NULL;
	else
	{
		msg->dest_addr = strdup(dest_addr); 
		//malloc(strlen(dest_addr)+1);
		//strcpy(msg->dest_addr, dest_addr);
	}
}

char* ssdpmsg_get_dest_addr(SSDPMSG_PTR msg)
{
	return msg->dest_addr;
}

int ssdpmsg_set_dest_port(SSDPMSG_PTR msg, int dest_port)
{
	msg->dest_port = dest_port;
}

int ssdpmsg_get_dest_port(SSDPMSG_PTR msg)
{
	return msg->dest_port;
}


char* ssdp_get_location(SSDPMSG_PTR msg)
{
	char* location = ssdpmsg_get_header(msg, "LOCATION");
	if (location != NULL)
		return location;
	else
	{
		location = ssdpmsg_get_header(msg, "Location");
		return location;
	}
	return NULL;
}

int ssdpmsg_isSearch(SSDPMSG_PTR msg)
{
	return msg->isSearch;
}

int ssdpmsg_set_isSearch(SSDPMSG_PTR msg)
{
	msg->isSearch = 1;
	msg->isReply = 0;
}

int ssdpmsg_isReply(SSDPMSG_PTR msg)
{
	return msg->isReply;
}

int ssdpmsg_set_isReply(SSDPMSG_PTR msg)
{
	msg->isSearch = 0;
	msg->isReply = 1;
}


