#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <io/io.h>
#include <ser/objectparser.h>
#include <ser/classdescription.h>

#include <io/jtype.h>
#include "monitor/tools.h"


static j_boolean annotation = 0;


/*
static int currentHandle=baseWireHandle;
static j_boolean EndAnnotation;



void parseClass(int fd)
{
	
	
}

void parseArray(int fd)
{
	
	
}

void parseReference(int fd)
{
	fprintf(stdout,"parseReference()\n");
	j_int handle=0;
	parsejInt(fd,&handle);
	handle-= (j_int)baseWireHandle;	
	fprintf(stdout,"\thandle: %i\n",(int)handle);
}




*/


void composeReference(int fd)
{
    j_byte code = TC_REFERENCE;
    writejByte(fd, code);
    
	fprintf(stdout,"composeReference()\n");
	j_int handle = 8257536 + 1;
	writejInt(fd, handle);
	//handle = 1; //-= (j_int)baseWireHandle;	
	fprintf(stdout,"\thandle: %i\n",(int)handle);
}


int composeString(int fd, char* str)
{
	fprintf(stdout,"composeString:  %s\n", str);
	UTF8_PTR utf8 = stringToUTF8(str); 
	writejUtf8(fd, utf8);
}


int composeAnnotation(int fd)
{
    j_byte code = TC_STRING;
    writejByte(fd, code);
    
    char annot[255];
    sprintf(annot, "http://%s:%d%s/", get_host_ip(), get_httpserver_port(), get_httpserver_urlpath());      
    composeString(fd, annot /*"http://192.168.2.2:8080/tmp/"*/);
    code = TC_ENDBLOCKDATA; 
    writejByte(fd, code);

/*
	if(peekCode(fd)==TC_ENDBLOCKDATA) 
    {
     	parseCode(fd);
        fprintf(stdout,"No Annotation\n");
        EndAnnotation=true;
        return NULL;
    }
    else
    {
      char *str;
      str=(char *)parseObjectOutputStream(fd);
      fprintf(stdout,"Annotation: %s\t\n",str);
      return str;
    }
    return NULL;
*/
}



void composeFieldValue(int fd, SER_FIELD field)
{
	fprintf(stdout,"writeFieldValue()\n");
	
    switch (field.type_code) {
    case 'B':
    	writejByte(fd, (j_byte)field.value.byte_value);
    	break;
    case 'C':
    	writejByte(fd, (j_byte)field.value.char_value);
    	break;
    case 'Z':
    	writejByte(fd, (j_byte)field.value.boolean_value);
    	break;
    case 'I':
    	writejInt(fd, (j_byte)field.value.int_value);
    	break;
    case 'J':
    	writejLong(fd, (j_byte)field.value.long_value);
    	break;
    case 'S':
    	writejShort(fd, (j_byte)field.value.short_value);
    	break;   	
    case 'D':
    case 'F':
    case 'L':  
    case '[':
    {
    	//j_byte code = TC_STRING;
    	//writejByte(fd, code);
    	
    	fprintf(stdout,"writeFieldValue() for type code= %c not supported\n",field.type_code);
    	composeString(fd, (char*)"field.value.string_value");
    }
    	break;   
    default:
       fprintf(stdout,"invalid classDescInfo : %c\n",field.type_code);
    }

}

void composeFieldDesc(int fd, SER_FIELD field)
{
	fprintf(stdout,"writeFieldDesc()\n");
	
    switch (field.type_code) {
    case 'B':
    case 'C':
    case 'D':
    case 'F':
    case 'I':
    case 'J':	
    case 'S':
    case 'Z':
    {
    	writejByte(fd, field.type_code);
    	UTF8_PTR fieldname = stringToUTF8(field.name); 
    	writejUtf8(fd, fieldname);
		fprintf(stdout,"\tprimitive type code = %c, fieldName = %s\n",field.type_code, field.name);
    }
    	break;  
	   
    case 'L':  
    case '[':
    {
    	writejByte(fd, field.type_code);
    	UTF8_PTR fieldname = stringToUTF8(field.name); 
    	writejUtf8(fd, fieldname);
	    // write String: array/object type
    	//j_byte code = TC_STRING;
    	//writejByte(fd, code);
    	composeString(fd, field.class_name);
    }
    	break;   
    default:
       fprintf(stdout,"invalid classDescInfo : %c\n",field.type_code);
    }

}

void composeFields(int fd, SER_FIELDPTR fields, j_short sizeFields)
{  
 	writejShort(fd, sizeFields);

    fprintf(stdout,"\tNumber of fields: %i\n",(int)sizeFields);
    	
    int i = 0;    
    for (i = 0; i < sizeFields; i++) {
		composeFieldDesc(fd, fields[i]);
    }
	return;
}



void composeFlags(int fd, j_byte flags)
{
     writejByte(fd,flags);
	
     switch (flags) {
     case SC_WRITE_METHOD:
		fprintf(stdout,"\tflag= SC_WRITE_METHOD\n");
	    break;
     case SC_SERIALIZABLE:
		fprintf(stdout,"\tflag = SC_SERIALIZABLE\n");
		break;
     case SC_EXTERNALIZABLE:
		fprintf(stdout,"\tflag = SC_EXTERNALIZABLE\n");
		break;
     case (SC_WRITE_METHOD | SC_SERIALIZABLE):
		fprintf(stdout,"\tflag = SC_SERIALIZABLE + SC_WRITE_METHOD\n");
     	break;
     case (SC_BLOCK_DATA | SC_EXTERNALIZABLE):
		fprintf(stdout,"\tflag = SC_EXTERNALIZABLE + SC_BLOCK_DATA\n");
     break;
         
     default:
        fprintf(stdout,"invalid classDescInfo : %c\n", flags);
     }
}

int composeFieldsValues(int fd, CLASSDESCPTR class_ptr)
{
	fprintf(stdout,"Compose Fields Values for class %s\n", class_ptr->name);
	
	// write fields values
	SER_FIELDPTR fields = class_ptr->field;
	j_short sizeFields = class_ptr->sizeField;
    
	int i = 0;    
    for (i = 0; i < sizeFields; i++) {
    	composeFieldValue(fd, fields[i]);
    }
	
    if (class_ptr->superClass != NULL)
    	composeFieldsValues(fd, class_ptr->superClass);
}

int composeClassDesc(int fd, CLASSDESCPTR class_ptr)
{
	int i;
	// writes class name in utf8 format and replacing '/' by '.'
	fprintf(stdout,"\tClassName: %s\n",class_ptr->name);
	char * str = class_ptr->name;
	for(i = 0; i<strlen(str);i++)
	{
		if(str[i]=='/')
			str[i]='.';
	}

	UTF8_PTR utf8 = stringToUTF8(str);
	writejUtf8(fd, utf8);


	//newPtr->id = currentHandle++ -baseWireHandle;
	//fprintf(stdout,"\tHandle number: %i\n",(int)newPtr->id);
	
	//Type
	//=> TO DO


	// writes  serial number
	fprintf(stdout,"\tserial version is : %I64d\n",class_ptr->serial);
	writejLong(fd, class_ptr->serial);

	// writes flags
	j_byte flags = class_ptr->flag;
	composeFlags(fd, flags);

	// write fields
    	SER_FIELDPTR fields = class_ptr->field;
    	j_short sizeField = class_ptr->sizeField;
	composeFields(fd, fields, sizeField);

	if (!annotation) 
	{
		annotation = 1;
		composeAnnotation(fd);
	}
	else
	{
		/*
		 *   OK
		 *   
		j_byte code = TC_ENDBLOCKDATA;
		writejByte(fd, code);
		//composeReference(fd);
		 * 
		 */

		// NO!!!!
		composeReference(fd);
		j_byte code = TC_ENDBLOCKDATA; 
	    writejByte(fd, code);
	}
	
	/*if(!EndAnnotation)
    	{
    		parseCode(fd);
    		fprintf(stdout,"Fin de l'annotation\n");
    		EndAnnotation=false;
    	}*/
    
    if (class_ptr->superClass != NULL)
		composeClassDescription(fd, class_ptr->superClass);
    else  
    {
    	fprintf(stdout,"No Superclass\n");
        j_byte code = TC_NULL;
        writejByte(fd, code);
    }
}

int composeClassDescription(int fd, CLASSDESCPTR class_ptr)
{
    j_byte code = TC_CLASSDESC;
    writejByte(fd, code);
    
    // annotation must be written in the output stream only for the first classdescription
	annotation = 0;
    
	composeClassDesc(fd, class_ptr);
  
/*      
    switch (code) {
        case TC_CLASSDESC:
            fprintf(stdout, "CODE : %s = TC_CLASS_DESC\n",toHexString(code));
            return parseClassDesc(fd);

        case TC_NULL:
            fprintf(stdout,"\tTC_NULL \t=>Probably a null super class\n");
            return NULL;

        case TC_PROXYCLASSDESC:
            fprintf(stdout,"TC_PROXYCLASSDESC");
    	    return NULL;
    }
    return NULL;
*/
}


int composeObject(int fd, OBJECTDESCPTR obj_ptr)
{
    
    	// write class description for this object
    	CLASSDESCPTR class_desc = obj_ptr->classDescr;
 	composeClassDescription(fd, class_desc);

    	// write object description 
    	composeObjectData(fd, class_desc, obj_ptr);
    	
    	composeFieldsValues(fd, class_desc);
}


void* composeObjectOutputStream(int fd, OBJECTDESCPTR obj_ptr)
{	

	
	j_byte code = TC_OBJECT;
	
	writejByte(fd, code);
	
	composeObject(fd, obj_ptr);
	
    code = TC_ENDBLOCKDATA; 
    writejByte(fd, code);

    // not necessary: just a test to check why it waits so long on the client side
    /*
    code = TC_ENDBLOCKDATA; 
    writejByte(fd, code);
    code = TC_ENDBLOCKDATA; 
    writejByte(fd, code);
    code = TC_ENDBLOCKDATA; 
    writejByte(fd, code);
    parsejByte(fd, &code);
    fprintf(stdout,"parsed byte = %02x\n",code);
    parsejByte(fd, &code);
    fprintf(stdout,"parsed byte = %02x\n",code);
    parsejByte(fd, &code);
    fprintf(stdout,"parsed byte = %02x\n",code);
    parsejByte(fd, &code);
    fprintf(stdout,"parsed byte = %02x\n",code);
    */
    
    
	fprintf(stdout,"finished composeObjectOutputStream\n");
	//close(fd);
	//fflush(stdout);	
	return;
	

/*
	switch (code) {
		case TC_OBJECT:
				fprintf(stdout, "CODE : %s = TC_OBJECT\n",toHexString(code));
				return parseObject(fd);
			break;
		    case TC_CLASS:
				fprintf(stdout, "CODE : %s = TC_CLASS\n",toHexString(code));
				parseClass(fd);
			break;
		    case TC_ARRAY:
				fprintf(stdout, "CODE : %s = TC_ARRAY\n",toHexString(code));
				parseArray(fd);
			break;
		    case TC_BLOCKDATA:
				fprintf(stdout, "CODE : %s = TC_BLOCKDATA\n",toHexString(code));
		    break;
		    case TC_ENDBLOCKDATA: //Class Annotation ?	
				fprintf(stdout, "CODE : %s = TC_ENDBLOCKDATA\n",toHexString(code));
				return NULL;

		    case TC_REFERENCE: //Reference to an object already parsed		    
				fprintf(stdout, "CODE : %s = TC_REFERENCE\n",toHexString(code));
				parseReference(fd);
				return NULL;
		    case TC_STRING:
				fprintf(stdout, "CODE : %s = TC_STRING\n",toHexString(code));
				char * str=parseString(fd);
				return str;				
		    case TC_NULL:
				fprintf(stdout, "CODE : %s = TC_NULL\n",toHexString(code));		    	
		    break;
		    default:
				fprintf(stdout, "CODE : %s = DON'T UNDERSTAND\n",toHexString(code));
		 }
		 return NULL;
*/

}


/*
 * fd : input file
 * desc : description of the class for the object
 * objDesc : description of the object to be filled in this method
*/
int composeObjectData(int fd, CLASSDESCPTR desc, OBJECTDESCPTR objDesc )
{
	CLASSDESCPTR super;
	fprintf(stdout, "readObjectData() for %s\n",desc->name);
	super = desc->superClass;
	if (super != NULL) {
	    composeObjectData(fd, super, objDesc);
	}
	
	if (((desc->flag)&(SC_WRITE_METHOD))==false) {
		fprintf(stdout, "Normal Read value for %s\n",desc->name);			
	}
	else
	{
		fprintf(stdout, "writing customized serialization for %s\n",desc->name);

		char *host, *str=NULL;
		j_int port=0;
		j_short mode=0;

		
		j_short code = TC_BLOCKDATA;
		writejByte(fd, code);

		switch(code)
		{
			case TC_BLOCKDATA:
			{
//				parseCode(fd); 
//				fprintf(stdout,"\tTC_BLOCKDATA");

				j_byte length=52; // 52 is the correct number
				writejByte(fd, length);
				fprintf(stdout,"\tnbBytes= %i\n",length);

				fprintf(stdout,"\tName Of the Object: %s\n", objDesc->name);
				UTF8_PTR utf8 = stringToUTF8(objDesc->name);
				writejUtf8(fd, utf8);				

				fprintf(stdout,"\t@IP: %s\t", objDesc->ip);
				UTF8_PTR utf8_ip = stringToUTF8(objDesc->ip);
				writejUtf8(fd, utf8_ip);	

				writejInt(fd, objDesc->port); //4
				fprintf(stdout,"Port: %i\n", objDesc->port);


/*
				j_long objNum	=0; 
				parsejLong(fd,&objNum); //8
				j_int unique		=0; 
				parsejInt(fd,&unique); //4
				j_long time		=0;
				parsejLong(fd,&time); //8
				j_short count	=0;
				parsejShort(fd,&count); //2
				j_byte bool 		=0;
				parsejByte(fd,&bool); // 1

				fprintf(stdout,"ObjID= ");
				fprintf(stdout,"\tObjUnum: %I64d \n",objNum);
				fprintf(stdout,"\tunique= %i\n",unique);
				fprintf(stdout,"\ttime= %I64d\n",time);
				fprintf(stdout,"\tcount= %i\n",count);
				fprintf(stdout,"\tbool= %i\n",bool);
*/
				writejLong(fd, objDesc->objNum);
				writejInt(fd, objDesc->unique); 
				writejLong(fd, objDesc->time);
				writejShort(fd, objDesc->count);
				writejByte(fd, objDesc->bool);
				break;
			}
		    	default:
				fprintf(stdout, "CODE : %s = DON'T UNDERSTAND\n",toHexString(code));
		}
	}			
	fprintf(stdout, "leave readObjectData() for %s\n",desc->name);
	
//	fflush(stdout);	
}



