#include "unit/unit.h"
#include <stdio.h>
/*
#include "event/eventqueue_table.h"
#include "socket/socket.h"

#include "engine/action.h"
#include "engine/event.h"
*/
#include "monitor/tools.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


int unit_LOCALPORT = 38007;

void unit_publish_msg(MSG_PTR msg, UNIT_PTR unit)
{
	fprintf(stdout, "unit_publish_msg\n");
	LISTENER_LIST_PTR l;

	for (l = unit->msg_listeners; l != NULL; l = l->next)
	{
	   LISTENER_PTR node = l->node;

	   if (node->type == LISTENER_PARSER) {
		PARSER_PTR p = (PARSER_PTR)node->listener.parser;
		fprintf(stdout, "unit_publish_msg on parser %p\n",p);
		
			p->func_msg_received(msg, node);
	   }
	   /*else if (node->type == LISTENER_COMPOSER) {
		COMPOSER_PTR p = (COMPOSER_PTR)node->listener.composer;
		fprintf(stdout, "unit_publish_msg on composer %p\n",p);
		
			p->func_msg_received(msg, node);
	   }*/
	   else if (node->type == LISTENER_UNIT) {
		UNIT_PTR u = (UNIT_PTR)node->listener.unit;
		fprintf(stdout, "unit_publish_msg on unit %p\n",u);
		
			u->func_msg_received(msg, node);
	   }
	}
}

void unit_msg_received(MSG_PTR msg, LISTENER_PTR node)
{
	fprintf(stdout, "unit receives msg from SRC=%p. length=%d src_addr=%s src_port=%d \n",msg->src, msg->length, msg->src_address, msg->src_port);
	unit_publish_msg(msg, node->listener.unit);
	//parser_publish_event(evt, node->listener.parser);
}

int unit_add_msglistener(UNIT_PTR unit, struct listener* evt_list)
{
	fprintf(stdout, "unit_add_msglistener\n");
        LISTENER_LIST_ENTRY_PTR list_entry = (LISTENER_LIST_ENTRY_PTR)malloc(sizeof(LISTENER_LIST_ENTRY));
	list_entry->node = evt_list;
	list_entry->next = NULL;
	
	if (unit->msg_listeners == NULL) {
		unit->msg_listeners = list_entry;	
	} else {
		list_entry->next = unit->msg_listeners;
		unit->msg_listeners = list_entry;
	}
}
	
int unit_add_msglistener_unit(UNIT_PTR unit, struct unit* u)
{
	fprintf(stdout, "unit_add_msglistener_unit\n");
	LISTENER_PTR evt_list = (LISTENER_PTR)malloc(sizeof(LISTENER_PTR));
	evt_list->type = LISTENER_UNIT;
	evt_list->listener.unit = u;
	unit_add_msglistener(unit, evt_list);
}

int unit_add_msglistener_parser(UNIT_PTR unit, struct parser* p)
{
	fprintf(stdout, "unit_add_msglistener_parser\n");
	LISTENER_PTR evt_list = (LISTENER_PTR)malloc(sizeof(LISTENER_PTR));
	evt_list->type = LISTENER_PARSER;
	evt_list->listener.parser = p;
	unit_add_msglistener(unit, evt_list);
}

int unit_add_msglistener_socket(UNIT_PTR unit, struct socket* s)
{
	fprintf(stdout, "unit_add_msglistener_socket\n");
	LISTENER_PTR evt_list = (LISTENER_PTR)malloc(sizeof(LISTENER_PTR));
	evt_list->type = LISTENER_SOCKET;
	evt_list->listener.socket = s;
	unit_add_msglistener(unit, evt_list);
}


SOCKET_PTR unit_getsocket(UNIT_PTR unit, char* key)
{

	fprintf(stdout, "unit_getsocket %s\n",key);

	MAPENTRYSOCKET_PTR map_entry = unit->sockets;
	
	for (map_entry = unit->sockets; map_entry != NULL; map_entry = map_entry->next) {
		fprintf(stdout, "unit_getsocket %s. map_entry->key=%s\n",key, map_entry->key);
		if (!strcmp(map_entry->key, key))
			return map_entry->socket;
	}

	return NULL;
}

PARSER_PTR unit_getparser(UNIT_PTR unit, char* key)
{

	fprintf(stdout, "unit_getparser %s\n",key);

	MAPENTRYPARSER_PTR map_entry = unit->parsers;
	
	for (map_entry = unit->parsers; map_entry != NULL; map_entry = map_entry->next) {
		fprintf(stdout, "unit_getparser %s. map_entry->key=%s\n",key, map_entry->key);
		if (!strcmp(map_entry->key, key))
			return map_entry->parser;
	}

	return NULL;
}

COMPOSER_PTR unit_getcomposer(UNIT_PTR unit, char* key)
{

	fprintf(stdout, "unit_getcomposer %s\n",key);

	MAPENTRYCOMPOSER_PTR map_entry = unit->composers;
	
	for (map_entry = unit->composers; map_entry != NULL; map_entry = map_entry->next) {
		fprintf(stdout, "unit_getcomposer %s. map_entry->key=%s\n",key, map_entry->key);
		if (!strcmp(map_entry->key, key))
			return map_entry->composer;
	}

	return NULL;
}


int unit_addsocket(UNIT_PTR unit, char* key, SOCKET_PTR s)
{

	fprintf(stdout, "unit_addsocket %s\n",key);
	//MAPENTRYPARSER_PTR unit_map_parser = u->parsers; 

	MAPENTRYSOCKET_PTR map_entry = (MAPENTRYSOCKET_PTR)malloc(sizeof(MAPENTRYSOCKET));
	map_entry->key = malloc(strlen(key)+1);
	strcpy(map_entry->key, key);
	map_entry->socket = s;
	map_entry->next = NULL;

	if (unit->sockets == NULL) {
		unit->sockets = map_entry;	
	} else {
		map_entry->next = unit->sockets;
		unit->sockets = map_entry;
	}
}

int unit_addparser(UNIT_PTR unit, char* key, PARSER_PTR p)
{

	fprintf(stdout, "unit_addparser %s\n",key);
	//MAPENTRYPARSER_PTR unit_map_parser = u->parsers; 

	MAPENTRYPARSER_PTR map_entry = (MAPENTRYPARSER_PTR)malloc(sizeof(MAPENTRYPARSER));
	map_entry->key = malloc(strlen(key)+1);
	strcpy(map_entry->key, key);
	map_entry->parser = p;
	map_entry->next = NULL;

	if (unit->parsers == NULL) {
		unit->parsers = map_entry;	
	} else {
		map_entry->next = unit->parsers;
		unit->parsers = map_entry;
	}
}

int unit_addcomposer(UNIT_PTR unit, char* key, COMPOSER_PTR c)
{

	fprintf(stdout, "unit_addcomposer %s\n",key);

	MAPENTRYCOMPOSER_PTR map_entry = (MAPENTRYCOMPOSER_PTR)malloc(sizeof(MAPENTRYCOMPOSER));
	map_entry->key = malloc(strlen(key)+1);
	strcpy(map_entry->key, key);
	map_entry->composer = c;
	map_entry->next = NULL;

	if (unit->composers == NULL) {
		unit->composers = map_entry;	
	} else {
		map_entry->next = unit->composers;
		unit->composers = map_entry;
	}
}

int unit_add_evtlistener(UNIT_PTR unit, LISTENER_PTR evt_list)
{
	fprintf(stdout, "unit_add_evtlistener\n");
        LISTENER_LIST_ENTRY_PTR list_entry = (LISTENER_LIST_ENTRY_PTR)malloc(sizeof(LISTENER_LIST_ENTRY));
	list_entry->node = evt_list;
	list_entry->next = NULL;
	
	if (unit->evt_listeners == NULL) {
		unit->evt_listeners = list_entry;	
	} else {
		list_entry->next = unit->evt_listeners;
		unit->evt_listeners = list_entry;
	}
}
	
int unit_add_evtlistener_parser(UNIT_PTR unit, PARSER_PTR p)
{
	fprintf(stdout, "unit_add_evtlistener_parser\n");
	LISTENER_PTR evt_list = (LISTENER_PTR)malloc(sizeof(LISTENER/*_PTR*/));
	evt_list->type = LISTENER_PARSER;
	evt_list->listener.parser = p;
	unit_add_evtlistener(unit, evt_list);
}

int unit_add_evtlistener_composer(UNIT_PTR unit, COMPOSER_PTR c)
{
	fprintf(stdout, "unit_add_evtlistener_composer\n");
	LISTENER_PTR evt_list = (LISTENER_PTR)malloc(sizeof(LISTENER/*_PTR*/));
	evt_list->type = LISTENER_COMPOSER;
	evt_list->listener.composer = c;
	unit_add_evtlistener(unit, evt_list);
}

int unit_add_evtlistener_unit(UNIT_PTR unit, UNIT_PTR u)
{
	fprintf(stdout, "unit_add_evtlistener_unit\n");
	LISTENER_PTR evt_list = (LISTENER_PTR)malloc(sizeof(LISTENER/*_PTR*/));
	evt_list->type = LISTENER_UNIT;
	evt_list->listener.unit = u;
	unit_add_evtlistener(unit, evt_list);
}

int unit_add_evtlistener_unit_proxy(UNIT_PTR unit, UNIT_PTR u)
{
	fprintf(stdout, "unit_add_evtlistener_unit_proxy\n");
	LISTENER_PTR evt_list = (LISTENER_PTR)malloc(sizeof(LISTENER/*_PTR*/));
	evt_list->type = LISTENER_UNIT_PROXY;
	evt_list->listener.unit = u;
	unit_add_evtlistener(unit, evt_list);
}



/*
 * NO LONGER USED
 * 
 */
void unit_publish_event(EVENT_PTR evt, UNIT_PTR unit)
{
	fprintf(stdout, "\n\n\nunit_publish_event\n");
	LISTENER_LIST_PTR l;

	int at_least_one_composer_is_listener_of_events = 0;
	
	for (l = unit->evt_listeners; l != NULL; l = l->next)
	{
	   LISTENER_PTR node = l->node;
	
	   if (node->type == LISTENER_COMPOSER) {
		
		   /*
		    * instead of dispatching the event to the different composers
		    * that are listeners of events on the unit, the event is added
		    * to the table of the unit, in the entry that corresponds to
		    * the evt->stream_id and it will be consumed by the unit's active
		    * composer.
		    * It is added only once to the event queue qnd not once for every
		    * composer that is a listener of the unit
		    * 
		   COMPOSER_PTR c = (COMPOSER_PTR)node->listener.composer;
		   fprintf(stdout, "unit_publish_event on composer %p\n",c);
		   c->func_event_received(evt, node);
		   */
		   at_least_one_composer_is_listener_of_events = 1;
		   
	   }        
	   else if (node->type == LISTENER_UNIT) {
	        UNIT_PTR u = (UNIT_PTR)node->listener.unit;
	        
	        
	        // get event's unit_src and compare to the listener unit:
	        // if their are the same unit, then do not dispatch the
	        // event to prevent loops
	   		EVENTSRC_PTR evt_src = evt->src;
	        UNIT_PTR evt_src_unit = evt_src->src_unit; 
	        fprintf(stdout, "unit_publish_event on unit %p. evt->src->src_unit=%p\n",u,evt_src_unit);
	        if (u != evt_src_unit)
	        	u->func_event_received(evt, node);
  	   }
	}

	if (at_least_one_composer_is_listener_of_events)
	{
		/*
		 * this code have been cut and pasted from the function composer_event_received(EVENT_PTR evt, LISTENER_PTR node)
		 * in composer.c to prevent multiple composers (all being evet listeners of the unit) to add the event 
		 * to he event queue with the result that the same event is registered on the event queue multiple times insted 
		 * of only once 
		 */
		
		fprintf(stdout, "composer receives event type=%d src=%p.\n", evt->type, evt->stream_id);
		
		/*
		COMPOSER_PTR composer = node->listener.composer; 
		*/
		
		// check if evt->stream_id exists in table/column stream_id
		EVENTQUEUE_TABLE_ENTRY_PTR entry = eventqueue_table_get_entry_by_stream_id(/*composer->*/unit->event_table, evt->stream_id);
		// if evt->stream_id does not exist in table/column stream_id, check in column sub_stream_id
		if (entry == NULL)
			entry = eventqueue_table_get_entry_by_sub_stream_id(/*composer->*/unit->event_table, evt->stream_id);
		
		// if not found in column stream_id and nor in column sub_stream_id, create a new entry
		if (entry == NULL)	
		{
			fprintf(stdout, "composer_event_received: event src not contained in table \n");

			entry = eventqueue_table_add_entry(/*composer->*/unit->event_table, evt->stream_id ,  -1/*sub_stream_id*/ /*, (void*)0*/);
			eventqueue_table_enqueue_event(entry, evt);
	
			/*
			 * The active composer (thread running and consuming events from the event queue)
			 * is set by the action in unit.sm set_socket_and_composer
			 
			pthread_t composer_thread;
			COMPOSETHREADDATA_PTR data = malloc(sizeof(COMPOSETHREADDATA));
		
			data->entry_event_queue = (EVENTQUEUE_TABLE_ENTRY_PTR)entry;
			data->composer = node->listener.composer;
		
			fprintf(stdout, "\nCREATING PTHREAD composer = %p\n", composer_thread);
			
			pthread_create(&composer_thread, NULL, composer->run_composer, (void*)data);
			*/
		}
		else
		{
			fprintf(stdout, "composer_event_received: event src contained in table \n");
			eventqueue_table_enqueue_event(entry, evt);
			
		}
	}
}


void unit_dispatch_evt_to_listeners(EVENT_PTR evt, void* u)
{
	unit_dispatch_evt_to_composers(evt, u);
	unit_dispatch_evt_to_units(evt, u);
	unit_dispatch_evt_to_unit_proxy(evt, u);
}

void unit_dispatch_evt_to_composers(EVENT_PTR evt, void* u)
{
	UNIT_PTR unit = (UNIT_PTR)u;
	
	fprintf(stdout, "\n\n\nunit_dispatch_evt_to_composers:\n");
	//eventqueue_table_print(unit->event_table);
	
	   /*
	    * instead of dispatching the event to the different composers
	    * that are listeners of events on the unit, the event is added
	    * to the table of the unit, in the entry that corresponds to
	    * the evt->stream_id and it will be consumed by the unit's active
	    * composer.
	    * It is added only once to the event queue qnd not once for every
	    * composer that is a listener of the unit
	    * 

	LISTENER_LIST_PTR l;
	
	for (l = unit->evt_listeners; l != NULL; l = l->next)
	{
	   LISTENER_PTR node = l->node;
	
	   if (node->type == LISTENER_COMPOSER) {
		COMPOSER_PTR p = (COMPOSER_PTR)node->listener.composer;
		fprintf(stdout, "unit_publish_event on composer %p\n",p);
		if (p != evt->src)
			p->func_event_received(evt, node);
	   }        
	}
	*/
	/*
	 * this code have been cut and pasted from the function composer_event_received(EVENT_PTR evt, LISTENER_PTR node)
	 * in composer.c to prevent multiple composers (all being evet listeners of the unit) to add the event 
	 * to he event queue with the result that the same event is registered on the event queue multiple times insted 
	 * of only once 
	 */
	
	fprintf(stdout, "composer receives event type=%d src=%p.\n", evt->type, evt->stream_id);
	
	/*
	COMPOSER_PTR composer = node->listener.composer; 
	*/
	
	// check if evt->stream_id exists in table/column stream_id
	EVENTQUEUE_TABLE_ENTRY_PTR entry = eventqueue_table_get_entry_by_stream_id(/*composer->*/unit->event_table, evt->stream_id);
	// if evt->stream_id does not exist in table/column stream_id, check in column sub_stream_id
	if (entry == NULL)
		entry = eventqueue_table_get_entry_by_sub_stream_id(/*composer->*/unit->event_table, evt->stream_id);
	
	// if not found in column stream_id and nor in column sub_stream_id, create a new entry
	if (entry == NULL)	
	{
		fprintf(stdout, "composer_event_received: event src not contained in table \n");

		entry = eventqueue_table_add_entry(/*composer->*/unit->event_table, evt->stream_id ,  -1/*sub_stream_id*/ /*, (void*)0*/);
		eventqueue_table_enqueue_event(entry, evt);

		/*
		 * The active composer (thread running and consuming events from the event queue)
		 * is set by the action in unit.sm set_socket_and_composer
		 
		pthread_t composer_thread;
		COMPOSETHREADDATA_PTR data = malloc(sizeof(COMPOSETHREADDATA));
	
		data->entry_event_queue = (EVENTQUEUE_TABLE_ENTRY_PTR)entry;
		data->composer = node->listener.composer;
	
		fprintf(stdout, "\nCREATING PTHREAD composer = %p\n", composer_thread);
		
		pthread_create(&composer_thread, NULL, composer->run_composer, (void*)data);
		*/
	}
	else
	{
		fprintf(stdout, "composer_event_received: event src contained in table \n");
		eventqueue_table_enqueue_event(entry, evt);
		
	}
}


void unit_dispatch_evt_to_units(EVENT_PTR evt, void* u)
{
	UNIT_PTR unit = (UNIT_PTR)u;
	
//	fflush(stdout);
	fprintf(stdout, "\n\n\nunit_dispatch_evt_to_units: evt->stream_id=%p\n",evt->stream_id);
	
	// replace sub_stream_id with stream_id for external units
	//eventqueue_table_print(unit->event_table);
	int stream_id;
	if (eventqueue_table_get_stream_id_by_sub_stream_id(unit->event_table, evt->stream_id, &stream_id))
		evt->stream_id = stream_id;
	
	LISTENER_LIST_PTR l;

	for (l = unit->evt_listeners; l != NULL; l = l->next)
	{
	   LISTENER_PTR node = l->node;
	
	   if (node->type == LISTENER_UNIT) {
	        UNIT_PTR u = (UNIT_PTR)node->listener.unit;
	        fprintf(stdout, "unit_publish_event on unit %p\n",u);
	        // get event's unit_src and compare to the listener unit:
	        // if their are the same unit, then do not dispatch the
	        // event to prevent loops
	   		EVENTSRC_PTR evt_src = evt->src;
	        UNIT_PTR evt_src_unit = evt_src->src_unit; 
	        fprintf(stdout, "unit_publish_event on unit %p. evt->src->src_unit=%p\n",u,evt_src_unit);
	        if (u != evt_src_unit)
	        	u->func_event_received(evt, node);
  	   }
	}	
}

void unit_dispatch_evt_to_unit_proxy(EVENT_PTR evt, void* u)
{
	UNIT_PTR unit = (UNIT_PTR)u;
	
	//fflush(stdout);
	fprintf(stdout, "\n\n\nunit_dispatch_evt_to_unit_proxy: evt->stream_id=%p\n",evt->stream_id);
	
	// replace sub_stream_id with stream_id for external units
	//eventqueue_table_print(unit->event_table);
	int stream_id;
	if (eventqueue_table_get_stream_id_by_sub_stream_id(unit->event_table, evt->stream_id, &stream_id))
		evt->stream_id = stream_id;
	
	LISTENER_LIST_PTR l;

	for (l = unit->evt_listeners; l != NULL; l = l->next)
	{
	   LISTENER_PTR node = l->node;
	
	   if (node->type == LISTENER_UNIT_PROXY) {
	        UNIT_PTR u = (UNIT_PTR)node->listener.unit;
	        fprintf(stdout, "unit_publish_event on unit proxy %p\n",u);
	        // get event's unit_src and compare to the listener unit:
	        // if their are the same unit, then do not dispatch the
	        // event to prevent loops
	   		EVENTSRC_PTR evt_src = evt->src;
	        UNIT_PTR evt_src_unit = evt_src->src_unit; 
	        fprintf(stdout, "unit_publish_event on unit proxy %p. evt->src->src_unit=%p\n",u,evt_src_unit);
	        if (u != evt_src_unit)
	        	u->func_event_received(evt, node);
  	   }
	}	
}

void unit_event_received(EVENT_PTR evt, LISTENER_PTR node)
{
	fprintf(stdout, "unit receives event type=%d src=%p. unit listeners=%p\n", evt->type, evt->stream_id, node->listener.unit);
	
	engineDispatchEvent (node->listener.unit->engine, evt);
	
	fprintf(stdout, "AFTER ENGINEDISPATCH\n"); 
	//unit_publish_event(evt, node->listener.unit);
}



void set_socket_and_composer(void* u, char* socket_name, char* composer_name, EVENT_PTR evt)
{
	
	UNIT_PTR unit = (UNIT_PTR)u;
	fprintf(stdout, "set_socket_and_composer: socket=%s composer=%s unit=%p event_Table=%p\n",socket_name, composer_name, unit, unit->event_table);
	
	
	EVENTQUEUE_TABLE_ENTRY_PTR entry = eventqueue_table_get_entry_by_stream_id(unit->event_table, evt->stream_id);
	
	
	
	eventqueue_table_print(unit->event_table);
	
	if (entry == NULL)
	{
		fprintf(stdout, "set_socket_and_composer: ENTRY IS NULL. Creating entry\n");
		
		entry = eventqueue_table_add_entry(unit->event_table, evt->stream_id, -1/*sub_stream_id*/ /*, (void*)0*/);
	
		SOCKET_PTR socket ;
		SOCKET_PTR socket_tmp = unit_getsocket(unit, socket_name);
		fprintf(stdout, "set_socket_and_composer: SOCKET_tmp = %p\n", socket_tmp);
		if (socket_tmp != NULL)
		{
			socket = socket_tmp->factory(unit);
			socket_set_localport(socket, unit_LOCALPORT);
			
			unit_LOCALPORT += 1;
		}
		
//		entry->socket_reply_port = socket_get_localport(socket);
		
		COMPOSER_PTR composer;
		COMPOSER_PTR composer_tmp = unit_getcomposer(unit, composer_name);
		if (composer_tmp != NULL)
		{
			// create the composer
			composer = composer_tmp->factory(unit);
			
//			// add the composer to the list of unit's evt_listeners
//			unit_add_evtlistener_composer(unit, composer);
			
			// add the socket to the list of the composer's msg_listeners
			composer_add_msglistener_socket(composer, socket);
			
//			// add event SDP_SWITCH_COMPOSER to the list of events if the list of composer thread is not empty
//			if (eventqueue_table_get_composer_thread_list_length(entry) > 0)
//			{
//				fprintf(stdout, "set_socket_and_composer (ADD evt SWITCH COMPOSER): socket=%s composer=%s unit=%p event_Table=%p\n",socket_name, composer_name, unit, unit->event_table);
//				EVENT_PTR evt_switch_composer =  event_create(SDP_SWITCH_COMPOSER, evt->stream_id, (void*)u);	
//				eventqueue_table_enqueue_event(entry, evt_switch_composer);
//			}
//			else
//				fprintf(stdout, "set_socket_and_composer (NOT ADD evt SWITCH COMPOSER): socket=%s composer=%s unit=%p event_Table=%p\n",socket_name, composer_name, unit, unit->event_table);
			
			
			// launch the thread of the composer to receive the events generated by the unit
			pthread_t composer_thread;
			COMPOSETHREADDATA_PTR data = malloc(sizeof(COMPOSETHREADDATA));
			data->entry_event_queue = (EVENTQUEUE_TABLE_ENTRY_PTR)entry;
			data->composer = composer;
			fprintf(stdout, "\nCREATING PTHREAD composer = %p\n", composer_thread);
			

			fprintf(stdout, "\neventqueue_table_get_composer_thread_list_length(entry) = %d\n",eventqueue_table_get_composer_thread_list_length(entry));
			
			
			
			/////////////////////////////////////////
			
			fprintf(stdout, "\nCREATING PTHREAD composer socket_get_localport(socket0) = %d\n", socket_get_localport(socket));
			eventqueue_table_add_composer_thread(entry, composer_name, composer, socket, 
					socket_get_localport(socket) /*, &cond*/);
			

		
			pthread_create(&composer_thread, NULL, composer->run_composer, (void*)data);
		
			fprintf(stdout, "\nCREATING PTHREAD composer socket_get_localport(socket) = %d\n", socket_get_localport(socket));
		
		
			eventqueue_table_get_entry_by_current_socket_reply_port(unit->event_table, 38007);
		
			//////////////////////////////////////////
			
			
			
/*			
			if (eventqueue_table_get_composer_thread_list_length(entry) > 0)
			{
				fprintf(stdout, "set_socket_and_composer(%s, %s): LOCKED entry %p\n",socket_name, composer_name, entry);
				
				// get last composer thread. ITs reference is used to lock current compsoer thread until the end
				// of the previous composer thread
				COMPOSERTHREAD_LIST_ENTRY_PTR previous_composer_thread  = eventqueue_table_get_last_composer_thread(entry);
				
				// add this composer's thread to the list 
				pthread_mutex_t mutex;
				pthread_mutex_init(&mutex, NULL);
				eventqueue_table_add_composer_thread(entry, composer_name, composer, socket, 
						socket_get_localport(socket), &mutex);
				
				// lock this thread
				eventqueue_table_composer_thread_lock_entry_mutex(previous_composer_thread);
			} 
			else
			{
				// add this composer's thread to the list 
				pthread_mutex_t mutex;
				pthread_mutex_init(&mutex, NULL);
				eventqueue_table_add_composer_thread(entry, composer_name, composer, socket, 
						socket_get_localport(socket), &mutex);
			}
			
			
			pthread_create(&composer_thread, NULL, composer->run_composer, (void*)data);
			
//			// set active composer string in entry in eventqueue_Table
//			entry->composer_listener_string = strdup(composer_name);
 
 */
		}

	
		
		
		
		/*
		eventqueue_table_enqueue_event(entry, evt);
		
		pthread_t composer_thread;
		COMPOSETHREADDATA_PTR data = malloc(sizeof(COMPOSETHREADDATA));
	
		data->entry_event_queue = (EVENTQUEUE_TABLE_ENTRY_PTR)entry;
		data->composer = node->listener.composer;
	
	
		
		fprintf(stdout, "\nCREATING PTHREAD composer = %p\n", composer_thread);
	
		
		pthread_create(&composer_thread, NULL, composer->run_composer, (void*)data);
		*/
	}
	else
	{
		fprintf(stdout, "set_socket_and_composer: ENTRY IS NOT NULL. \n");
		
		// if composer has changed, create an instance of the new composer and 
		// activate its thread
//		if (entry->composer_listener_string == NULL || strcmp(entry->composer_listener_string, composer_name))
//		{
			SOCKET_PTR socket ;
			SOCKET_PTR socket_tmp = unit_getsocket(unit, socket_name);
			fprintf(stdout, "set_socket_and_composer: SOCKET_tmp = %p\n", socket_tmp);
			if (socket_tmp != NULL)
			{
				socket = socket_tmp->factory(unit);
				socket_set_localport(socket, unit_LOCALPORT);
				
				unit_LOCALPORT += 1;
			}
			
//			entry->socket_reply_port = socket_get_localport(socket);
			
			COMPOSER_PTR composer;
			COMPOSER_PTR composer_tmp = unit_getcomposer(unit, composer_name);
			if (composer_tmp != NULL)
			{
				// create the composer
				composer = composer_tmp->factory(unit);
				
//				// add the composer to the list of unit's evt_listeners
//				unit_add_evtlistener_composer(unit, composer);
				
				// add the socket to the list of the composer's msg_listeners
				composer_add_msglistener_socket(composer, socket);
				
				
//				// add event SDP_SWITCH_COMPOSER to the list of events if the list of composer thread is not empty
//				if (eventqueue_table_get_composer_thread_list_length(entry) > 0)
//				{
//					fprintf(stdout, "set_socket_and_composer (ADD evt SWITCH COMPOSER): socket=%s composer=%s unit=%p event_Table=%p\n",socket_name, composer_name, unit, unit->event_table);
//					EVENT_PTR evt_switch_composer =  event_create(SDP_SWITCH_COMPOSER, evt->stream_id, (void*)u);	
//					eventqueue_table_enqueue_event(entry, evt_switch_composer);
//				}
//				else
//					fprintf(stdout, "set_socket_and_composer (NOT ADD evt SWITCH COMPOSER): socket=%s composer=%s unit=%p event_Table=%p\n",socket_name, composer_name, unit, unit->event_table);
				
				
				// launch the thread of the composer to receive the events generated by the unit
				pthread_t composer_thread;
				COMPOSETHREADDATA_PTR data = malloc(sizeof(COMPOSETHREADDATA));
				data->entry_event_queue = (EVENTQUEUE_TABLE_ENTRY_PTR)entry;
				data->composer = composer;
				fprintf(stdout, "\nCREATING PTHREAD composer = %p\n", composer_thread);
				
				
//				fprintf(stdout, "\neventqueue_table_get_composer_thread_list_length(entry) = %d\n",eventqueue_table_get_composer_thread_list_length(entry));
				
//				if (eventqueue_table_get_composer_thread_list_length(entry) > 0)
//				{
					
					// get last composer thread. ITs reference is used to lock current compsoer thread until the end
					// of the previous composer thread
//					COMPOSERTHREAD_LIST_ENTRY_PTR previous_composer_thread  = eventqueue_table_get_last_composer_thread(entry);
					
//					fprintf(stdout, "set_socket_and_composer(%s, %s): BEFORE LOCKING on mutex %p\n",socket_name, composer_name, previous_composer_thread->mutex);
					
					
					// add this composer's thread to the list
				/*
				pthread_cond_t cond;
				pthread_cond_init(&cond, NULL);
				*/
				
				fprintf(stdout, "\nCREATING PTHREAD composer socket_get_localport(socket0) = %d\n", socket_get_localport(socket));
					eventqueue_table_add_composer_thread(entry, composer_name, composer, socket, 
							socket_get_localport(socket) /*, &cond*/);
					
					// lock this thread
//					int lock = eventqueue_table_composer_thread_lock_entry_mutex(previous_composer_thread);
//					fprintf(stdout, "set_socket_and_composer(%s, %s): AFTER LOCKING on mutex  %p lock=%d\n",socket_name, composer_name, previous_composer_thread->mutex,lock);
//				} 
//				else
//				{
//					// add this composer's thread to the list 
//					pthread_mutex_t mutex;
//					pthread_mutex_init(&mutex, NULL);
//					eventqueue_table_add_composer_thread(entry, composer_name, composer, socket, 
//							socket_get_localport(socket), &mutex);
//					fprintf(stdout, "set_socket_and_composer(%s, %s): set mutex %p\n",socket_name, composer_name, &mutex);
					
						
//					COMPOSERTHREAD_LIST_ENTRY_PTR previous_composer_thread  = eventqueue_table_get_last_composer_thread(entry);
					
//					fprintf(stdout, "TEST: set_socket_and_composer(%s, %s):  mutex  = %p\n",socket_name, composer_name, previous_composer_thread->mutex);
					
					
//				}
				
				
				pthread_create(&composer_thread, NULL, composer->run_composer, (void*)data);
				
				fprintf(stdout, "\nCREATING PTHREAD composer socket_get_localport(socket) = %d\n", socket_get_localport(socket));
				
				
				eventqueue_table_get_entry_by_current_socket_reply_port(unit->event_table, 38007);
				
				
//				// set active composer string in entry in eventqueue_Table
//				entry->composer_listener_string = strdup(composer_name);
			}
//		}
		/*
		fprintf(stdout, "composer_event_received: event src contained in table \n");
		eventqueue_table_enqueue_event(entry, evt);
		*/
	}
	

}

void set_socket_and_parser(void* u, char* socket_name, char* parser_name, EVENT_PTR evt)
{
	
	UNIT_PTR unit = (UNIT_PTR)u;
	fprintf(stdout, "set_socket_and_parser: socket=%s parser=%s unit=%p event_Table=%p\n",socket_name, parser_name, unit, unit->event_table);
	
	
	EVENTQUEUE_TABLE_ENTRY_PTR entry = eventqueue_table_get_entry_by_stream_id(unit->event_table, evt->stream_id);
	
	eventqueue_table_print(unit->event_table);
	
	if (entry == NULL)
	{
		fprintf(stdout, "set_socket_and_parser(%s, %s): ENTRY IS NULL. Creating entry\n");

	}
	else
	{
//		int socket_reply_port = entry->socket_reply_port;

		//pthread_mutex_lock(&(entry->mutex));
		
		COMPOSERTHREAD_LIST_ENTRY_PTR last_composer_in_Thread_list = eventqueue_table_get_last_composer_thread(entry);
		int socket_reply_port = last_composer_in_Thread_list->socket_reply_port;
		
		//pthread_mutex_unlock(&(entry->mutex));
		
		fprintf(stdout, "set_socket_and_parser(%s, %s): ENTRY IS not NULL. socket_Reply_port = %d\n",socket_name, parser_name,socket_reply_port);
		
		SOCKET_PTR socket;
		SOCKET_PTR socket_tmp = unit_getsocket(unit, socket_name);
		fprintf(stdout, "set_socket_and_parser(%s, %s): SOCKET_tmp = %p\n", socket_name, parser_name,socket_tmp);
		if (socket_tmp != NULL)
		{
			socket = socket_tmp->factory(unit);
			socket_set_localport(socket, socket_reply_port);
//			entry->socket_reply = socket;
		}
		
		
		PARSER_PTR parser;
		PARSER_PTR parser_tmp = unit_getparser(unit, parser_name);
		if (parser_tmp != NULL)
		{
			parser = parser_tmp->factory(unit);
			
			// add the parser to the list of the socket's msg_listeners
			socket_add_msglistener_parser(socket, parser);
			
			// add the unit to the list of parser's evt_listeners
			parser_add_evtlistener_unit(parser, unit);
		}
		
		socket_listen(socket, get_host_ip()/*"192.168.2.2"*/, socket_reply_port  );
	}
	
	
}


void set_socket_composer_and_parser(void* u, char* socket_name, char* composer_name,char* parser_name, EVENT_PTR evt)
{
	
	UNIT_PTR unit = (UNIT_PTR)u;
	fprintf(stdout, "set_socket_composer_and_parser: socket=%s composer=%s parser=%s unit=%p event_Table=%p\n",socket_name, composer_name, parser_name, unit, unit->event_table);
	
	
	EVENTQUEUE_TABLE_ENTRY_PTR entry = eventqueue_table_get_entry_by_stream_id(unit->event_table, evt->stream_id);
	
	eventqueue_table_print(unit->event_table);
	if (entry == NULL)
	{
		
		entry = eventqueue_table_add_entry(unit->event_table, evt->stream_id, -1/*sub_stream_id*/ /*, (void*)0*/);
		
		
		fprintf(stdout, "set_socket_composer_and_parser: ENTRY IS NULL. Creating entry.\n");
		
		
		SOCKET_PTR socket ;
		SOCKET_PTR socket_tmp = unit_getsocket(unit, socket_name);
		fprintf(stdout, "set_socket_composer_and_parser: SOCKET_tmp = %p unit_LOCALPORT=%d\n", socket_tmp, unit_LOCALPORT);
		if (socket_tmp != NULL)
		{
			socket = socket_tmp->factory(unit);
			socket_set_localport(socket, unit_LOCALPORT);
			
			unit_LOCALPORT += 1;
		}

		
		PARSER_PTR parser;
		PARSER_PTR parser_tmp = unit_getparser(unit, parser_name);
		fprintf(stdout, "set_socket_composer_and_parser: parser is %p. \n", parser_tmp);
		if (parser_tmp != NULL)
		{
			parser = parser_tmp->factory(unit);
			
			// add the parser to the list of the socket's msg_listeners
			socket_add_msglistener_parser(socket, parser);
			
			// add the unit to the list of parser's evt_listeners
			parser_add_evtlistener_unit(parser, unit);
			
			fprintf(stdout, "set_socket_composer_and_parser: parser activated. \n");
		}
		else
			fprintf(stdout, "set_socket_composer_and_parser: parser not found. \n");
		
		COMPOSER_PTR composer;
		COMPOSER_PTR composer_tmp = unit_getcomposer(unit, composer_name);
		if (composer_tmp != NULL)
		{
			// create the composer
			composer = composer_tmp->factory(unit);

			
			// add the socket to the list of the composer's msg_listeners
			composer_add_msglistener_socket(composer, socket);
			
			
			// launch the thread of the composer to receive the events generated by the unit
			pthread_t composer_thread;
			COMPOSETHREADDATA_PTR data = malloc(sizeof(COMPOSETHREADDATA));
			data->entry_event_queue = (EVENTQUEUE_TABLE_ENTRY_PTR)entry;
			data->composer = composer;
			fprintf(stdout, "\nCREATING PTHREAD composer (%s)= %p\n", composer_name, composer_thread);
			

				eventqueue_table_add_composer_thread(entry, composer_name, composer, socket, 
						socket_get_localport(socket) /*, &cond*/);
				

			pthread_create(&composer_thread, NULL, composer->run_composer, (void*)data);


		
			/////////////////////////////////////////
			
			fprintf(stdout, "\nCREATING PTHREAD composer socket_get_localport(socket0) = %d\n", socket_get_localport(socket));
			eventqueue_table_add_composer_thread(entry, composer_name, composer, socket, 
					socket_get_localport(socket) /*, &cond*/);
			
	
		
			pthread_create(&composer_thread, NULL, composer->run_composer, (void*)data);
		
			fprintf(stdout, "\nCREATING PTHREAD composer socket_get_localport(socket) = %d\n", socket_get_localport(socket));
		
		
			eventqueue_table_get_entry_by_current_socket_reply_port(unit->event_table, 38007);
		
			//////////////////////////////////////////
		}
	}
	else
	{

			fprintf(stdout, "set_socket_composer_and_parser: ENTRY IS NOT NULL. \n");
			
				SOCKET_PTR socket ;
				SOCKET_PTR socket_tmp = unit_getsocket(unit, socket_name);
				fprintf(stdout, "set_socket_composer_and_parser: SOCKET_tmp = %p unit_LOCALPORT=%d\n", socket_tmp, unit_LOCALPORT);
				if (socket_tmp != NULL)
				{
					socket = socket_tmp->factory(unit);
					socket_set_localport(socket, unit_LOCALPORT);
					
					unit_LOCALPORT += 1;
				}

				
				PARSER_PTR parser;
				PARSER_PTR parser_tmp = unit_getparser(unit, parser_name);
				fprintf(stdout, "set_socket_composer_and_parser: parser is %p. \n", parser_tmp);
				if (parser_tmp != NULL)
				{
					parser = parser_tmp->factory(unit);
					
					// add the parser to the list of the socket's msg_listeners
					socket_add_msglistener_parser(socket, parser);
					
					// add the unit to the list of parser's evt_listeners
					parser_add_evtlistener_unit(parser, unit);
					
					fprintf(stdout, "set_socket_composer_and_parser: parser activated. \n");
				}
				else
					fprintf(stdout, "set_socket_composer_and_parser: parser not found. \n");
				
				COMPOSER_PTR composer;
				COMPOSER_PTR composer_tmp = unit_getcomposer(unit, composer_name);
				if (composer_tmp != NULL)
				{
					// create the composer
					composer = composer_tmp->factory(unit);

					
					// add the socket to the list of the composer's msg_listeners
					composer_add_msglistener_socket(composer, socket);
					
					
					// launch the thread of the composer to receive the events generated by the unit
					pthread_t composer_thread;
					COMPOSETHREADDATA_PTR data = malloc(sizeof(COMPOSETHREADDATA));
					data->entry_event_queue = (EVENTQUEUE_TABLE_ENTRY_PTR)entry;
					data->composer = composer;
					fprintf(stdout, "\nCREATING PTHREAD composer (%s)= %p\n", composer_name, composer_thread);
					

						eventqueue_table_add_composer_thread(entry, composer_name, composer, socket, 
								socket_get_localport(socket) /*, &cond*/);
						

					pthread_create(&composer_thread, NULL, composer->run_composer, (void*)data);

				}
	
	}
}


void set_composerparser(void* u, char* composerparser_name, EVENT_PTR evt)
{
	
	UNIT_PTR unit = (UNIT_PTR)u;
	fprintf(stdout, "set_composerparser: composerparser_name=%s unit=%p event_Table=%p\n",composerparser_name, unit, unit->event_table);
	
	
	EVENTQUEUE_TABLE_ENTRY_PTR entry = eventqueue_table_get_entry_by_stream_id(unit->event_table, evt->stream_id);
	
	eventqueue_table_print(unit->event_table);
	if (entry == NULL)
	{
		fprintf(stdout, "set_composerparser: ENTRY IS NULL. Creating entry\n");
		
		entry = eventqueue_table_add_entry(unit->event_table, evt->stream_id, -1/*sub_stream_id*/ /*, (void*)0*/);
		
		COMPOSER_PTR composer;
		COMPOSER_PTR composer_tmp = unit_getcomposer(unit, composerparser_name);
		if (composer_tmp != NULL)
		{
			// create the composer
			composer = composer_tmp->factory(unit);
			
			// add the unit to the list of composer's evt_listeners
			composer_add_evtlistener_unit(composer, unit);
			
			// launch the thread of the composer to receive the events generated by the unit
			pthread_t composer_thread;
			COMPOSETHREADDATA_PTR data = malloc(sizeof(COMPOSETHREADDATA));
			data->entry_event_queue = (EVENTQUEUE_TABLE_ENTRY_PTR)entry;
			data->composer = composer;
			fprintf(stdout, "\nCREATING PTHREAD composer (%s)= %p\n", composerparser_name, composer_thread);
			

				eventqueue_table_add_composer_thread(entry, composerparser_name, composer, NULL, -1);
				

			pthread_create(&composer_thread, NULL, composer->run_composer, (void*)data);

		}
	}
	else
	{
		fprintf(stdout, "set_composerparser: ENTRY IS NOT NULL. \n");
		
		COMPOSER_PTR composer;
		COMPOSER_PTR composer_tmp = unit_getcomposer(unit, composerparser_name);
		if (composer_tmp != NULL)
		{
			// create the composer
			composer = composer_tmp->factory(unit);
			
			// add the unit to the list of composer's evt_listeners
			composer_add_evtlistener_unit(composer, unit);
			
			// launch the thread of the composer to receive the events generated by the unit
			pthread_t composer_thread;
			COMPOSETHREADDATA_PTR data = malloc(sizeof(COMPOSETHREADDATA));
			data->entry_event_queue = (EVENTQUEUE_TABLE_ENTRY_PTR)entry;
			data->composer = composer;
			fprintf(stdout, "\nCREATING PTHREAD composer (%s)= %p\n", composerparser_name, composer_thread);
			

				eventqueue_table_add_composer_thread(entry, composerparser_name, composer, NULL, -1);
				

			pthread_create(&composer_thread, NULL, composer->run_composer, (void*)data);

		}
	}
}


void print_str(char* string)
{
	fprintf(stdout,"print: %s\n",string);
}

void print_evt(EVENT_PTR evt)
{
	fprintf(stdout,"print_evt\n");
}

void unit_send_disc_request(EVENT_PTR evt, void* u)
{
	fprintf(stdout,"unit_send_disc_request\n");

	//unit_publish_event(event_create(SDP_SEND_SERVICE_REQUEST, evt->stream_id, evt->src), evt->src);
	
	EVENT_PTR event = event_create(SDP_SEND_SERVICE_REQUEST, evt->stream_id, evt->src);
	unit_dispatch_evt_to_composers(event, u);
}

void unit_send_disc_reply(EVENT_PTR evt, void* u)
{
	fprintf(stdout,"unit_send_disc_reply\n");

	EVENT_PTR event = event_create(SDP_SEND_SERVICE_REPLY, evt->stream_id, evt->src);
	unit_dispatch_evt_to_composers(event, u);
}

void unit_send_comm_request(EVENT_PTR evt, void* u)
{
	fprintf(stdout,"unit_send_comm_request\n");

	//unit_publish_event(event_create(SDP_SEND_SERVICE_REQUEST, evt->stream_id, evt->src), evt->src);
	
	EVENT_PTR event = event_create(SCP_SEND_SERVICE_REQUEST, evt->stream_id, evt->src);
	unit_dispatch_evt_to_composers(event, u);
}

void unit_send_comm_reply(EVENT_PTR evt, void* u)
{
	fprintf(stdout,"unit_send_comm_reply\n");

	EVENT_PTR event = event_create(SCP_SEND_SERVICE_REPLY, evt->stream_id, evt->src);
	unit_dispatch_evt_to_composers(event, u);
}

void unit_create_proxy(EVENT_PTR evt, void* u)
{
	fprintf(stdout,"unit_create_proxy\n");

	
	EVENT_PTR event = event_create(GENERATE_PROXY, evt->stream_id, evt->src);
	unit_dispatch_evt_to_composers(event, u);
}

int unit_addaction_function1(UNIT_PTR u, char* name, prototype_function1 function)
{
	ACTION_PTR a1 = action_create_function1(name, function);
	if (u->actions == NULL)
	{
		u->actions = a1;
	}
	else
	{
		a1->next_action = u->actions;
		u->actions = a1;
	}
	
}

int unit_addaction_function2(UNIT_PTR u, char* name, prototype_function2 function)
{
	ACTION_PTR a2 = action_create_function2(name, function);
	if (u->actions == NULL)
	{
		u->actions = a2;
	}
	else
	{
		a2->next_action = u->actions;
		u->actions = a2;
	}
}

int unit_addaction_function3(UNIT_PTR u, char* name, prototype_function3 function)
{
	ACTION_PTR a3 = action_create_function3(name, function);
	if (u->actions == NULL)
	{
		u->actions = a3;
	}
	else
	{
		a3->next_action = u->actions;
		u->actions = a3;
	}
}

int unit_addaction_function4(UNIT_PTR u, char* name, prototype_function4 function)
{
	ACTION_PTR a4 = action_create_function4(name, function);
	if (u->actions == NULL)
	{
		u->actions = a4;
	}
	else
	{
		a4->next_action = u->actions;
		u->actions = a4;
	}
}

int unit_addaction_function5(UNIT_PTR u, char* name, prototype_function5 function)
{
	ACTION_PTR a5 = action_create_function5(name, function);
	if (u->actions == NULL)
	{
		u->actions = a5;
	}
	else
	{
		a5->next_action = u->actions;
		u->actions = a5;
	}
}


int unit_addaction_function6(UNIT_PTR u, char* name, prototype_function6 function)
{
	ACTION_PTR a6 = action_create_function6(name, function);
	if (u->actions == NULL)
	{
		u->actions = a6;
	}
	else
	{
		a6->next_action = u->actions;
		u->actions = a6;
	}
}



UNIT_PTR unit_create(char* sm_filename, ACTION_PTR extra_actions)
{
	fprintf(stdout, "Creating unit %s\n",sm_filename);
	UNIT_PTR u = (UNIT_PTR)malloc(sizeof(UNIT));

	u->parsers = NULL;
	u->composers = NULL;
	u->sockets = NULL;
		
	u->evt_listeners = NULL;
	u->msg_listeners = NULL;
	u->func_event_received = unit_event_received; 
	u->func_publish_event = unit_publish_event;
	
	u->func_msg_received = unit_msg_received;
	u->func_publish_msg = unit_publish_msg;
	
	u->event_table = eventqueue_table_create();
	
	/*
	PARSER_PTR p = slp_parser_create(u);
	char key[255];
	strcpy(key, "SLP");
	unit_addparser(u, key, p);
	unit_add_msglistener_parser(u, p);
 	u->current_parser = p;
	parser_add_evtlistener_unit(p, u);
	
	COMPOSER_PTR c = composer_create(u);
	char key1[255];
	strcpy(key1, "SLP");
	unit_addcomposer(u, key1, c);
	
	unit_add_evtlistener_composer(u, c);
 	u->current_composer = c;
	*/
	u->actions = extra_actions;
	unit_addaction_function1(u, "print_str", print_str);
	unit_addaction_function2(u, "print_evt", print_evt);
	unit_addaction_function3(u, "set_socket_and_composer", set_socket_and_composer);
	unit_addaction_function3(u, "set_socket_and_parser", set_socket_and_parser);
	unit_addaction_function5(u, "set_socket_composer_and_parser", set_socket_composer_and_parser);
	unit_addaction_function4(u, "unit_dispatch_evt_to_composers", unit_dispatch_evt_to_composers);
	unit_addaction_function4(u, "unit_dispatch_evt_to_listeners", unit_dispatch_evt_to_listeners);
	unit_addaction_function4(u, "unit_dispatch_evt_to_units", unit_dispatch_evt_to_units);
	unit_addaction_function4(u, "unit_dispatch_evt_to_unit_proxy", unit_dispatch_evt_to_unit_proxy);
	
	unit_addaction_function4(u, "sendDiscRequest", unit_send_disc_request);
	unit_addaction_function4(u, "sendDiscReply", unit_send_disc_reply);
	unit_addaction_function4(u, "sendCommRequest", unit_send_comm_request);
	unit_addaction_function4(u, "sendCommReply", unit_send_comm_reply);
	unit_addaction_function4(u, "createProxy", unit_create_proxy);
	unit_addaction_function6(u, "set_composerparser", set_composerparser);
	
	//FILE* file = fopen(sm_filename, "r");
	int file = open(sm_filename, O_RDWR );
	u->engine = engineCreate(file, u->actions, u);
	
	//fclose(file);
	close(file);
	

	return u;	
}


